from enum import IntEnum, Enum, auto


class RespawnReason(IntEnum):
    FreshStart = 0x0
    LoadSave = 0x1
    LoadToLocation = 0x2
    RestorePreviousSave = 0x3
    Unknown = 0x4
    DeathInSpace = 0x5
    DeathOnPlanet = 0x6
    DeathInOrbit = 0x7
    DeathOnAbandonedFreighter = 0x8
    WarpInShip = 0x9
    Teleport = 0xA
    Portal = 0xB
    UpgradeSaveAfterPatch = 0xC
    SwitchAmbientPlanet = 0xD
    BaseViewerMode = 0xE
    WarpInFreighter = 0xF
    JoinMultiplayer = 0x10


class StateEnum(str, Enum):
    TkFSMNoState = b"FSM_NOSTATE"
    ApplicationScratchpadState = b"SCRATCHPAD"
    ApplicationGameModeSelectorState = b"MODESELECTOR"
    ApplicationGalacticMapState = b"GALAXYMAP"
    ApplicationAmbientGameState = b"AMBIENT"
    ApplicationGlobalLoadState = b"APPGLOBALLOAD"
    ApplicationLocalLoadState = b"APPLOCALLOAD"
    ApplicationSimulationState = b"APPVIEW"
    ApplicationShutdownState = b"APPSHUTDOWN"
    ApplicationBootState = b"APPBOOT"
    ApplicationCoreServicesState = b"APPCORESERVICES"
    ApplicationDeathState_0 = b"YOUAREDEAD"


class GcInteractionType(IntEnum):
    _None = 0x0
    Shop = 0x1
    NPC = 0x2
    NPC_Secondary = 0x3
    NPC_Anomaly = 0x4
    NPC_Anomaly_Secondary = 0x5
    Ship = 0x6
    Outpost = 0x7
    SpaceStation = 0x8
    RadioTower = 0x9
    Monolith = 0xA
    Factory = 0xB
    AbandonedShip = 0xC
    Harvester = 0xD
    Observatory = 0xE
    TradingPost = 0xF
    DistressBeacon = 0x10
    Portal = 0x11
    Plaque = 0x12
    AtlasStation = 0x13
    AbandonedBuildings = 0x14
    WeaponTerminal = 0x15
    SuitTerminal = 0x16
    SignalScanner = 0x17
    Teleporter_Base = 0x18
    Teleporter_Station = 0x19
    ClaimBase = 0x1A
    NPC_Freighter_Captain = 0x1B
    NPC_HIRE_Weapons = 0x1C
    NPC_HIRE_Weapons_Wait = 0x1D
    NPC_HIRE_Farmer = 0x1E
    NPC_HIRE_Farmer_Wait = 0x1F
    NPC_HIRE_Builder = 0x20
    NPC_HIRE_Builder_Wait = 0x21
    NPC_HIRE_Vehicles = 0x22
    NPC_HIRE_Vehicles_Wait = 0x23
    MessageBeacon = 0x24
    NPC_HIRE_Scientist = 0x25
    NPC_HIRE_Scientist_Wait = 0x26
    NPC_Recruit = 0x27
    NPC_Freighter_Captain_Secondary = 0x28
    NPC_Recruit_Secondary = 0x29
    Vehicle = 0x2A
    MessageModule = 0x2B
    TechShop = 0x2C
    VehicleRaceStart = 0x2D
    BuildingShop = 0x2E
    MissionGiver = 0x2F
    HoloHub = 0x30
    HoloExplorer = 0x31
    HoloSceptic = 0x32
    HoloNoone = 0x33
    PortalRuneEntry = 0x34
    PortalActivate = 0x35
    CrashedFreighter = 0x36
    GraveInCave = 0x37
    GlitchyStoryBox = 0x38
    NetworkPlayer = 0x39
    NetworkMonument = 0x3A
    AnomalyComputer = 0x3B
    AtlasPlinth = 0x3C
    Epilogue = 0x3D
    GuildEnvoy = 0x3E
    ManageFleet = 0x3F
    ManageExpeditions = 0x40
    Frigate = 0x41
    CustomiseCharacter = 0x42
    CustomiseShip = 0x43
    CustomiseWeapon = 0x44
    CustomiseVehicle = 0x45
    ClaimBaseAnywhere = 0x46
    FleetNavigator = 0x47
    FleetCommandPost = 0x48
    StoryUtility = 0x49
    MPMissionGiver = 0x4A
    SpecialsShop = 0x4B
    WaterRuin = 0x4C
    LocationScanner = 0x4D
    ByteBeat = 0x4E
    NPC_CrashSite = 0x4F
    NPC_Scavenger = 0x50
    BaseGridPart = 0x51
    NPC_Freighter_Crew = 0x52
    NPC_Freighter_Crew_Owned = 0x53
    AbandonedShip_With_NPC = 0x54
    ShipPilot = 0x55
    NexusMilestones = 0x56
    NexusDailyMission = 0x57
    CreatureFeeder = 0x58
    ExoticExtra1 = 0x59
    ExoticExtra2 = 0x5A
    ExoticExtra3 = 0x5B
    ExoticExtra4 = 0x5C
    ExoticExtra5 = 0x5D
    ExoticExtra6 = 0x5E
    MapShop = 0x5F
    NPC_Closure = 0x60
    StorageContainer = 0x61
    Teleporter_Nexus = 0x62
    ShipSalvage = 0x63
    ByteBeatSwitch = 0x64
    AbandonedFreighterIntro = 0x65
    AbandonedFreighterEnd = 0x66
    AbandonedFreighterProcText = 0x67
    AbandonedFreighterCaptLog = 0x68
    AbandonedFreighterCrewLog = 0x69
    AbandonedFreighterShop = 0x6A
    CustomiseFreighter = 0x6B
    LibraryVault = 0x6C
    LibraryMainTerminal = 0x6D
    LibraryMap = 0x6E
    WeaponUpgrade = 0x6F
    Pet = 0x70
    Creature = 0x71
    FreighterGalacticMap = 0x72
    RecipeStation = 0x73
    StationCore = 0x74
    NPC_Settlement_SpecialWorker = 0x75
    NPC_Settlement_Secondary = 0x76
    SettlementHub = 0x77
    SettlementBuildingSite = 0x78
    SettlementAdminTerminal = 0x79
    FriendlyDrone = 0x7A
    DroneHive = 0x7B
    RocketLocker = 0x7C
    FrigateCaptain = 0x7D
    PirateShop = 0x7E
    NPC_PirateSecondary = 0x7F
    NPC_FreighterBase_SquadronPilot = 0x80
    NPC_FreighterBase_FrigateCaptain = 0x81
    NPC_FreighterBase_Worker = 0x82
    RobotHead = 0x83
    RobotCampTerminal = 0x84
    MonolithNub = 0x85
    NexusSpiderman = 0x86
    WeaponSalvage = 0x87
    DiscoverySelector = 0x88
    RobotShop = 0x89
    SeasonTerminal = 0x8A
    NPC_Freighter_Captain_Pirate = 0x8B
    SkiffLocker = 0x8C
    CustomiseSkiff = 0x8D
    ExhibitAssembly = 0x8E
    ArchiveMultitool = 0x8F
    BoneShop = 0x90


class GcDamageType(IntEnum):
    Gun = 0x0
    Laser = 0x1
    Shotgun = 0x2
    Burst = 0x3
    Rail = 0x4
    Cannon = 0x5
    Explosion = 0x6
    Melee = 0x7
    ShipGun = 0x8
    ShipLaser = 0x9
    ShipShotgun = 0xA
    ShipMinigun = 0xB
    ShipRockets = 0xC
    ShipPlasma = 0xD
    VehicleGun = 0xE
    VehicleLaser = 0xF
    SentinelLaser = 0x10
    PlayerDamage = 0x11
    PlayerWeapons = 0x12
    ShipWeapons = 0x13
    VehicleWeapons = 0x14
    CombatEffects = 0x15
    Fiend = 0x16
    FreighterLaser = 0x17
    FreighterTorpedo = 0x18


class GcStatsTypes(IntEnum):
    Unspecified = 0
    Weapon_Laser = auto()
    Weapon_Laser_Damage = auto()
    Weapon_Laser_Mining_Speed = auto()
    Weapon_Laser_HeatTime = auto()
    Weapon_Laser_Bounce = auto()
    Weapon_Laser_ReloadTime = auto()
    Weapon_Laser_Recoil = auto()
    Weapon_Laser_Drain = auto()
    Weapon_Laser_StrongLaser = auto()
    Weapon_Laser_ChargeTime = auto()
    Weapon_Laser_MiningBonus = auto()
    Weapon_Projectile = auto()
    Weapon_Projectile_Damage = auto()
    Weapon_Projectile_Range = auto()
    Weapon_Projectile_Rate = auto()
    Weapon_Projectile_ClipSize = auto()
    Weapon_Projectile_ReloadTime = auto()
    Weapon_Projectile_Recoil = auto()
    Weapon_Projectile_Bounce = auto()
    Weapon_Projectile_Homing = auto()
    Weapon_Projectile_Dispersion = auto()
    Weapon_Projectile_BulletsPerShot = auto()
    Weapon_Projectile_MinimumCharge = auto()
    Weapon_Projectile_MaximumCharge = auto()
    Weapon_Projectile_BurstCap = auto()
    Weapon_Projectile_BurstCooldown = auto()
    Weapon_ChargedProjectile = auto()
    Weapon_ChargedProjectile_ChargeTime = auto()
    Weapon_ChargedProjectile_CooldownDuration = auto()
    Weapon_ChargedProjectile_Drain = auto()
    Weapon_ChargedProjectile_ExtraSpeed = auto()
    Weapon_Rail = auto()
    Weapon_Shotgun = auto()
    Weapon_Burst = auto()
    Weapon_Flame = auto()
    Weapon_Cannon = auto()
    Weapon_Grenade = auto()
    Weapon_Grenade_Damage = auto()
    Weapon_Grenade_Radius = auto()
    Weapon_Grenade_Speed = auto()
    Weapon_Grenade_Bounce = auto()
    Weapon_Grenade_Homing = auto()
    Weapon_Grenade_Clusterbomb = auto()
    Weapon_TerrainEdit = auto()
    Weapon_SunLaser = auto()
    Weapon_SoulLaser = auto()
    Weapon_MineGrenade = auto()
    Weapon_FrontShield = auto()
    Weapon_Scope = auto()
    Weapon_Spawner = auto()
    Weapon_SpawnerAlt = auto()
    Weapon_Melee = auto()
    Weapon_StunGrenade = auto()
    Weapon_Stealth = auto()
    Weapon_Scan = auto()
    Weapon_Scan_Radius = auto()
    Weapon_Scan_Recharge_Time = auto()
    Weapon_Scan_Types = auto()
    Weapon_Scan_Binoculars = auto()
    Weapon_Scan_Discovery_Creature = auto()
    Weapon_Scan_Discovery_Flora = auto()
    Weapon_Scan_Discovery_Mineral = auto()
    Weapon_Scan_Secondary = auto()
    Weapon_Scan_Terrain_Resource = auto()
    Weapon_Scan_Surveying = auto()
    Weapon_Scan_BuilderReveal = auto()
    Weapon_Fish = auto()
    Weapon_Stun = auto()
    Weapon_Stun_Duration = auto()
    Weapon_Stun_Damage_Multiplier = auto()
    Weapon_FireDOT = auto()
    Weapon_FireDOT_Duration = auto()
    Weapon_FireDOT_DPS = auto()
    Weapon_FireDOT_Damage_Multiplier = auto()
    Suit_Armour_Health = auto()
    Suit_Armour_Shield = auto()
    Suit_Armour_Shield_Strength = auto()
    Suit_Energy = auto()
    Suit_Energy_Regen = auto()
    Suit_Protection = auto()
    Suit_Protection_Cold = auto()
    Suit_Protection_Heat = auto()
    Suit_Protection_Toxic = auto()
    Suit_Protection_Radiation = auto()
    Suit_Protection_Spook = auto()
    Suit_Protection_Pressure = auto()
    Suit_Underwater = auto()
    Suit_UnderwaterLifeSupport = auto()
    Suit_DamageReduce_Cold = auto()
    Suit_DamageReduce_Heat = auto()
    Suit_DamageReduce_Toxic = auto()
    Suit_DamageReduce_Radiation = auto()
    Suit_Protection_HeatDrain = auto()
    Suit_Protection_ColdDrain = auto()
    Suit_Protection_ToxDrain = auto()
    Suit_Protection_RadDrain = auto()
    Suit_Protection_WaterDrain = auto()
    Suit_Protection_SpookDrain = auto()
    Suit_Stamina_Strength = auto()
    Suit_Stamina_Speed = auto()
    Suit_Stamina_Recovery = auto()
    Suit_Jetpack = auto()
    Suit_Jetpack_Tank = auto()
    Suit_Jetpack_Drain = auto()
    Suit_Jetpack_Refill = auto()
    Suit_Jetpack_Ignition = auto()
    Suit_Jetpack_DoubleJump = auto()
    Suit_Jetpack_WaterEfficiency = auto()
    Suit_Jetpack_MidairRefill = auto()
    Suit_Refiner = auto()
    Suit_AutoTranslator = auto()
    Suit_Utility = auto()
    Suit_RocketLocker = auto()
    Suit_FishPlatform = auto()
    Suit_FoodUnit = auto()
    Suit_Denier = auto()
    Suit_Vehicle_Summon = auto()
    Ship_Weapons_Guns = auto()
    Ship_Weapons_Guns_Damage = auto()
    Ship_Weapons_Guns_Rate = auto()
    Ship_Weapons_Guns_HeatTime = auto()
    Ship_Weapons_Guns_CoolTime = auto()
    Ship_Weapons_Guns_Scale = auto()
    Ship_Weapons_Guns_BulletsPerShot = auto()
    Ship_Weapons_Guns_Dispersion = auto()
    Ship_Weapons_Guns_Range = auto()
    Ship_Weapons_Guns_Damage_Radius = auto()
    Ship_Weapons_Lasers = auto()
    Ship_Weapons_Lasers_Damage = auto()
    Ship_Weapons_Lasers_HeatTime = auto()
    Ship_Weapons_Missiles = auto()
    Ship_Weapons_Missiles_NumPerShot = auto()
    Ship_Weapons_Missiles_Speed = auto()
    Ship_Weapons_Missiles_Damage = auto()
    Ship_Weapons_Missiles_Size = auto()
    Ship_Weapons_Shotgun = auto()
    Ship_Weapons_MiniGun = auto()
    Ship_Weapons_Plasma = auto()
    Ship_Weapons_Rockets = auto()
    Ship_Weapons_ShieldLeech = auto()
    Ship_Armour_Shield = auto()
    Ship_Armour_Shield_Strength = auto()
    Ship_Armour_Health = auto()
    Ship_Scan = auto()
    Ship_Scan_EconomyFilter = auto()
    Ship_Scan_ConflictFilter = auto()
    Ship_Hyperdrive = auto()
    Ship_Hyperdrive_JumpDistance = auto()
    Ship_Hyperdrive_JumpsPerCell = auto()
    Ship_Hyperdrive_QuickWarp = auto()
    Ship_Launcher = auto()
    Ship_Launcher_TakeOffCost = auto()
    Ship_Launcher_AutoCharge = auto()
    Ship_PulseDrive = auto()
    Ship_PulseDrive_MiniJumpFuelSpending = auto()
    Ship_PulseDrive_MiniJumpSpeed = auto()
    Ship_Boost = auto()
    Ship_Maneuverability = auto()
    Ship_BoostManeuverability = auto()
    Ship_LifeSupport = auto()
    Ship_Drift = auto()
    Ship_Teleport = auto()
    Ship_CargoShield = auto()
    Ship_WaterLandingJet = auto()
    Freighter_Hyperdrive = auto()
    Freighter_Hyperdrive_JumpDistance = auto()
    Freighter_Hyperdrive_JumpsPerCell = auto()
    Freighter_MegaWarp = auto()
    Freighter_Teleport = auto()
    Freighter_Fleet_Boost = auto()
    Freighter_Fleet_Speed = auto()
    Freighter_Fleet_Fuel = auto()
    Freighter_Fleet_Combat = auto()
    Freighter_Fleet_Trade = auto()
    Freighter_Fleet_Explore = auto()
    Freighter_Fleet_Mine = auto()
    Vehicle_Boost = auto()
    Vehicle_Engine = auto()
    Vehicle_Scan = auto()
    Vehicle_EngineFuelUse = auto()
    Vehicle_EngineTopSpeed = auto()
    Vehicle_BoostSpeed = auto()
    Vehicle_BoostTanks = auto()
    Vehicle_Grip = auto()
    Vehicle_SkidGrip = auto()
    Vehicle_SubBoostSpeed = auto()
    Vehicle_Laser = auto()
    Vehicle_LaserDamage = auto()
    Vehicle_LaserHeatTime = auto()
    Vehicle_LaserStrongLaser = auto()
    Vehicle_Gun = auto()
    Vehicle_GunDamage = auto()
    Vehicle_GunHeatTime = auto()
    Vehicle_GunRate = auto()
    Vehicle_StunGun = auto()
    Vehicle_TerrainEdit = auto()
    Vehicle_FuelRegen = auto()
    Vehicle_AutoPilot = auto()
    Vehicle_Flame = auto()
    Vehicle_FlameDamage = auto()
    Vehicle_FlameHeatTime = auto()
    Vehicle_Refiner = auto()


class GcAudioWwiseEvents(IntEnum):
    INVALID_EVENT = 0x0
    ABANDONED_DOOR_UNLOCK = 0x264BED2D
    ABANDONED_FIEND_IDLE = 0x187DE821
    ABANDONED_FIEND_ROAR = 0xD6403FEF
    ABANDONED_FIEND_RUN = 0xF4780FEE
    ABANDONED_FIEND_SPIT = 0x81754059
    ABANDONED_FIEND_WALK = 0xC8910DD0
    ABANDONED_JELLYFISH_DEATH = 0x439E085F
    ABANDONED_JELLYFISH_SWIM = 0x4DD7469F
    AF_CAPSULE = 0x4CDD3358
    AF_DOOR_PRESSURISING = 0x24E7DF92
    AF_DOOR_PRESSURISING1 = 0xAB04F2E7
    AF_DOOR_PRESSURISING2 = 0xAB04F2E4
    AF_DOOR_PRESSURISING3 = 0xAB04F2E5
    AF_EXPLODINGCAPSULE = 0x5F8A1444
    AF_FAN = 0xA5F03712
    AF_ROTATINGDEVICE = 0x9BBD3FD5
    AMB_ABANDONEDBUILDING = 0x4C987896
    AMB_ABANDONEDBUILDING_STOP = 0xA891AC5
    AMB_ANCIENTGUARDIAN = 0xAED37253
    AMB_BLACKHOLE = 0x7A8710CD
    AMB_BUILDING_START = 0x143EDD47
    AMB_BUILDING_STOP = 0x5CE58FED
    AMB_FREIGHTER_INTERNAL = 0x5F322152
    AMB_FRIGATE = 0xC397F586
    AMB_NEBULA_STORM = 0x9B1672B5
    AMB_NEXUS = 0xB15F1A93
    AMB_PLANET_ALL = 0xB0FEDFC0
    AMB_PLANET_ALL_STOP = 0x870A61EF
    AMB_RAIN_SURFACE = 0xD5115048
    AMB_RAIN_SURFACE_STOP = 0x31243A67
    AMB_SETTLEMENT_HUB = 0x297F17E3
    AMB_SPACESTATION_HANGER = 0xEC3F2892
    AMB_WEATHER_THUNDER = 0xEA8B35F9
    AMB_WEATHER_THUNDER_STOP = 0x7A68768C
    AMBIENT_EMPHASISER = 0x62B568C5
    ANIMATEDDOOR_CLOSE = 0xD135F2D3
    ANIMATEDDOOR_OPEN = 0x93B90D65
    ANOMALY_CORE = 0x95FDDC1A
    ANOMALY_DOOR_CLOSE = 0xE7C7565A
    ANOMALY_DOOR_OPEN = 0xF376E95E
    ANOMALY_MAINAIRLOCK_CLOSE = 0x97933C38
    ANOMALY_MAINAIRLOCK_OPEN = 0x7A31D97C
    ANOMALY_SIMULATION_CONSOLE_END = 0xC89FD926
    ANOMALY_SIMULATION_CONSOLE_FLASH = 0x4D525F5B
    ANOMALY_SIMULATION_CONSOLE_START = 0x226E710D
    ANOMALY_SIMULATION_LIGHTSOFF = 0x5C36AC25
    ANOMALY_SIMULATION_LIGHTSON = 0x32B01899
    ANOMALY_SIMULATION_REVEAL_OPEN = 0xAF06F8C5
    ANOMALY_SIMULATION_TERMINAL_DIE = 0xD6AD5022
    ANOMALY_WEAPONCRATE_CLOSE = 0xE35624E5
    ANOMALY_WEAPONCRATE_OPEN = 0x8A1736EF
    ANTATTACK2 = 0x5BCBDC96
    ANTELOPE2LEGPOUNCE1 = 0x26DF7660
    ANTELOPEATTACK3 = 0xD81B03CA
    ANTELOPEROAR = 0xCB03FA5B
    ANTELOPESHAKE = 0x60DF35B
    ANTELOPETWOLEGATTACK = 0xF74CC245
    ANTELOPETWOLEGATTACK2 = 0x92D5D2AD
    ANTELOPETWOLEGATTACK3 = 0x92D5D2AC
    ANTELOPETWOLEGPOUNCE2 = 0x633AFD2F
    ANTELOPETWOLEGPOUNCE3 = 0x633AFD2E
    ANTELOPETWOLEGROAR = 0xA2B4EF51
    ANTELOPETWOPERFORM = 0x1627CCF6
    ANTPOUNCE1 = 0x2DD423DB
    ANTPOUNCE02 = 0xFEF4701C
    ANTPOUNCE03 = 0xFEF4701D
    ARTHROPOD_ATTACK01 = 0xBEEF8EA0
    ARTHROPOD_EAT = 0x84FB32FD
    ARTHROPOD_POUNCE = 0x6CC98D93
    ARTHROPOD_QUEEN_ATTACK01 = 0xD1C4F58D
    ARTHROPOD_QUEEN_BIRTHING = 0x8FF2DCC5
    ARTHROPOD_QUEEN_BOUNCE = 0x5094F4D0
    ARTHROPOD_QUEEN_EAT = 0x891AA586
    ARTHROPOD_QUEEN_GROUNDAPPEAR = 0xFFAAAEDA
    ARTHROPOD_QUEEN_POUNCE01 = 0xACDB5EDF
    ARTHROPOD_QUEEN_ROAR = 0x32B5FCF4
    ARTHROPOD_QUEEN_SPIT = 0xC97180DA
    ASTEROID_EXPLODE = 0xF91DD0FC
    ASTEROID_HIT = 0xFE51061C
    ATLAS_ARCH = 0xA4494F25
    ATLAS_BALLOFLIGHT = 0x9E3D0CB
    ATLAS_CORE = 0xBC1CE2F8
    ATLAS_CORE_ACTIVATE = 0x916A8160
    ATLAS_CORE_INTERACT = 0x4734CC65
    ATLAS_GALAXY_SPIN_LP = 0x68977FD7
    ATLAS_GALAXYBEAM = 0xC5B56B54
    ATLAS_GALAXYSTART_MULTIPLE = 0xA3DFC892
    ATLAS_GALAXYSTART_SINGLE = 0x1D6B1966
    ATLAS_INTERFACE_GALAXY_SPIN = 0xC1D86B30
    ATLAS_INTERFACE_TRIGGER = 0xFCA6F003
    ATLAS_ORB_FLARE = 0xA3217125
    ATLAS_ORB_ILLUMINATE = 0x1736FCDD
    ATLAS_PLINTH_RISE = 0x8464FB10
    ATLAS_SEED_01 = 0x82B25AB8
    ATLAS_SEED_02 = 0x82B25ABB
    ATLAS_SEED_03 = 0x82B25ABA
    ATLAS_SEED_04 = 0x82B25ABD
    ATLAS_SEED_05 = 0x82B25ABC
    ATLAS_SPHERE_PULSE = 0x6F545734
    ATLAS_SPHERE_SPARK = 0xC0F94248
    ATLAS_SPHERE_WIND = 0x59F53DC7
    ATLAS_VANISH = 0x1DBBF4C
    ATLASCORRUPTED_LP = 0x41327075
    ATLASCORRUPTED_LP_STOP = 0x276E5E18
    ATLASCORRUPTED_START = 0xEBCD5933
    ATLASINTERACT_CLOSE = 0xFAED1D89
    ATLASINTERACT_OPEN = 0xFFC5D75B
    ATLASSTARTSCENEORB_ACTIVATE = 0x3F60B597
    ATLASSTARTSCENEORB_ACTIVATEIDLE = 0x10DCFBD1
    ATLASSTARTSCENEORB_DISMISS = 0x3F5AD170
    ATLASSTARTSCENEORB_END = 0x4855A843
    ATLASSTARTSCENEORB_IDLE = 0x4123CCDA
    BASE_AQUARIUM = 0x4A30FB0
    BASE_BATTERY_CHARGING = 0x7C13B3BA
    BASE_BATTERY_DISCHARGING = 0x230E6054
    BASE_BATTERY_FULLYCHARGED = 0x36F5BDDF
    BASE_BATTERY_FULLYDISCHARGED = 0xC50227AD
    BASE_BIOFUELCHARGED = 0xE43B51CF
    BASE_BIOFUELDISCHARGED = 0xDF54E5D
    BASE_BIOFUELRUNNING = 0xBE89F34E
    BASE_CALCISHROOM = 0xDFC60F7F
    BASE_CUBEGADGET = 0x35F1697A
    BASE_CYCLONIC_LATHE = 0xEC4E25A8
    BASE_DOOR_CLOSE = 0xF5C07B4C
    BASE_DOOR_OPEN = 0xAB8E00D8
    BASE_ELECTRICALWIRING_DELETE = 0x94811EC9
    BASE_ELECTRICALWIRING_PLACE = 0x1D81BC71
    BASE_ELECTRICCUBE = 0x78527FE3
    BASE_FORCEFIELD_DOOR = 0xCEB18629
    BASE_GARAGE_DOOR_CLOSE = 0x3935565C
    BASE_GARAGE_DOOR_OPEN = 0x1B8E3148
    BASE_GASEXTRACTOR = 0x6F563648
    BASE_GASEXTRACTOR_OFF = 0x6270A7CE
    BASE_LARGEMONITORSTATION = 0x1B3F5918
    BASE_LIGHTBOX = 0xDA4C4B9A
    BASE_MINERALEXTRACTOR = 0x44AD4073
    BASE_MINERALEXTRACTOR_OFF = 0x1CB23CA5
    BASE_MONITORSTATION = 0x703BBA57
    BASE_OSCILLOSCOPE = 0x8603C216
    BASE_PIPE_DELETE = 0x987092CD
    BASE_PIPE_PLACE = 0x280CACAD
    BASE_POCKETREALITYGENERATOR = 0x95D9B358
    BASE_POWER_CONNECT = 0xA8DC0783
    BASE_POWER_OFF = 0x9E862FCE
    BASE_POWER_ON = 0x72477AB0
    BASE_POWER_POWERDOWN = 0xB0EC3B5A
    BASE_POWER_POWERUP = 0x6627C5F9
    BASE_POWER_SWITCH_OFF = 0x6BD0C41D
    BASE_POWER_SWITCH_ON = 0xED8BA271
    BASE_POWERFLOW_OFF = 0xB0E54966
    BASE_POWERFLOW_ON = 0x7E373308
    BASE_SERVER = 0x6DD9D114
    BASE_SOL_CLOSE = 0x9AA926CC
    BASE_SOL_OPEN = 0x53FBD758
    BASE_SOLARPANEL_CLOSE = 0xCF003B2B
    BASE_SOLARPANEL_OPEN = 0xF241066D
    BASE_SPHERECREATE = 0x304F20F2
    BASE_SPHEREROLL = 0x5D2DB27F
    BASEBEACON = 0xA2D231B2
    BASEBUILD_ITEM_BEACON = 0xE011D583
    BASEBUILD_ITEM_COMMUNICATIONSSTATION = 0x91C32F14
    BASEBUILD_ITEM_COMMUNICATIONSSTATION_ACCEPT = 0xFF644EEF
    BASEBUILD_ITEM_COMMUNICATIONSSTATION_CANCEL = 0x1855CDED
    BASEBUILD_ITEM_CONSTRUCTIONTERMINAL = 0x5FF59BA4
    BASEBUILD_ITEM_PLANTINCUBATOR = 0xED58F63F
    BASEBUILD_ITEM_SCIENCETERMINAL = 0x99231F73
    BASEBUILD_ITEM_SIGNALBOOSTER_LOOP = 0xF746FF22
    BASEBUILD_ITEM_SIGNALBOOSTER_START = 0xDD70498C
    BASEBUILD_ITEM_TERMINALGENERIC = 0xC8E2F31A
    BASEBUILD_ITEM_WEAPONTERMINAL = 0xB15A99B7
    BASESHOP_OPEN = 0xC0D6FE45
    BASETERMINAL = 0x71FD32FE
    BEACON_TRIGGER_START = 0x9B8CB96D
    BEACON_TRIGGER_STOP = 0x819AACAF
    BEAMSTONE = 0x8EC94FFF
    BEETLE_FLY = 0xB990B31A
    BEETLE_WALK = 0x8AD063BC
    BINOCULARS_ENTER = 0x9FD4BC6C
    BINOCULARS_EXIT = 0x3EEB7CAE
    BINOCULARS_ZOOM01 = 0xBCD75A
    BINOCULARS_ZOOM02 = 0xBCD759
    BINOCULARS_ZOOM03 = 0xBCD758
    BLACKHOLE_WARP = 0x4F9D6EE1
    BLD_ALARM_LP = 0x2CC0151E
    BLD_ALARM_LP_STOP = 0x42B994FD
    BLD_AMB_ATM = 0x16C1B9A5
    BLD_AMB_DEBRISLARGE = 0xFC66BDC7
    BLD_AMB_DEPOTS = 0x793F92E
    BLD_AMB_DEPOTS_STOP = 0x6A9C012D
    BLD_BLACKBOX_OPEN = 0x3BBECA3F
    BLD_DAMAGEDMACH_BEAM = 0xE5821724
    BLD_DEBRISLARGE_OPEN = 0x6829FAA1
    BLD_DMG_MACH_POD_LP = 0x5035727B
    BLD_DOOR_EXPLODE = 0x801AE19A
    BLD_HOLOGRAM_APPEAR = 0x62AE0EA3
    BLD_LIGHTS = 0x1892FE37
    BLD_POD_DOOR_CLOSE = 0xA2DC6005
    BLD_POD_DOOR_OPEN = 0x4C4F68F
    BLD_POD_SHUTDOWN = 0x6FD14262
    BLD_POD_STARTUP = 0x5C4B561F
    BLD_RUIN_MONOLITH = 0x1EDC03C1
    BLD_RUIN_PLAQUE = 0x5D206C15
    BLD_SC_FACT_INT = 0xBB08AD3D
    BLD_SC_OBS_IN = 0xB504D119
    BLD_SCIENTIFIC_DOOR_CLOSE = 0x40961F37
    BLD_SCIENTIFIC_DOOR_OPEN = 0xE8572281
    BLD_SCIENTIFIC_FACTORY_ROOF = 0x47BC05
    BLD_SCIENTIFIC_PISTON = 0x2FEB96E5
    BLD_SCIENTIFIC_WINDOW_CLOSE = 0x1DEC7157
    BLD_SCIENTIFIC_WINDOW_OPEN = 0x1B615F21
    BLD_SERVER = 0x933C9559
    BLD_TONEINT_GENERIC_01 = 0x207AA53D
    BLD_TONEINT_GENERIC_02 = 0x207AA53E
    BLD_TONEINT_GENERIC_03 = 0x207AA53F
    BLD_TONEINT_GENERIC_04 = 0x207AA538
    BLD_TONEINT_GENERIC_05 = 0x207AA539
    BLD_TONEINT_GENERIC_06 = 0x207AA53A
    BLD_TONEINT_GENERIC_07 = 0x207AA53B
    BLD_TONEINT_GENERIC_08 = 0x207AA534
    BLD_TONEINT_GENERIC_09 = 0x207AA535
    BLD_TONEINT_GENERIC_10 = 0x217AA6AF
    BLD_TONEINT_GENERIC_11 = 0x217AA6AE
    BLD_TONEINT_GENERIC_12 = 0x217AA6AD
    BLD_TONEINT_GENERIC_13 = 0x217AA6AC
    BLD_TONEINT_GENERIC_14 = 0x217AA6AB
    BLD_TONEINT_GENERIC_15 = 0x217AA6AA
    BLD_TONEINT_GENERIC_16 = 0x217AA6A9
    BLD_TONEINT_GENERIC_17 = 0x217AA6A8
    BLD_TONEINT_GENERIC_18 = 0x217AA6A7
    BLD_TONEINT_HANGER_START_01 = 0xCF108C8
    BLD_TONEINT_HANGER_STOP_01 = 0x74461F80
    BLD_TR_HAR_INT = 0x3C3CB2A0
    BLD_TRADER_DOOR_CLOSE = 0xE74FE36
    BLD_TRADER_DOOR_OPEN = 0xA876DCE2
    BLD_TRADER_FACTORY_ROOF = 0xDD99760
    BLD_TRADER_RADIOTOWEREFFECT = 0xDA81C2AC
    BLD_WARRIOR_DOOR_CLOSE = 0x42737C4C
    BLD_WARRIOR_DOOR_OPEN = 0x44339BD8
    BLD_WARRIOR_FACTORY_ROOF = 0x33B9723E
    BLD_WARRIOR_ROOF_OBS = 0x79E2A24
    BLD_WARRIOR_SATELLITE = 0x9D2AD184
    BLD_WARRIOR_WALLEX_CAP = 0x2F73E8B3
    BLD_WORDSTATION = 0x5EADD344
    BLOB_TERRARIUM = 0x836231DE
    BLOBATTACK = 0xF73A93BC
    BLOBATTACK2 = 0xED3690C6
    BLOBATTACK3 = 0xED3690C7
    BLOBROAR = 0x743C03A4
    BRIDGETERMINAL_CLOSE = 0xC3D36AE3
    BRIDGETERMINAL_OPEN = 0xA26E57D5
    BRIDGETERMINALSCREEN = 0xB7549556
    BUGFIEND_ATTACK01 = 0x531CBC05
    BUGFIEND_EAT = 0x933FE89E
    BUGFIEND_GROUNDAPPEAR = 0x950EAFA2
    BUGFIEND_PAIN01 = 0x932BD321
    BUGFIEND_POUNCE01 = 0x7573DD67
    BUGFIEND_SPIT = 0xA79F6A92
    BUGFIEND_STUNNED = 0x47D1F241
    BUGGY_BOOST_START = 0xA8AD0530
    BUGGY_BOOST_STOP = 0x5998369C
    BUGGY_HORN_START = 0xF277A3F6
    BUGGY_HORN_STOP = 0x19167876
    BUGGY_IDLE_EXTERIOR = 0x6F5E01BB
    BUGGY_IMPACTS = 0x7A3FF7D1
    BUGGY_JUMP = 0x40AED174
    BUGGY_START = 0x574EA9C4
    BUGGY_STOP = 0x9AF38178
    BUGGY_SUSPENSION = 0x9979BE53
    BURNING_BARREL = 0xF24D4A35
    BUTTERFLY = 0xD410A32
    BYTEBEAT = 0x3DB63CCF
    BYTEBEAT_BAR = 0x8EEE3065
    BYTEBEAT_BAR_STOP = 0x4B3267A8
    BYTEBEAT_PLAYER = 0x1DF2F9B5
    BYTEBEAT_STOP = 0x932527FA
    CAPSULE_COLLECT = 0xBC55E8B1
    CAPSULE_PANEL_OPEN = 0xE95C7888
    CATALTATTACK = 0x9AD42B64
    CATALTATTACK2 = 0x20004E5E
    CATALTATTACK3 = 0x20004E5F
    CATALTHAPPY = 0x6179CA9A
    CATALTPERFORM01 = 0x2FF4EBE6
    CATALTROAR = 0x93C693EC
    CATATTACK1 = 0x49AFA08
    CATATTACK2 = 0x49AFA0B
    CATATTACK3 = 0x49AFA0A
    CATLARGEATTACK = 0xAC68C044
    CATPERFORM01 = 0x74F5CCB3
    CATPOUNCE = 0x23978AD9
    CATROAR = 0x8D40571B
    CHARACTEREDITOR_SELECT = 0xE22A1DC0
    CHARACTEREDITOR_WOOSH = 0x1B532920
    CHAT = 0xF6C8069B
    CLAMCLOSE = 0x9E33F27A
    CLAMOPEN = 0x9D20C9FE
    CLAMSHELL_IDLE = 0x896C2B0D
    CLAMSHELL_OPEN = 0x3F0E2BF
    COLLECTABLE_RECEIVED = 0xC266F931
    COMMS_CHATTER_FREIGHTER = 0xDFEA2C37
    COMMS_CHATTER_PIRATES_AMBIENT = 0x48838B34
    COMMS_CHATTER_PIRATES_HIT = 0x81CCB593
    COMMS_CHATTER_POLICE = 0xD547E7BB
    COMMS_CHATTER_POLICE_HIT = 0x40407039
    COMMS_CHATTER_STOP_ALL = 0x50409A1D
    COMMUNICATOR_CLOSE = 0x2D2D0DB1
    COMMUNICATOR_HAIL = 0x7B52749D
    COMMUNICATOR_OPEN = 0x41B5F833
    COMPUTER_TEXT = 0x2F2F62DC
    COMPUTER_TEXT_STOP = 0xFE197CAB
    COMPUTER_TEXT_TYPE = 0x28D3F683
    COMPUTER_TEXT_TYPE_STOP = 0xE271EAEE
    COOKER_CLOSE = 0xDE567DC9
    COOKER_COOKING = 0x1409D575
    COOKER_END = 0xF9F58DD6
    COOKER_OPEN = 0xC703639B
    CORETERMINAL_COLLECTDATA = 0x5A8D1FF
    CORRUPTED_PILLAR = 0xF8AD68FE
    CORRUPTED_PILLAR_FR0 = 0x230ADD5B
    CORRUPTED_PILLAR_FR226 = 0x8BA349BD
    CORRUPTEDQUAD_AMBIENT_TONE = 0x4736C7DE
    CORRUPTEDQUAD_DIE = 0xA7E3590D
    CORRUPTEDQUAD_EMOTE_LP = 0xB11C2646
    CORRUPTEDQUAD_EMOTE_LP_STOP = 0x9E7EA915
    CORRUPTEDQUAD_EVADE = 0xC54605A8
    CORRUPTEDQUAD_POUNCE = 0x760FEF17
    CORRUPTEDQUAD_POUNCEBACK = 0xA18C6526
    CORRUPTEDQUAD_STUNNED = 0x71BCF6C2
    CORRUPTMONOLITH_BASE = 0xEE3CFFE4
    CORRUPTMONOLITH_BURST = 0xE30F0A57
    CORRUPTMONOLITH_CLOSE = 0x62AB0D15
    CORRUPTMONOLITH_SPARK = 0x5B7D7DAA
    COWATTACK1 = 0xF26FF8FF
    COWATTACK2 = 0xF26FF8FC
    COWATTACK2HIND = 0xFED92B2F
    COWATTACK3 = 0xF26FF8FD
    COWATTACK3HIND = 0x9C8C20B2
    COWATTACKHIND = 0x2E946A79
    COWFLOATHAPPY = 0xBE89AD0A
    COWFLOATSAD = 0x31FB447C
    COWHAPPYHIND = 0xD48DDDFF
    COWHINDPERFORM01 = 0xD64E7029
    COWHINDROAR01 = 0x2197E780
    COWPERFORM01 = 0xA1E54730
    COWPOUNCE1 = 0x31C0A479
    COWROAR = 0xE2F1E4D6
    CRASHED_FREIGHTER = 0xA672C68C
    CRATE_WEAPON = 0x144B7049
    CRATE_WEAPON_CLOSE = 0x7ACC6D60
    CRATELOCKOPEN = 0xF7DED48F
    CRATEM_OPEN = 0xB602DA46
    CREATURE_BITE = 0xA83D7AAB
    CREATURE_JUMPSWIPE = 0xC4B64355
    CREATURE_POOP = 0x57FC4B17
    CREATURE_ROAR = 0x58EB908D
    CREATURE_STEP_BLOB = 0x8A27FDBB
    CREATURE_STEP_BLOB_WALK = 0x707CF181
    CREATURE_STEPS = 0x2A6F6752
    CREATURE_SWIPE = 0x64797DF9
    CREATURE_VOCALS_SQUAWK_AGGRESSION = 0x75F5A46D
    CREATURE_VOCALS_SQUAWK_ATTACK = 0x23D5A471
    CREATURE_VOCALS_SQUAWK_DIE = 0x395F9689
    CREATURE_VOCALS_SQUAWK_FLEE = 0xEF169B9
    CREATURE_VOCALS_SQUAWK_IDLE = 0x6DCF4D8B
    CREATURE_VOCALS_SQUAWK_PAIN = 0x6C8842D5
    CREATURE_VOCALS_SQUAWK_ROAR = 0x80D02225
    CREATURE_VOCALS_SQUAWK_ROAR_ANGRY = 0x4FF9BF6F
    CREATURE_VOCALS_SQUAWK_ROAR_HAPPY = 0x925E724A
    CREATURE_VOCALS_SQUAWK_ROAR_NEUTRAL = 0xA8E86F75
    CREATURE_VOCALS_SQUAWK_SNORE = 0x8DFE9A1A
    CRT_BIRD_FLAP = 0x361B8FB6
    CRT_COW_WINGFLAP = 0x6B97E021
    CRT_GRUNT_WINGFLAPRUN = 0x7B6E923
    CRT_GRUNT_WINGFLAPWALK = 0x1E4355FF
    CRYOCHAMBER = 0xCDD3E924
    CRYOCHAMBER_CLOSE = 0x2ADCB15D
    CRYSTAL_RARE_EXPLODE = 0xA0786AA6
    CRYSTAL_RARE_LP = 0x86DDA9C7
    CRYSTALALTAR_COLLECT = 0x441AEFA0
    CRYSTALALTAR_LOOP = 0xE2EAC53C
    CUSTOMISE_ACTIVATE = 0xE1CCDB77
    CUSTOMISE_END = 0x734712A3
    CUSTOMISE_IDLE = 0x38B3D8BA
    DEATH_DAMAGE = 0x617076E7
    DEATH_DAMAGE_REBUILD = 0x30258C33
    DEATHMARKER_PULSE = 0x57F9C699
    DEATHMARKER_TRANSFORM = 0x651ED76
    DEATHSHOUT = 0xEBA2C6C4
    DISCOVER_PLANET = 0x721715FD
    DISCOVERY_UPLOADED = 0xF8D5FE88
    DOOR_BROKEN_SPARKS = 0xA5397178
    DRAGONFLY = 0xB48AC47B
    DRAGONFLY_BOOST_START = 0xC7ADCCAE
    DRAGONFLY_BOOST_STOP = 0xD7CF88E
    DRAGONFLY_HORN_START = 0xC06C8F4
    DRAGONFLY_HORN_STOP = 0xC55D6968
    DRAGONFLY_IDLE_EXTERIOR = 0x81E3589D
    DRAGONFLY_IMPACTS = 0xA58ADC43
    DRAGONFLY_JUMP = 0xD07A3EA6
    DRAGONFLY_START = 0xED4829D6
    DRAGONFLY_STOP = 0xB4782DD6
    DRAGONFLY_SUSPENSION = 0x6F051BC9
    DRILL_IN = 0x87E6EB8A
    DRILL_LP = 0x84E6E75B
    DRILL_LP_STOP = 0x5A24BEF6
    DRILL_OUT = 0x958077E5
    DRONE_ALERT = 0x7A84D746
    DRONE_ARMOURED_BRACE = 0x5A7DE16F
    DRONE_ARMOURED_UNBRACE = 0xD65D31C4
    DRONE_ATTACK = 0x234F1F00
    DRONE_ATTACK_STOP = 0xA6B07F2F
    DRONE_DEBRIS = 0x3CCD53D1
    DRONE_DIE = 0x772B483E
    DRONE_EMOTE_LP = 0xD5FDCCDF
    DRONE_EMOTE_LP_STOP = 0xBC9CA56A
    DRONE_EMOTE_ONESHOT = 0x6890081
    DRONE_ENGINE = 0x7F0625AA
    DRONE_ENGINE_CORRUPTED = 0xA1D3CD87
    DRONE_FRIENDLY_COMBAT = 0xE1F7777C
    DRONE_FRIENDLY_COMBAT_STOP = 0x7A6EDC0B
    DRONE_FRIENDLY_DEVICE_OFF = 0xEE5687A8
    DRONE_FRIENDLY_DEVICE_ON = 0xB1FEF1B2
    DRONE_FRIENDLY_SUMMONED = 0x3FFEDE7A
    DRONE_FRIENDLY_UNSUMMONED = 0xC39240FB
    DRONE_FRIENDLY_WANTED = 0x30684DA9
    DRONE_FRIENDLY_WANTED_END = 0xA3274B4B
    DRONE_INVESTIGATING = 0x1B83BC48
    DRONE_LASER = 0x9DF60645
    DRONE_MEDIC_ATTACK = 0xF6B0A69
    DRONE_MEDIC_DISENGAGE = 0x45F4D79A
    DRONE_MEDIC_ENGAGE = 0x28DE13F8
    DRONE_MEDIC_FIX = 0xB63AAB4A
    DRONE_MEDIC_IDLE = 0x5D87B953
    DRONE_RECHARGE = 0xACC011B
    DRONE_SCAN_START = 0xD4DA690A
    DRONE_SCAN_STOP = 0x410B5462
    DRONE_SEARCHING = 0x6EC52C40
    DRONE_SHIELD_ACTIVATE = 0x3530F375
    DRONE_SHIELD_DEACTIVATE = 0xAABD2664
    DRONE_SHIELD_GLITCH = 0x8FE1B631
    DRONE_SUMMONER_ALARM = 0xF1CE63E2
    DRONE_SUMMONER_SIGNAL = 0xE67CDB17
    DRONE_SUMMONER_UNSIGNAL = 0x58AEE782
    DRONE_SUSPICIOUS = 0xB6CE0AD5
    E3_ZOOMIN = 0xBE030510
    E3_ZOOMOUT = 0x15C6E177
    EGG_MACHINE_AMBIENT_LP = 0x7BE7B7BA
    EGG_MACHINE_CLOSE = 0x6B395F97
    EGG_MACHINE_COOK = 0xBAB81BD1
    EGG_MACHINE_FINISH = 0xD5B01638
    EGG_MACHINE_OPEN = 0x955F5B61
    EGG_MACHINE_START = 0x97160567
    EGGOPENS = 0x9058C8F7
    EGGRESOURCE_COLLECT = 0x5D44C34B
    ENGINEREACTOR_OFF_IDLE = 0xF322160A
    EQUIP_DAMAGED = 0xF56C53BB
    EXOCRAFT_SUMMONING_STATION = 0x29EF00E2
    EXPL_DEPOT = 0x14D13D39
    EXPL_ELECTRICAL_STUN = 0xCEDE2742
    EXPL_ELECTRICAL_STUN_STOP = 0x50AC08C1
    EXPL_FIREWORK = 0xC78B45E
    EXPL_FIREWORK_LAUNCH = 0x203840E0
    EXPL_FIREWORK_LAUNCH_SLIME = 0x37F4611
    EXPL_FIREWORK_SLIME = 0xD86955AF
    EXPL_FIREWORK_TAIL = 0xAF543557
    EXPL_FIREWORK_TAIL_SLIME = 0x6665BA8A
    EXPL_FREIGHTER = 0x38C32017
    EXPL_FREIGHTER_BUILDUP = 0xCD0A69F9
    EXPL_FREIGHTER_CONTAINER_LARGE = 0x98E3FACB
    EXPL_FREIGHTER_CONTAINER_SMALL = 0x8ED7A637
    EXPL_FREIGHTER_ONE_SHOTS = 0x39897238
    EXPL_FREIGHTER_ROD = 0xFE15D955
    EXPL_NEWSTARSYSTEM = 0xD468363A
    EXPL_ROCK = 0xB5CC968E
    EXPL_SHIELD_GENERATOR = 0xA6A5B3D4
    EXPL_SHIP_SMALL = 0x2D0884BB
    EXPL_SHIPS_LARGE = 0xBB5CA45A
    EXPL_SHIPS_MED = 0x618DEA29
    EXPL_SHIPS_SMALL = 0xB8D9B746
    EXPL_SMALL_SPACE_GENERIC = 0xC7DD7E03
    EXPL_SPACE_MEMORYBOAT = 0xC7026C2B
    EXPL_TORPEDO = 0x75651EF2
    EXPLODINGBARREL = 0xA7AE41A9
    EXPLORERANGRYIPAD = 0xB1BD172B
    EXPLORERCHATTER = 0xE1C4E07B
    EXPLORERHAPPYIPAD = 0xC786698E
    EXPLORERHAPPYIPAD2 = 0xA6982AB8
    EXPLORERHAPPYIPAD3 = 0xA6982AB9
    EXPLORERIPADGREET = 0xC03F5D47
    EXPLORERIPADGREET2 = 0xEABFD6F7
    EXPLORERIPADGREET3 = 0xEABFD6F6
    EXPLORERIPADGREET4 = 0xEABFD6F1
    EXPLORERNEUTRALIPAD = 0x87AE24B1
    EXPLOSION_RESOURCE_GATHER = 0x42613325
    EYESTALK = 0x33AF58C1
    FEEDERDISPENSE = 0x722708E9
    FIBREGLASS_DOOR1_SETTLEMENT_CLOSE = 0x1A13F00
    FIBREGLASS_DOOR1_SETTLEMENT_OPEN = 0x4ADAF334
    FIBREGLASS_DOOR2_SETTLEMENT_CLOSE = 0x9004F65D
    FIBREGLASS_DOOR2_SETTLEMENT_OPEN = 0x4E200377
    FIEND_ATTACK = 0x4EBD3690
    FIEND_BURY = 0xA732976C
    FIEND_DIE = 0x57FEA6E
    FIEND_GROUNDAPPEAR = 0x9A41A76E
    FIEND_GROUNDEFFECT = 0xE816A4C6
    FIEND_IDLE = 0x9393197A
    FIEND_POUNCE = 0x74BB47B2
    FIEND_ROAR = 0x859699D0
    FIEND_SPIT = 0xFA3ABC76
    FIREPLACE_LP = 0x499F8DC1
    FIRESTORM = 0x2841CE64
    FIRESTORM_STOP = 0x37098E83
    FISHCAUGHT = 0x511DD5F7
    FISHFIEND_DIE = 0x6E831730
    FISHFIEND_EAT = 0x5A853604
    FISHFIEND_SPAWN = 0x1C3DC95F
    FISHING_PLATFORM_LP = 0xB3D3B34
    FISHING_PLATFORM_OPEN = 0xF81A3B8
    FISHSPARKLE = 0x2AF797E7
    FISHSTRUGGLE = 0x99B4CCB6
    FLOATING_GASBAG_EXPLODE = 0x5D91DBB7
    FLOATINGFERN = 0x23132724
    FLOATNIBBLE = 0x36776BB
    FLOATRIPPLE = 0xB201D5BB
    FLOATSPLASH = 0xE24550E4
    FOLEY_STOP_ALL = 0xAEA67841
    FOOT_LOCKER_OPEN = 0xAF12AD4F
    FOOTSTEP = 0x6F394B77
    FOOTSTEP_FALLLAND = 0xFFA89F82
    FORFANGRY01 = 0x419C389A
    FORFCHATTER01 = 0xE497504E
    FORFGREET01 = 0x9934D7C6
    FORFHAPPY01 = 0x40C85F
    FOSSIL_COLLECT = 0xC13BB166
    FOURTHRACE_APOLLO_ANGRY00 = 0xAC2665AE
    FOURTHRACE_APOLLO_CHATTER00 = 0x73545F86
    FOURTHRACE_APOLLO_GREET00 = 0xEE5A2A22
    FOURTHRACE_APOLLO_GREET01 = 0xEE5A2A23
    FOURTHRACE_APOLLO_GREET02 = 0xEE5A2A20
    FOURTHRACE_APOLLO_GREET03 = 0xEE5A2A21
    FOURTHRACE_APOLLO_GREET04 = 0xEE5A2A26
    FOURTHRACE_APOLLO_HAPPY00 = 0xD14ED307
    FOURTHRACE_APOLLO_HAPPY01 = 0xD14ED306
    FOURTHRACE_APOLLO_HAPPY02 = 0xD14ED305
    FOURTHRACE_APOLLO_IDLE00 = 0x747677FD
    FOURTHRACE_ARTEMIS_ANGRY00 = 0x1EA5A71C
    FOURTHRACE_ARTEMIS_CHATTER00 = 0x1E577730
    FOURTHRACE_ARTEMIS_GREET00 = 0x15AA44F4
    FOURTHRACE_ARTEMIS_GREET01 = 0x15AA44F5
    FOURTHRACE_ARTEMIS_GREET02 = 0x15AA44F6
    FOURTHRACE_ARTEMIS_GREET03 = 0x15AA44F7
    FOURTHRACE_ARTEMIS_GREET04 = 0x15AA44F0
    FOURTHRACE_ARTEMIS_HAPPY00 = 0x738920B9
    FOURTHRACE_ARTEMIS_HAPPY01 = 0x738920B8
    FOURTHRACE_ARTEMIS_HAPPY02 = 0x738920BB
    FOURTHRACE_ARTEMIS_IDLE00 = 0x946BA2B3
    FOURTHRACE_NULL_ANGRY00 = 0xAD16E1B0
    FOURTHRACE_NULL_CHATTER00 = 0xD4C3C08C
    FOURTHRACE_NULL_GREET00 = 0x960B9B68
    FOURTHRACE_NULL_GREET01 = 0x960B9B69
    FOURTHRACE_NULL_GREET02 = 0x960B9B6A
    FOURTHRACE_NULL_GREET03 = 0x960B9B6B
    FOURTHRACE_NULL_GREET04 = 0x960B9B6C
    FOURTHRACE_NULL_HAPPY00 = 0xBD9D7CAD
    FOURTHRACE_NULL_HAPPY01 = 0xBD9D7CAC
    FOURTHRACE_NULL_HAPPY02 = 0xBD9D7CAF
    FOURTHRACE_NULL_IDLE00 = 0xC5B3E657
    FOURTHRACE_PROC_ANGRY00 = 0xA69C07BF
    FOURTHRACE_PROC_CHATTER00 = 0x5FB0BF2B
    FOURTHRACE_PROC_GREET00 = 0x4A1A67CB
    FOURTHRACE_PROC_GREET01 = 0x4A1A67CA
    FOURTHRACE_PROC_GREET02 = 0x4A1A67C9
    FOURTHRACE_PROC_GREET03 = 0x4A1A67C8
    FOURTHRACE_PROC_GREET04 = 0x4A1A67CF
    FOURTHRACE_PROC_HAPPY00 = 0x7402CDD2
    FOURTHRACE_PROC_HAPPY01 = 0x7402CDD3
    FOURTHRACE_PROC_HAPPY02 = 0x7402CDD0
    FOURTHRACE_PROC_IDLE00 = 0x1593DBFE
    FRACTALCUBE = 0xB6F17CBB
    FREIGHTER_ALARM = 0x10F2436D
    FREIGHTER_ALARM_START = 0x2B11860C
    FREIGHTER_BRIDGE = 0x8DDFA449
    FREIGHTER_CALL = 0xBA2BE15A
    FREIGHTER_CORRIDOR = 0x7D0215EC
    FREIGHTER_DOOR_INTERNAL_CLOSE = 0xFA499897
    FREIGHTER_DOOR_INTERNAL_OPEN = 0x3F55DE61
    FREIGHTER_DOOR_REINFORCED_CLOSE = 0x4DE5D229
    FREIGHTER_DOOR_REINFORCED_OPEN = 0x16C6217B
    FREIGHTER_DRONE = 0xA4898134
    FREIGHTER_ELEVATOR = 0x1D26E750
    FREIGHTER_HANGAR = 0xC3642BEB
    FREIGHTER_HANGARDOOR_CLOSE = 0xA9AF6976
    FREIGHTER_HANGARDOOR_OPEN = 0xF6307F22
    FREIGHTER_LOWSHIELD_ALARM = 0xEF3758E5
    FREIGHTER_REFINER_ROOM = 0x82217F99
    FREIGHTER_REFINER_RUNNING = 0x22D0D8CD
    FREIGHTER_SHIELD_LP = 0x10C0C14C
    FREIGHTER_SHIELD_LP_STOP = 0x8DF13AFB
    FREIGHTER_SHIELD_ONESHOT = 0x316F204
    FREIGHTER_STELLAREXTRACTOR = 0x5806FFF
    FREIGHTER_STORAGE_TERMINAL = 0x511D7268
    FREIGHTER_TELEPORT = 0xDCD9243F
    FREIGHTER_TELEPORTER = 0xCDD40E2A
    FRIGATE_LIVING_DEVOUR = 0x1E1153E9
    FRIGATE_LIVING_REVEAL = 0x4045C9B3
    FRIGATE_LIVING_TALK = 0x1E4E7B6
    FRIGATE_LIVING_WARPIN = 0x195615B7
    GAS_BASTARD_POP = 0x3EA92568
    GEMCRYSTAL_COLLECT = 0xAC4DFF83
    GLITCHY_MONITOR = 0x1E04A85C
    GRABBYPLANT_ATTACK_END = 0x684EBBB8
    GRABBYPLANT_ATTACK_LP = 0x10A22325
    GRABBYPLANT_DIE = 0xD7FAF53C
    GRAV_BALLS = 0xC72A3468
    GRAV_BALLS_STOP = 0xAE129547
    GROUND_SIZZLE = 0x577DF00A
    GROUND_SIZZLE_STOP = 0x1BAC5A39
    GROUNDWORM_CLOSE = 0x6D6FB800
    GROUNDWORM_KILL = 0xCA498284
    GROUNDWORM_OPEN = 0x25023634
    GRUNTATTACK2 = 0xDE8A7D61
    GRUNTATTACK3 = 0xDE8A7D60
    GRUNTFLOATHAPPY = 0xFFBDD045
    GRUNTFLOATSLEEP = 0x9ED114F6
    GRUNTPOUNCE = 0xB66812B
    GRUNTROAR = 0x8C8B6075
    HARRYTEST = 0xD13E408D
    HAZ_CRIT_COLD = 0x4C14E836
    HAZ_CRIT_HEAT = 0xAA7866FE
    HAZ_CRIT_O2 = 0xBDA886E7
    HAZ_CRIT_RAD = 0x582BD949
    HAZ_CRIT_RAD_FALLING = 0x6F3906B1
    HAZ_CRIT_RAD_STABLE = 0xAD62460D
    HAZ_CRIT_SHIELD = 0x4643A77B
    HAZ_CRIT_SHIELD_FALLING = 0x10651173
    HAZ_CRIT_SHIELD_STABLE = 0x274BF05F
    HAZ_CRIT_THERM_FALLING = 0xF60D19A6
    HAZ_CRIT_TOXIC = 0xA2EE4605
    HAZ_CRIT_TOXIC_FALLING = 0xC71CDD4D
    HAZ_CRIT_TOXIC_STABLE = 0x55AB8951
    HAZARDPLANT_CLOSE = 0x8C136AB5
    HAZARDPLANT_IDLE = 0xA9E70AAD
    HAZARDPLANT_OPEN = 0x246D555F
    HAZARDPLANT_OPENIDLE = 0x9308BAF9
    HEATER_OFF = 0xD57B9408
    HEATER_ON = 0x4E481692
    HEXAGON = 0x66DC42F
    HOLOHUB_END = 0xCF84178C
    HOLOHUB_LADDER_END = 0x372BBD97
    HOLOHUB_LADDER_START = 0xEF70C184
    HOLOHUB_START = 0xD60EC7EF
    HOVERCRAFT_BOOST_START = 0xF116021C
    HOVERCRAFT_BOOST_STOP = 0xC256FEF0
    HOVERCRAFT_HORN_START = 0xA5828922
    HOVERCRAFT_HORN_STOP = 0x6EEC151A
    HOVERCRAFT_IDLE_EXTERIOR = 0x293C4C27
    HOVERCRAFT_IMPACTS = 0xF638247D
    HOVERCRAFT_JUMP = 0x611F8178
    HOVERCRAFT_START = 0x18B0E3B0
    HOVERCRAFT_STOP = 0x4909EE1C
    HOVERCRAFT_SUSPENSION = 0x26A065CF
    HUD_JUMP_ENGAGE = 0x3AC8D717
    HUD_JUMPING = 0x4238C05
    IDENTIFY_SCAN_OFF = 0x8E533775
    IDENTIFY_SCAN_ON = 0xC5976489
    IMPACT_CREATURE_SQUISH = 0xAD1494AB
    IMPACTS_GROUND_GENERIC_SMALL = 0x785AA13A
    INTERACT_COLLECT = 0x2DB05350
    INTERACTION_CARGOBAY = 0x2153E9AE
    INTERACTION_CARGOBAYSTUCK = 0x8374264A
    INTERACTION_CARGOCONTLOAD = 0xEF521ED6
    INTERACTION_ENGINEREACTOR = 0x1255F34E
    INTERACTION_MAINTPOINT = 0xFE58FBEF
    INTERACTION_TURRETSHELLS = 0xA8F90361
    INTERACTION_TURRETTURN = 0xDB15CA55
    INTERACTIVECASE_OPEN = 0xE81E1242
    JELLYFISH_DIE = 0x8D0341AE
    JELLYFISH_SPAWN = 0x4CF735B9
    JELLYFISH_SWIM = 0x6DF627F0
    JELLYFISHBOSS_APPEAR = 0x4B30A1CE
    JELLYFISHBOSS_ORBATTACK = 0x252C9E10
    JELLYFISHBOSS_SWIM = 0xF1258E95
    JETPACK_BOOST_PICKUP = 0x1662D4A8
    JETPACK_BOOST_START = 0x59EEB4F8
    JETPACK_BOOST_STOP = 0xE6CC9004
    JETPACK_BOOST_TIMEOUT = 0x3D3E8565
    JETPACK_DEPLETED = 0x4392405
    JETPACK_START = 0xBF36A0FC
    JETPACK_STOP = 0x35973C50
    JETPACK_WATER_TRANSITION_INTO_ATMOS = 0x3EBFB6F9
    JETPACK_WATER_TRANSITION_INTO_WATER = 0x20BEC596
    KEYCONTAINER = 0xF4218B47
    LANDING_PLATFORM_CLOSE = 0x854717ED
    LANDING_PLATFORM_OPEN = 0x78991C27
    LANDINGBAY_ACTIVATE = 0x3816AA16
    LANDINGBAY_DEACTIVATE = 0x853967B7
    LANDSQUID_APPEAR = 0x3C4D6560
    LANDSQUID_DISAPPEAR = 0x2B93DE02
    LANDSQUID_KAMIKAZE = 0xFEDCC316
    LANDSQUID_KAMIKAZE_STOP = 0x5EB75A45
    LANDSQUID_KILL = 0x327DB8CF
    LANDSQUID_SPIT = 0x65F318DD
    LANDSQUID_SWIM = 0x65E64CDB
    LANTERNCLOSE = 0x808EAE35
    LANTERNOPEN = 0x8AFD33DF
    LAVA_VOLCANO_AMBIENT = 0x4D0F2CED
    LAVA_VOLCANO_ERUPT = 0xE111872B
    LAVA_VOLCANO_EXPLODE = 0x82B62E7E
    LIGHTNING = 0xC6BFE289
    LOCKER_OPEN = 0x305CA008
    LOWERORDERANGRYIPAD = 0xA7B5482F
    LOWERORDERCHATTERIPAD = 0x3E606FBB
    LOWERORDERGREET1IPAD = 0x18A08D70
    LOWERORDERGREET2IPAD = 0xB00B7183
    LOWERORDERGREET3IPAD = 0xD559CDA2
    LOWERORDERGREET4IPAD = 0x4F012E65
    LOWERORDERGREET5IPAD = 0x39664C44
    LOWERORDERHAPPY2IPAD = 0x324DAE34
    LOWERORDERHAPPY3IPAD = 0xCCFEEDD5
    LOWERORDERHAPPY4IPAD = 0x93565F52
    LOWERORDERHAPPYIPAD = 0x8547CFD2
    MAINTENANCE_BROKEN = 0xEEE46E
    MANTARAY_ATTACK = 0x74EEDFC1
    MANTARAY_FASTSWIM = 0xF5F12B8F
    MANTARAY_SWIM = 0xF8F768E1
    MAP_STAR_WOOSH = 0xBC7AB0AD
    MAP_WAYPOINT_TONE_LP = 0xCD4C651B
    MECH_EXIT = 0xBCC570FD
    MECH_IDLE = 0xBB021D37
    MECH_JETPACK_LANDING = 0x520C6999
    MECH_JETPACK_LANDING_INTRO = 0xB183200A
    MECH_JETPACK_LANDING_SKID = 0x180A89A5
    MECH_JETPACK_LP = 0xDE5305B4
    MECH_JETPACK_LP_END = 0xA6FCEB2A
    MECH_JETPACK_RETRIGGER = 0x76E0CB75
    MECH_JETPACK_STARTUP = 0x16C249B
    MECH_JETPACK_TRIGGER = 0xCF7D714
    MECH_MOVE_RUN = 0xD7C5239C
    MECH_MOVE_WALK = 0x936BCEAA
    MECH_SENTINEL_STEP_RUN = 0x85D18C
    MECH_SENTINEL_STEP_WALK = 0xA892E81A
    MECH_STEP_RUN = 0xE008E6CD
    MECH_STEP_WALK = 0x5569365D
    MECH_STONE_STEP_RUN = 0xBA0B131B
    MECH_STONE_STEP_WALK = 0xAE485EF7
    MESSAGEMODULE_IDLE = 0x74347F1F
    MESSAGEMODULE_START = 0x96AB9597
    METALFORMATION_COLLECT = 0x2F24E23C
    METEORITE_EXPLODE = 0xD846F01D
    METEORITE_INCOMING = 0xCFBF792E
    MILK_BOTTLING = 0x4511C1AE
    MILK_PUMPING = 0x87C5888F
    MINIDRONE_ACTIVE = 0x9F140B13
    MINIDRONE_IDLE = 0xA651E327
    MINIDRONE_SHOOT = 0xE1A418B6
    MINIWORM_BURSTOUT = 0x105FB33A
    MINIWORM_DEATH = 0x2996DB4A
    MINIWORM_IDLE = 0x8C3BC9E2
    MINIWORM_LUNGE = 0xB1195BC9
    MINIWORM_LURKING = 0x72AF95EC
    MINIWORM_RETRACT = 0x97EB3C43
    MINIWORM_ROAR = 0xA0EA53E8
    MOLE = 0xBD7B65F0
    MONOLITH_BEAM_START = 0x22177738
    MONOLITH_INTERACTIONPLATFORM_START = 0x31D40DBC
    MONUMENT = 0x9AB78CBA
    MOTION_PS5_01 = 0x139A94EC
    MOTION_PS5_STOP = 0xECE193FD
    MSTRUCTURE = 0x2E46515
    MUS_AMBIENT_MODE = 0xEB3C1A97
    MUS_AMBIENT_MODE_STOP = 0xB0299432
    MUS_ATLASSTATION = 0xD2C903D2
    MUS_COMMUNITYRESEARCH = 0xC44ABF93
    MUS_CORRUPTED_LP = 0x9CF981B6
    MUS_CORRUPTED_LP_STOP_FAST = 0x26307F5A
    MUS_CORRUPTED_LP_STOP_SLOW = 0xB9DB6827
    MUS_CORRUPTED_MUSICCUE = 0xA1CA2E10
    MUS_CORRUPTED_STING_LONG = 0x89859902
    MUS_ENCLAVE_DISCOVER = 0xFC4C03AD
    MUS_ENDING = 0x3414FF98
    MUS_EXPEDITION_START = 0x68E79865
    MUS_FIRSTTIMESPACESTATION = 0x1C477914
    MUS_FIRSTTIMEWARP = 0x21015BC
    MUS_FISHING = 0x6999BC45
    MUS_FISHING_STOP = 0x7F346DC8
    MUS_GAMESTART = 0x6E416461
    MUS_GAMESTART_LUSHWALK = 0xE4582A4F
    MUS_GAMESTART_LUSHWALK_STOP = 0x57DB907A
    MUS_GAMESTART_STOP = 0x2BE88C64
    MUS_LEVEL_UP = 0xDBB97803
    MUS_LOADING01 = 0x58A3185E
    MUS_LOADING02 = 0x58A3185D
    MUS_LOADING03 = 0x58A3185C
    MUS_LOADING04 = 0x58A3185B
    MUS_LOADING05 = 0x58A3185A
    MUS_LOADING06 = 0x58A31859
    MUS_LOADING07 = 0x58A31858
    MUS_LOADING08 = 0x58A31857
    MUS_LOADING09 = 0x58A31856
    MUS_LOADING10 = 0x57A316EC
    MUS_LOADING11 = 0x57A316ED
    MUS_LOADING12 = 0x57A316EE
    MUS_LOADING13 = 0x57A316EF
    MUS_LOADING14 = 0x57A316E8
    MUS_LOADING15 = 0x57A316E9
    MUS_LOADING16 = 0x57A316EA
    MUS_LOADING17 = 0x57A316EB
    MUS_LOADING18 = 0x57A316E4
    MUS_LOADING19 = 0x57A316E5
    MUS_LOADING20 = 0x5AA31BA5
    MUS_LOADING21 = 0x5AA31BA4
    MUS_LOADING22 = 0x5AA31BA7
    MUS_LOADING23 = 0x5AA31BA6
    MUS_LOADING24 = 0x5AA31BA1
    MUS_LOADING25 = 0x5AA31BA0
    MUS_LOADING26 = 0x5AA31BA3
    MUS_LOADING27 = 0x5AA31BA2
    MUS_LOADING28 = 0x5AA31BAD
    MUS_LOADING29 = 0x5AA31BAC
    MUS_LOADING30 = 0x59A31A32
    MUS_LOADING31 = 0x59A31A33
    MUS_LOADING32 = 0x59A31A30
    MUS_LOADING33 = 0x59A31A31
    MUS_LOADING34 = 0x59A31A36
    MUS_LOADING35 = 0x59A31A37
    MUS_LOADING36 = 0x59A31A34
    MUS_LOADING37 = 0x59A31A35
    MUS_LOADING38 = 0x59A31A3A
    MUS_LOADING39 = 0x59A31A3B
    MUS_LOADING40 = 0x54A31213
    MUS_LOADING41 = 0x54A31212
    MUS_LOADING42 = 0x54A31211
    MUS_LOADING43 = 0x54A31210
    MUS_LOADING44 = 0x54A31217
    MUS_LOADING45 = 0x54A31216
    MUS_LOADING46 = 0x54A31215
    MUS_LOADING47 = 0x54A31214
    MUS_LOADING48 = 0x54A3121B
    MUS_LOADING49 = 0x54A3121A
    MUS_LOADING50 = 0x53A310A0
    MUS_LOADING51 = 0x53A310A1
    MUS_LOADING52 = 0x53A310A2
    MUS_LOADING_STOP = 0x1E870702
    MUS_MILESTONE_COMPLETE = 0xD15B7779
    MUS_MILESTONE_REWARDS = 0x72C807B0
    MUS_MONOLITH = 0x18D5A84D
    MUS_MONOLITH_STOP = 0x120E6A40
    MUS_ONE_SINGLE_STAR = 0x77BEEC59
    MUS_RECURSIVE_SIMULATION = 0xE5C1825B
    MUS_SPACEVIRGIN = 0x2E518E96
    MUS_STATUS_UPDATE = 0x9E8F516D
    MUS_STORYMODE_MUSICCUE_01 = 0xC12BE1FC
    MUS_STORYMODE_MUSICCUE_02 = 0xC12BE1FF
    MUS_STORYMODE_MUSICCUE_03 = 0xC12BE1FE
    MUS_STORYMODE_MUSICCUE_04 = 0xC12BE1F9
    MUS_STORYMODE_MUSICCUE_05 = 0xC12BE1F8
    MUS_STORYMODE_MUSICCUE_06_LP = 0xC345F572
    MUS_STORYMODE_MUSICCUE_06_LP_STOP = 0x37EA3DD1
    MUS_STORYMODE_MUSICCUE_07 = 0xC12BE1FA
    MUS_STORYMODE_MUSICCUE_08_LP = 0x31987684
    MUS_STORYMODE_MUSICCUE_08_LP_STOP = 0x4F40ADE3
    MUS_STORYMODE_MUSICCUE_09 = 0xC12BE1F4
    MUS_STORYMODE_MUSICCUE_10_LP = 0xDD4A2FD
    MUS_STORYMODE_MUSICCUE_10_LP_STOP = 0x21A4CB50
    MUS_STORYMODE_MUSICCUE_11_LP = 0x57BEDBE2
    MUS_STORYMODE_MUSICCUE_11_LP_STOP = 0x22CA1
    MUS_STORYMODE_MUSICCUE_12_LP = 0x102487FB
    MUS_STORYMODE_MUSICCUE_12_LP_STOP = 0xA8509856
    MUS_STORYMODE_MUSICCUE_13_LP = 0x9B4C59A0
    MUS_STORYMODE_MUSICCUE_13_LP_STOP = 0xB5CCBF8F
    MUS_STORYMODE_MUSICCUE_14 = 0xC02BE00E
    MUS_STORYMODE_MUSICCUE_15 = 0xC02BE00F
    MUS_STORYMODE_MUSICCUE_16 = 0xC02BE00C
    MUS_STORYMODE_MUSICCUE_17 = 0xC02BE00D
    MUS_STORYMODE_MUSICCUE_18 = 0xC02BE002
    MUS_STORYMODE_MUSICCUE_19 = 0xC02BE003
    MUS_STORYMODE_MUSICCUE_20 = 0xBF2BDE97
    MUS_STORYMODE_MUSICCUE_21 = 0xBF2BDE96
    MUS_STORYMODE_MUSICCUE_22_LP = 0x10FAF564
    MUS_STORYMODE_MUSICCUE_22_LP_STOP = 0x46E34383
    MUS_STORYMODE_MUSICCUE_23 = 0xBF2BDE94
    MUS_STORYMODE_MUSICCUE_24 = 0xBF2BDE93
    MUS_STORYMODE_MUSICCUE_25 = 0xBF2BDE92
    MUS_STORYMODE_MUSICCUE_26 = 0xBF2BDE91
    MUS_STORYMODE_MUSICCUE_27 = 0xBF2BDE90
    MUS_STORYMODE_MUSICCUE_28 = 0xBF2BDE9F
    MUS_STORYMODE_MUSICCUE_29 = 0xBF2BDE9E
    MUS_STORYMODE_MUSICCUE_30 = 0xBE2BDD24
    MUS_STORYMODE_MUSICCUE_31 = 0xBE2BDD25
    MUS_STORYMODE_MUSICCUE_32 = 0xBE2BDD26
    MUS_STORYMODE_MUSICCUE_33 = 0xBE2BDD27
    MUS_STORYMODE_STOPALL = 0x5519D8C5
    MUS_THE_APPEARANCE_OF_A_STAR_SYSTEM = 0x5EC79C9C
    MUS_UNKNOWN_SYSTEM_X349866 = 0x637CCD8
    MUS_XBOX_SPLASHSCREEN = 0x99AFDCA0
    MUS_XBOX_SPLASHSCREEN_STOP = 0x89EE888F
    NADA_CHATTER_11 = 0xF7BB5BF6
    NADA_CHATTER_12 = 0xF7BB5BF5
    NADA_CHATTER_13 = 0xF7BB5BF4
    NADA_GREET_08 = 0x7D9C920C
    NADA_GREET_09 = 0x7D9C920D
    NEW_TECH = 0xCAC84920
    NEW_WEAPON = 0xE3FA979C
    NEXUS_BRIDGEENGINE_IDLE = 0xB01A5461
    NEXUS_BUBBLINGTUBE_SMALL = 0x495F0A84
    NEXUS_CONTROLROOM_CENTRE = 0xD9E873E9
    NEXUS_CONTROLROOM_HOLOGRAM = 0xB1F10DCD
    NEXUS_COOKINGFOOD = 0x6A2D035F
    NEXUS_EXTERIORLEG = 0xA2F9E64D
    NEXUS_FUELPUMP = 0xC949845F
    NEXUS_LANDING_RINGS = 0x725742B2
    NEXUS_MARKETDOOR_CLOSE = 0x99262904
    NEXUS_MARKETDOOR_OPEN = 0x81306600
    NEXUS_MIDDLEDRONE_IDLE = 0x2FA246D9
    NEXUS_PLANTGROWBOX = 0x7490B24
    NEXUS_ROBOARM_MOVE1 = 0x229C720C
    NEXUS_ROBOARM_MOVE1_REV = 0x21CFF112
    NEXUS_ROTATINGSIGN = 0x7D5A7B6A
    NEXUS_SMALLDRONE_FRAME0 = 0x2F28D10A
    NEXUS_SMALLDRONE_FRAME192 = 0x26731F8A
    NEXUS_SMALLDRONE_FRAME289 = 0xA56B98D9
    NEXUS_SMALLDRONE_FRAME512 = 0xB67CFCF6
    NEXUS_SMALLDRONE_FRAME640 = 0x21755640
    NEXUS_SMALLDRONE_FRAME879 = 0xA45C8CFA
    NEXUS_SMALLDRONE_LP = 0x6CC12C6F
    NEXUS_TELEPORTER = 0xADAB0AF1
    NEXUS_VENT = 0x2440A0FC
    NEXUS_WALLFAN = 0x1FA26F80
    NORMANDY_BEACON = 0xCC905DCE
    NOTIFY_ADDITIONALRESOURCES = 0xF4860355
    NOTIFY_AREANOTCLEAR = 0x129A400
    NOTIFY_ASSISTANT = 0x44073D5F
    NOTIFY_ATTACKSHIPSENGAGED = 0x97E57481
    NOTIFY_BASEOUTRANGE = 0xC25586D1
    NOTIFY_BASEOUTRANGE_RETURN = 0x9D895AAE
    NOTIFY_BUILDLIMIT = 0x85C9120C
    NOTIFY_CIVILIANFREIGHTER_DESTROYED = 0x75D6D35A
    NOTIFY_CRITIAL_ENERGY = 0xAF6B907C
    NOTIFY_CRITIAL_HIT = 0xB4DC4AF7
    NOTIFY_CRITICAL_COLD = 0x3534E9B7
    NOTIFY_CRITICAL_HEAT = 0xEE9FF4E3
    NOTIFY_CRITICAL_NOOXYGEN = 0xF718BE58
    NOTIFY_CRITICAL_RAD = 0x6694BE72
    NOTIFY_CRITICAL_TOXIC = 0xE80C3762
    NOTIFY_DAMAGESUSTAINED = 0x70C2A03A
    NOTIFY_DAMAGEVEHICLE = 0x8D4D1E66
    NOTIFY_DAMAGEVEHICLESUSTAINED = 0x1A9FD076
    NOTIFY_ENERGY_PERCENT = 0xE4CE6907
    NOTIFY_EXTERNALVIEW = 0xB03C84EF
    NOTIFY_EXTREMEHAZARDPLANET = 0xF43765ED
    NOTIFY_EXTREMESENTINELPLANET = 0x83C94F75
    NOTIFY_FREIGHTERACQUIRED = 0x5FC34813
    NOTIFY_FREIGHTERWARP = 0x82FD0FD1
    NOTIFY_FUELDEPLETED = 0xEF3000F4
    NOTIFY_FUELREQUIRED = 0xE89842EA
    NOTIFY_GAS_PLANT = 0x3A05F2D6
    NOTIFY_HAZ_CAVE_COLD = 0xF31B087B
    NOTIFY_HAZ_CAVE_HEAT = 0xC4AD486F
    NOTIFY_HAZ_CAVE_RADIATION = 0xF18F48E6
    NOTIFY_HAZ_CAVE_TOXIC = 0xC6F1B1A6
    NOTIFY_HAZ_CRIT_COLD = 0xBDE32DB6
    NOTIFY_HAZ_CRIT_HEAT = 0x1C46AC7E
    NOTIFY_HAZ_CRIT_RADIATION = 0x1CDFE22D
    NOTIFY_HAZ_CRIT_TOXIC = 0x4AA5AE85
    NOTIFY_HAZ_NIGHT_COLD = 0xD9846BCE
    NOTIFY_HAZ_NIGHT_HEAT = 0xF7B71686
    NOTIFY_HAZ_NIGHT_RADIATION = 0x90E58735
    NOTIFY_HAZ_NIGHT_TOXIC = 0x714CA8DD
    NOTIFY_HAZ_TEMP_STABLE = 0xB56C8D2F
    NOTIFY_HAZ_WATER_COLD = 0x81DE761F
    NOTIFY_HAZ_WATER_HEAT = 0x5BC840DB
    NOTIFY_HAZ_WATER_TOXIC = 0x6E79BAEA
    NOTIFY_HIT_COLD = 0xD38A3CED
    NOTIFY_HIT_ENERGY = 0x869CE84F
    NOTIFY_HIT_HEAT = 0xE92FA0E9
    NOTIFY_HIT_RAD = 0x176C6800
    NOTIFY_HIT_TOXIC = 0x9B632C5C
    NOTIFY_HOMEPLANET = 0xA44B6BB2
    NOTIFY_HOMEPLANETESTABLISHED = 0x648ABCEC
    NOTIFY_HOSTILES = 0x19F50A20
    NOTIFY_HOSTILES_DEFEATED = 0x5886A77D
    NOTIFY_HOSTILESYSTEM = 0xE60E20FE
    NOTIFY_HOSTILESYSTEMENGAGE = 0x4161E437
    NOTIFY_HOSTILESYSTEMWEAPONS = 0xE3138F29
    NOTIFY_HOT_ROCK = 0x2022A12E
    NOTIFY_INSUFFICIENTRESOURCES = 0x87CD5C9B
    NOTIFY_INTERNALVIEW = 0xE5A5363D
    NOTIFY_INV_TRANSFERRED = 0xF5199CCD
    NOTIFY_INVENTORY_SHIP_FULL = 0x7FEAB5CC
    NOTIFY_INVENTORY_SUIT_FULL = 0x57A8357F
    NOTIFY_ITEM_RECEIVED = 0x64B8C086
    NOTIFY_LANDING = 0x244555A
    NOTIFY_LANDINGSEQUENCE = 0xF8167905
    NOTIFY_LIFESUPPORTFALLING = 0xB1A96BA5
    NOTIFY_LOW_ENERGY = 0x916DB99C
    NOTIFY_MISSILEDESTROYED = 0xBE9C28A0
    NOTIFY_MISSILEENEMY = 0xC0A031A5
    NOTIFY_MISSILEENEMYINBOUND = 0xCFCA9E0C
    NOTIFY_MISSILEINBOUND = 0x8A853C06
    NOTIFY_MISSILEINCOMING = 0x117B54CF
    NOTIFY_MISSILEINCOMINGDESTROYED = 0xD9BC2ADC
    NOTIFY_MISSILEINCOMINGNEUTRALISED = 0x900B6253
    NOTIFY_MISSILELOCKED = 0xB2B6FCF5
    NOTIFY_MISSILENEUTRALISED = 0xB1E6896F
    NOTIFY_MISSILEREADY = 0x2704818
    NOTIFY_MISSILESDESTROYED = 0xFEA1EB33
    NOTIFY_MISSILESINCOMINGDESTROYED = 0x7844BE83
    NOTIFY_MISSILESINCOMINGNEUTRALISED = 0x305C90C8
    NOTIFY_MISSILESNEUTRALISED = 0x27D01838
    NOTIFY_NEW_SHIP = 0x4E3FD7DE
    NOTIFY_NEW_SLOT = 0x5048D544
    NOTIFY_NEW_SYSTEM = 0xEB09F91B
    NOTIFY_NEW_WEAPON = 0xF9D4781C
    NOTIFY_NEWASSISTANT = 0xA87F871F
    NOTIFY_NEWASSISTANTACQUIRED = 0xE4B6193F
    NOTIFY_NEWBOUNTY = 0x2ED364C4
    NOTIFY_NEWFREIGHTERACQUIRED = 0x8943C7D3
    NOTIFY_OBJECTIVE_COMPLETE = 0xBB7E1EA4
    NOTIFY_PIRATEENGINES = 0xF1E2BFBF
    NOTIFY_PIRATESLARGE = 0x8D320F36
    NOTIFY_PIRATESSPOTTED = 0x19003798
    NOTIFY_PRO_OFFLINE = 0x5DEDA806
    NOTIFY_PRO_PERCENT = 0x19661DC8
    NOTIFY_PRODUCT_RECEIVED = 0x36B5EED4
    NOTIFY_PULSE = 0xFDA5D118
    NOTIFY_PULSEOFFATMOS = 0x2A8B274B
    NOTIFY_PULSEOFFFUEL = 0xAFCB0F67
    NOTIFY_PULSEOFFLARGESHIP = 0x62E50DE2
    NOTIFY_PULSEOFFLOCAL = 0xC42AB9F0
    NOTIFY_PULSEOFFPLANET = 0x24FCA7F9
    NOTIFY_PULSEOFFSTATION = 0xCFF19999
    NOTIFY_RADLEAK_DAMAGE = 0x3A928F91
    NOTIFY_RADPRO_OFFLINE = 0x66C488F
    NOTIFY_REFUELVEHICLE = 0x7A00F4CE
    NOTIFY_SENTINELSARRIVED = 0x5807CBC3
    NOTIFY_SENTINELSDEACTIVATED = 0xBE2FA622
    NOTIFY_SENTINELSTARSHIPS = 0xD6463F36
    NOTIFY_SENTINELSTARSHIPSCOMBAT = 0x965E55FA
    NOTIFY_SHIELD_DOWN = 0x4619ABB5
    NOTIFY_TARGETACQUIRED = 0x4734B5E6
    NOTIFY_TARGETLOCKED = 0x22D490DC
    NOTIFY_TECHNOLOGYCRITICALLYDAMAGED = 0x8D9A8992
    NOTIFY_THRUSTERSOFFATMOS = 0x7AD9AE32
    NOTIFY_THRUSTERSOFFLARGESHIP = 0xD1B3E833
    NOTIFY_THRUSTERSOFFLOCAL = 0x206BDF55
    NOTIFY_THRUSTERSOFFSTATION = 0xFFAE5BB8
    NOTIFY_TOXICPRO_OFFLINE = 0x52C65D7
    NOTIFY_TRANSFERRED = 0xB1FB7B81
    NOTIFY_TRANSFERRED_ELEMENT = 0x92F3EE84
    NOTIFY_TRANSFERRED_PRODUCT = 0x1BBA22D9
    NOTIFY_UNITS_DEPLETED = 0x1B43FD00
    NOTIFY_UNITS_INSUFFICIENT = 0x77EA828C
    NOTIFY_UNITS_RECEIVED = 0xE2A736C0
    NOTIFY_VEHICLE = 0xE31EB0A7
    NOTIFY_VEHICLEACQUIRED = 0x79BFA8D7
    NOTIFY_VEHICLEDEPOLYED = 0x55CB1197
    NOTIFY_VEHICLEMOBILISED = 0x22ACF15B
    NOTIFY_VEHICLESUMMONED = 0xE0F39F69
    NOTIFY_WARNING = 0xEC145583
    NOTIFY_WARP = 0x261F5C3B
    NOTIFY_WARPING = 0x66D34BA5
    NPC_CLOTHING_1H_INTERACT_IPAD01 = 0x5AA4948A
    NPC_CLOTHING_1H_INTERACT_IPAD02 = 0x5AA49489
    NPC_CLOTHING_1H_SITTING_INTERACT_IPAD01 = 0xF18063B3
    NPC_CLOTHING_1H_SITTING_INTERACT_IPAD02 = 0xF18063B0
    NPC_CONSTRUCTION_TERMINAL = 0x1433F1D1
    NPC_FOLEY_CLOTHING_0H_IDLE_BASIC01 = 0xD646765B
    NPC_FOLEY_CLOTHING_0H_IDLE_BASIC02 = 0xD6467658
    NPC_FOLEY_CLOTHING_0H_IDLE_BASIC03 = 0xD6467659
    NPC_FOLEY_CLOTHING_0H_IDLE_BASIC04 = 0xD646765E
    NPC_FOLEY_CLOTHING_0H_IDLE_BASIC05 = 0xD646765F
    NPC_FOLEY_CLOTHING_0H_IDLE_LOOKDOWN01 = 0x5D508CC4
    NPC_FOLEY_CLOTHING_0H_IDLE_LOOKLEFT01 = 0x93461FF7
    NPC_FOLEY_CLOTHING_0H_IDLE_LOOKLEFT02 = 0x93461FF4
    NPC_FOLEY_CLOTHING_0H_IDLE_LOOKLEFT03 = 0x93461FF5
    NPC_FOLEY_CLOTHING_0H_IDLE_LOOKRIGHT01 = 0x7A2CAEC
    NPC_FOLEY_CLOTHING_0H_IDLE_LOOKRIGHT02 = 0x7A2CAEF
    NPC_FOLEY_CLOTHING_0H_IDLE_LOOKRIGHT03 = 0x7A2CAEE
    NPC_FOLEY_CLOTHING_0H_IDLE_LOOKUP01 = 0xDC60245B
    NPC_FOLEY_CLOTHING_0H_INT_CNSL_IN = 0x6D1BD65F
    NPC_FOLEY_CLOTHING_0H_INT_CNSL_LP = 0x701BDA9A
    NPC_FOLEY_CLOTHING_0H_INT_CNSL_OUT = 0xAD6D0F2
    NPC_FOLEY_CLOTHING_0H_INT_RT_01_IN = 0xA9983603
    NPC_FOLEY_CLOTHING_0H_INT_RT_01_LP = 0xA4982EFE
    NPC_FOLEY_CLOTHING_0H_INT_RT_01_OUT = 0x168E23FE
    NPC_FOLEY_CLOTHING_0H_INT_RT_02_IN = 0x558369C6
    NPC_FOLEY_CLOTHING_0H_INT_RT_02_LP = 0x5A8371F7
    NPC_FOLEY_CLOTHING_0H_INT_RT_02_OUT = 0x7EEEB7C9
    NPC_FOLEY_CLOTHING_0H_INT_RT_03 = 0xF65FDE5D
    NPC_FOLEY_CLOTHING_0H_INT_RT_04 = 0xF65FDE5A
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_01 = 0xF6916F77
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_02 = 0xF6916F74
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_03 = 0xF6916F75
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_04 = 0xF6916F72
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_05 = 0xF6916F73
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_06 = 0xF6916F70
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_07 = 0xF6916F71
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_08 = 0xF6916F7E
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_09 = 0xF6916F7F
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_10 = 0xF79170E9
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_11 = 0xF79170E8
    NPC_FOLEY_CLOTHING_0H_INTER_LISTEN_12 = 0xF79170EB
    NPC_FOLEY_CLOTHING_0H_SHUTDWN_IN = 0xB237B602
    NPC_FOLEY_CLOTHING_0H_SHUTDWN_OUT = 0x9AAF193D
    NPC_FOLEY_CLOTHING_0H_SIT_ANGRY01 = 0x7502B292
    NPC_FOLEY_CLOTHING_0H_SIT_ANGRY02 = 0x7502B291
    NPC_FOLEY_CLOTHING_0H_SIT_CHATTER01 = 0x7DE81D76
    NPC_FOLEY_CLOTHING_0H_SIT_CHATTER02 = 0x7DE81D75
    NPC_FOLEY_CLOTHING_0H_SIT_GREET01 = 0xC4F0B05E
    NPC_FOLEY_CLOTHING_0H_SIT_GREET02 = 0xC4F0B05D
    NPC_FOLEY_CLOTHING_0H_SIT_HAPPY01 = 0xDA2DA237
    NPC_FOLEY_CLOTHING_0H_SIT_HAPPY02 = 0xDA2DA234
    NPC_FOLEY_CLOTHING_0H_SIT_LOOK_L01 = 0xB11AD035
    NPC_FOLEY_CLOTHING_0H_SIT_LOOK_L02 = 0xB11AD036
    NPC_FOLEY_CLOTHING_0H_SIT_LOOK_R01 = 0x350207DB
    NPC_FOLEY_CLOTHING_0H_SIT_LOOK_R02 = 0x350207D8
    NPC_FOLEY_CLOTHING_0H_SIT_LOOKARND = 0x8BC36BE
    NPC_FOLEY_CLOTHING_0H_SIT_NEUTRAL01 = 0xFDD53340
    NPC_FOLEY_CLOTHING_0H_SIT_NEUTRAL02 = 0xFDD53343
    NPC_FOLEY_CLOTHING_0H_SIT_SOFA_IDLE01 = 0x1826E27B
    NPC_FOLEY_CLOTHING_0H_SIT_SOFA_IDLE02 = 0x1826E278
    NPC_FOLEY_CLOTHING_0H_SIT_SOFA_IDLE03 = 0x1826E279
    NPC_FOLEY_CLOTHING_0H_SIT_SOFA_IDLE04 = 0x1826E27E
    NPC_FOLEY_CLOTHING_0H_SIT_SOFA_IDLE05 = 0x1826E27F
    NPC_FOLEY_CLOTHING_0H_SIT_SOFA_IDLE06 = 0x1826E27C
    NPC_FOLEY_CLOTHING_0H_SIT_SOFA_IDLE07 = 0x1826E27D
    NPC_FOLEY_CLOTHING_0H_SIT_SOFA_INTO = 0x4BB40382
    NPC_FOLEY_CLOTHING_0H_SIT_SOFA_OUTOF = 0xCE067C73
    NPC_FOLEY_CLOTHING_0H_SIT_STRETCH = 0x6C12BE63
    NPC_FOLEY_CLOTHING_0H_STAND_ANGRY01 = 0x44CB2FE6
    NPC_FOLEY_CLOTHING_0H_STAND_ANGRY02 = 0x44CB2FE5
    NPC_FOLEY_CLOTHING_0H_STAND_ANGRY05 = 0x44CB2FE2
    NPC_FOLEY_CLOTHING_0H_STAND_ANGRY_LP01 = 0xD00508BF
    NPC_FOLEY_CLOTHING_0H_STAND_ANGRY_LP02 = 0xD00508BC
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER01 = 0x9C9C8A22
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER02 = 0x9C9C8A21
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER03 = 0x9C9C8A20
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER04 = 0x9C9C8A27
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER05 = 0x9C9C8A26
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER06 = 0x9C9C8A25
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER07 = 0x9C9C8A24
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER08 = 0x9C9C8A2B
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER09 = 0x9C9C8A2A
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER10 = 0x9B9C88B0
    NPC_FOLEY_CLOTHING_0H_STAND_CHATTER14 = 0x9B9C88B4
    NPC_FOLEY_CLOTHING_0H_STAND_GREET01 = 0x4BCB4C32
    NPC_FOLEY_CLOTHING_0H_STAND_GREET02 = 0x4BCB4C31
    NPC_FOLEY_CLOTHING_0H_STAND_GREET03 = 0x4BCB4C30
    NPC_FOLEY_CLOTHING_0H_STAND_GREET04 = 0x4BCB4C37
    NPC_FOLEY_CLOTHING_0H_STAND_GREET05 = 0x4BCB4C36
    NPC_FOLEY_CLOTHING_0H_STAND_GREET06 = 0x4BCB4C35
    NPC_FOLEY_CLOTHING_0H_STAND_GREET07 = 0x4BCB4C34
    NPC_FOLEY_CLOTHING_0H_STAND_HAPPY01 = 0xAD11189B
    NPC_FOLEY_CLOTHING_0H_STAND_HAPPY02 = 0xAD111898
    NPC_FOLEY_CLOTHING_0H_STAND_HAPPY03 = 0xAD111899
    NPC_FOLEY_CLOTHING_0H_STAND_HAPPY04 = 0xAD11189E
    NPC_FOLEY_CLOTHING_0H_STAND_HAPPY05 = 0xAD11189F
    NPC_FOLEY_CLOTHING_0H_STAND_HAPPY06 = 0xAD11189C
    NPC_FOLEY_CLOTHING_0H_STAND_HAPPY07 = 0xAD11189D
    NPC_FOLEY_CLOTHING_0H_STAND_HAPPY08 = 0xAD111892
    NPC_FOLEY_CLOTHING_0H_STAND_HAPPY09 = 0xAD111893
    NPC_FOLEY_CLOTHING_0H_STAND_NEUTRAL01 = 0x6A7ED79C
    NPC_FOLEY_CLOTHING_0H_STAND_NEUTRAL02 = 0x6A7ED79F
    NPC_FOLEY_CLOTHING_0H_TURN_L_120 = 0x61557725
    NPC_FOLEY_CLOTHING_0H_TURN_R_120 = 0x799CCD57
    NPC_FOLEY_CLOTHING_1H_INTERACT_IPAD03 = 0x9E246668
    NPC_FOLEY_CLOTHING_1H_INTERACT_IPAD04 = 0x9E24666F
    NPC_FOLEY_CLOTHING_1H_INTERACT_IPAD05 = 0x9E24666E
    NPC_FOLEY_CLOTHING_1H_SAD_LP01 = 0x1B899810
    NPC_FOLEY_CLOTHING_1H_STAND_ANGRY03 = 0x62053463
    NPC_FOLEY_CLOTHING_1H_STAND_ANGRY04 = 0x62053464
    NPC_FOLEY_CLOTHING_1H_STAND_NEUTRAL03 = 0xB895DC69
    NPC_FOLEY_CLOTHING_1H_STAND_NEUTRAL04 = 0xB895DC6E
    NPC_FOLEY_CLOTHING_1H_UNSHEATH_IPAD = 0xEEA97
    NPC_FOOTSTEPS_GENERIC = 0xEBEBBF24
    NPC_HANDHOLOGRAM = 0x826D3313
    NPC_ROBOT_FOOTSTEP = 0x72AB250
    NPC_SCIENCE_WORKSTATION_ARMS = 0x2AE4A2D5
    NPC_SHIP_ENGINE_FREIGHTER_FRONT = 0xA84C5D19
    NPC_SHIP_ENGINES = 0xB264012B
    NPC_SHIP_IDLE = 0x24526C1C
    NPC_SHIP_LAND = 0x87C20BE9
    NPC_SHIP_LAND_IMPACT = 0xD3FDB23A
    NPC_SHIP_LAND_ROTATE = 0xFA6D3689
    NPC_SHIP_LAND_ROTATE_STOP = 0xB736C13C
    NPC_SHIP_LASER = 0x922FB54B
    NPC_SHIP_LASERS01 = 0x71E894F3
    NPC_SHIP_LASERS02 = 0x71E894F0
    NPC_SHIP_LASERS03 = 0x71E894F1
    NPC_SHIP_LASERS04 = 0x71E894F6
    NPC_SHIP_POLICE_SIREN = 0xCEA4E032
    NPC_SHIP_POLICE_SIREN_STOP = 0xFB949B91
    NPC_SHIP_SCAN_PULSE = 0xD80B1123
    NPC_SHIP_SPACESTATION_FLYIN = 0xF746B237
    NPC_SHIP_TAKEOFF = 0xAA8DD0FA
    NPC_SHIPS_WARPIN = 0xA3176202
    NPC_SHIPS_WARPOUT = 0xCACADD3D
    NPC_SHIPSMALL_WARPIN = 0xC0106C54
    NPC_SHIPSMALL_WARPOUT = 0xA4CB6FF3
    NPC_SPEECH_CHATTER = 0xE46F6261
    NPC_TALK_STOP = 0xE4A1A5E6
    NPC_VOCAL_1H_ANGRY_STAND_03 = 0x9F5CFFE9
    NPC_VOCAL_1H_ANGRY_STAND_04 = 0x9F5CFFEE
    NPC_VOCAL_1H_NEUTRAL_STAND_03 = 0x5519FD7
    NPC_VOCAL_ANGRY_STAND01 = 0x36FAD9EA
    NPC_VOCAL_ANGRY_STAND02 = 0x36FAD9E9
    NPC_VOCAL_CHATTER_STAND_01 = 0x8C317B1F
    NPC_VOCAL_CHATTER_STAND_02 = 0x8C317B1C
    NPC_VOCAL_CHATTER_STAND_03 = 0x8C317B1D
    NPC_VOCAL_CHATTER_STAND_04 = 0x8C317B1A
    NPC_VOCAL_GREET_STAND_01 = 0x3547199B
    NPC_VOCAL_GREET_STAND_02 = 0x35471998
    NPC_VOCAL_GREET_STAND_03 = 0x35471999
    NPC_VOCAL_GREET_STAND_04 = 0x3547199E
    NPC_VOCAL_GREET_STAND_06 = 0x3547199C
    NPC_VOCAL_GREET_STAND_07 = 0x3547199D
    NPC_VOCAL_HAPPY_STAND_01 = 0xEBF7787C
    NPC_VOCAL_HAPPY_STAND_02 = 0xEBF7787F
    NPC_VOCAL_HAPPY_STAND_03 = 0xEBF7787E
    NPC_VOCAL_HAPPY_STAND_04 = 0xEBF77879
    NPC_VOCAL_HAPPY_STAND_05 = 0xEBF77878
    NPC_VOCAL_HAPPY_STAND_06 = 0xEBF7787B
    NPC_VOCAL_HAPPY_STAND_07 = 0xEBF7787A
    NPC_VOCAL_HAPPY_STAND_08 = 0xEBF77875
    NPC_VOCAL_IDLE_BASIC01 = 0x7EB4B73
    NPC_VOCAL_NEUTRAL_STAND_01 = 0xE4463E89
    NPC_VOCAL_NEUTRAL_STAND_02 = 0xE4463E8A
    NPC_VOCAL_SIT_ANGRY_01 = 0x1BC6EB37
    NPC_VOCAL_SIT_ANGRY_02 = 0x1BC6EB34
    NPC_VOCAL_SIT_CHATTER_01 = 0xBA70E1BB
    NPC_VOCAL_SIT_CHATTER_02 = 0xBA70E1B8
    NPC_VOCAL_SIT_GREET_01 = 0x3CF60EF3
    NPC_VOCAL_SIT_GREET_02 = 0x3CF60EF0
    NPC_VOCAL_SIT_HAPPY_01 = 0x8FD013FC
    NPC_VOCAL_SIT_HAPPY_02 = 0x8FD013FF
    NPC_WPN_FREIGHTER_GUN = 0xDBF6ADA4
    NPC_WPN_FREIGHTER_LASER = 0x87E7FDC7
    NPC_WPN_FREIGHTER_LASER_END = 0x965A42C9
    NPC_WPN_FREIGHTER_TURRET_FIRE = 0x2A924483
    NPC_WPN_FREIGHTER_TURRET_ROTATE = 0xE146872E
    NPC_WPN_FREIGHTER_TURRET_ROTATE_STOP = 0x65002B2D
    NPC_WPN_SMALLSHIP_LASER = 0xDD05AA14
    NPC_WPN_SMALLSHIP_LASER_STOP = 0xFAA48C13
    NPC_WPN_TORPEDO_LAUNCH = 0x3B44D26C
    NPC_WPN_TORPEDO_LP_STOP = 0xA8D00D38
    NPC_WPN_TURRET_START = 0x6AB593D2
    NPC_WPN_TURRET_STOP = 0x3C50938A
    OBJ_ATMOSPHERE_HARVESTER = 0x71246308
    OBJ_BARREL_MED = 0xC9953608
    OBJ_CRATE_LARGE = 0x613B2D40
    OBJ_CRATE_MED = 0xC5E4BAC7
    OBJ_CRATE_SMALLA = 0x6B9851E9
    OBJ_CRATE_SMALLB = 0x6B9851EA
    OBJ_FLAG = 0x4D907B09
    OBJ_HARVESTER = 0x4099D393
    OBJ_HEALTHSTATION_OFF = 0x777473D5
    OBJ_HEALTHSTATION_ON = 0xD2519969
    OBJ_MINING_AMU = 0x5F04D3FD
    OBJ_MINING_GAS_HARVESTER = 0xD278D30E
    OBJ_MONOLITH = 0xAFF212EB
    OBJ_PLAQUE = 0x6E4AAD8B
    OBJ_PORTABLEREFINERY_START = 0x318F8A43
    OBJ_PORTABLEREFINERY_STOP = 0xC52354C1
    OBJ_REFINERYLARGE_IDLE = 0x344C4FB9
    OBJ_REFINERYLARGE_START = 0xA7C2D6AD
    OBJ_REFINERYLARGE_STOP = 0x2745AFEF
    OBJ_REFINERYMEDIUM_IDLE = 0xF037F80F
    OBJ_REFINERYMEDIUM_START = 0xC27FE2E7
    OBJ_REFINERYMEDIUM_STOP = 0x4A31510D
    OBJ_ROBOTHEAD = 0x91611EAB
    OBJ_ROBOTHEAD_HAND = 0xBB49D295
    OBJ_RUINS_RESOURCE_LP = 0x57539186
    OBJ_SHIELD_REPAIRER_OFF = 0x2D439567
    OBJ_SHIELD_REPAIRER_ON = 0x5D1B7B93
    OBJ_SPINNINGCHAIR = 0x31D21E68
    OBJ_SPINNINGGLOBE = 0x2E2F03EC
    OBJ_SPINNINGSHAPE = 0x6BD9CA70
    OBJ_STANDINGSTONE_ACTIVATE = 0x994C77D2
    OBJ_STANDINGSTONE_RARE = 0xA4603971
    OBJ_STANDINGSTONES = 0x5CEA7805
    OBJ_WAYPOINT = 0xEB0C2542
    OBJECT_ANALYSING = 0x18EF30C7
    OBJECT_OF_INTEREST = 0x7C61D8C5
    OBSERVATORY_HOLOGRAM = 0x4587B823
    OCTO_IDLE_FR1 = 0x4982E72D
    OCTO_IDLE_FR145 = 0x1136566C
    OCTO_IDLE_FR353 = 0x1C3AE4EB
    OCTO_IDLE_FR575 = 0x9E2CA6C1
    OCTO_IDLE_FR780 = 0x91310F9B
    OCTO_SPRINGWALK_FR1 = 0x3FA36967
    OCTO_SPRINGWALK_FR161 = 0x50F34D8
    OCTO_WALK_FR1 = 0xD7EC18B8
    OCTO_WALK_FR145 = 0x890DC0A1
    OCTO_WALK_FR353 = 0xE130F12
    OCTO_WALK_FR575 = 0xFC176FCC
    OCTO_WALK_FR780 = 0x811CBEB6
    OILSTREAM = 0x607B82D7
    ORBIDLE = 0xE0625692
    ORBIDLE_LOOP = 0xAAD2AC93
    PARTICLES_DUSTDEVIL = 0x73BA60C9
    PARTICLES_DUSTDEVIL_STOP = 0x88C0177C
    PARTICLES_ELECTRICAL_SPARKS = 0xFC91F6C0
    PARTICLES_ELECTRICAL_SPARKS_STOP = 0xE475E6EF
    PARTICLES_ELECTRICALANOMALY = 0x94FDA5E6
    PARTICLES_ELECTRICALANOMALY_STOP = 0x4736D7F5
    PARTICLES_GEOTHERMAL = 0x3AC18629
    PARTICLES_GEOTHERMAL_EXPLODE = 0x2C5CFB0B
    PARTICLES_GEOTHERMAL_STOP = 0x509A891C
    PARTICLES_GRAVITYINVERSION = 0xCC383C04
    PARTICLES_GRAVITYINVERSION_STOP = 0x3D3A9E63
    PARTICLES_LAVAVENT = 0xD8080D82
    PARTICLES_LAVAVENT_EXPLODE = 0xF72E024
    PARTICLES_LAVAVENT_STOP = 0xC2360C01
    PARTICLES_RADIOANOMALY = 0x72F46861
    PARTICLES_RADIOANOMALY_STOP = 0x2609864
    PARTICLES_SPARKS_COMMON = 0x89739B49
    PARTICLES_SPARKS_COMMON_STOP = 0x9D9126FC
    PARTICLES_TOXICCLOUD = 0x1278E4D9
    PARTICLES_TOXICCLOUD_STOP = 0xB205BCAC
    PET_EGG_INDUCE = 0x979DE509
    PET_EGGSPLOSION = 0x874B2413
    PET_UI_ADOPT = 0xBA4E41AE
    PET_UI_CALLPET = 0x507485B
    PET_UI_COLLECT_EGGS = 0x23B82F2F
    PET_UI_CUSTOM_FLANK = 0xBB6990AA
    PET_UI_CUSTOM_SELECT = 0x7F84507C
    PET_UI_DISMISS = 0x6797B7FC
    PET_UI_EGG_HATCH = 0x92C0559C
    PET_UI_FOOD_PELLET = 0x60B750C1
    PET_UI_MENU_HOVER = 0x64BD01EE
    PET_UI_PAT = 0xFEAFB237
    PET_UI_SUMMON = 0x716F5B99
    PET_UI_TREAT = 0x28CCAA60
    PILGRIM_BOOST_START = 0x5D72659C
    PILGRIM_BOOST_STOP = 0xAB53D70
    PILGRIM_HORN_START = 0xEDE0C7A2
    PILGRIM_HORN_STOP = 0xDE95EC9A
    PILGRIM_IDLE_EXTERIOR = 0x698C1BA7
    PILGRIM_IMPACTS = 0x7D8D4FFD
    PILGRIM_JUMP = 0xE6D853F8
    PILGRIM_START = 0x1AA44330
    PILGRIM_STOP = 0xCEC2C09C
    PILGRIM_SUSPENSION = 0x6EFEA44F
    PIPE_SMOKE = 0xD9CB4AF
    PIPE_SMOKE_STOP = 0xC85D689A
    PIRATE_SALVAGE_CHAIR_SPIN = 0x839C9669
    PIRATE_STATION_GENERATOR = 0xC421C6D5
    PIRATE_STATIONCORE = 0xED62DD76
    PL_BREATHING_START = 0x8D7EFCF7
    PL_BREATHING_STOP = 0x73C9C55D
    PL_CAMOUFLAGE_IN = 0x4E6C24EA
    PL_CAMOUFLAGE_OUT = 0x793836C5
    PL_DAMAGE_WARNING_LOW_HEALTH_LP = 0x9AE9352D
    PL_DAMAGE_WARNING_LOW_HEALTH_LP_STOP = 0x1AD6B960
    PL_DAMAGE_WARNING_SHIELD_LOSS = 0x5BE3084
    PL_FISHING_LINE_PULL = 0x4148A197
    PL_FISHING_LINE_PULL_STOP = 0xC6256932
    PL_FOLEY_BODYHITS = 0x915FF2EE
    PL_FOLEY_CLOTHING_0H_SWIM_BACK = 0x3DEA4F58
    PL_FOLEY_CLOTHING_0H_SWIM_FORWARD = 0xFABD31D4
    PL_FOLEY_CLOTHING_0H_SWIM_IDLE = 0x50A7E0CF
    PL_FOLEY_CLOTHING_0H_SWIM_LEFT_RIGHT = 0xBA7587F5
    PL_FOLEY_CLOTHING_1H_MULTITOOL_MELEE = 0x9D96CD91
    PL_FOLEY_CLOTHING_1H_OVERHEAT = 0x10B47D33
    PL_FOLEY_CLOTHING_1H_RELOAD = 0xD9219578
    PL_FOLEY_CLOTHING_2H_MULTITOOL_MELEE = 0xD63657DC
    PL_FOLEY_CLOTHING_2H_MULTITOOLRELOAD = 0x3036188A
    PL_FOLEY_CLOTHING_DEATH_KNEES = 0xC5403F26
    PL_FOLEY_CLOTHING_DEATH_SWIM = 0x5FC94D6
    PL_FOLEY_CLOTHING_EMOTE_CALLPET = 0x7F9262A7
    PL_FOLEY_CLOTHING_EMOTE_DANCEINTO = 0x843BC963
    PL_FOLEY_CLOTHING_EMOTE_FALLKNEESINTO = 0x9E81C443
    PL_FOLEY_CLOTHING_EMOTE_FALLKNEESLP = 0x846370D
    PL_FOLEY_CLOTHING_EMOTE_FEED = 0x16F3DD78
    PL_FOLEY_CLOTHING_EMOTE_GREET_WAVE = 0x451D518D
    PL_FOLEY_CLOTHING_EMOTE_HEROICINTO = 0x6C7928E2
    PL_FOLEY_CLOTHING_EMOTE_LOOKDISTANCEINTO = 0xEC9B5CE
    PL_FOLEY_CLOTHING_EMOTE_MINDBLOWN = 0x8CC7D7CE
    PL_FOLEY_CLOTHING_EMOTE_NEG_FINGERWAG = 0xC74E5AF9
    PL_FOLEY_CLOTHING_EMOTE_POINT = 0x8685F006
    PL_FOLEY_CLOTHING_EMOTE_RELAXINTO = 0xAA4B1AAC
    PL_FOLEY_CLOTHING_EMOTE_SITINTO = 0x71A2E776
    PL_FOLEY_CLOTHING_EMOTE_STROKE = 0x2056D3D0
    PL_FOLEY_CLOTHING_EMOTE_THUMBSUP = 0x1B2E5FE8
    PL_FOLEY_CLOTHING_EMOTE_WONDER = 0x90D499C5
    PL_FOLEY_CLOTHING_FALL_CONTROL = 0xAA776AEA
    PL_FOLEY_CLOTHING_FALL_PANIC = 0xE28BA57C
    PL_FOLEY_CLOTHING_IDLE_WEIGHT_SHIFT = 0x48554711
    PL_FOLEY_CLOTHING_JOG_TO_IDLE = 0x31229EF8
    PL_FOLEY_CLOTHING_LADDER_CYCLE_DOWN = 0xA5310BB
    PL_FOLEY_CLOTHING_LADDER_CYCLE_UP = 0x3D3DDF5C
    PL_FOLEY_CLOTHING_LADDER_DISMOUNT_BOTTOM = 0x8FF84B91
    PL_FOLEY_CLOTHING_LADDER_DISMOUNT_TOP = 0xB5A5F559
    PL_FOLEY_CLOTHING_LADDER_MOUNT_BOTTOM = 0xF4ED6D9D
    PL_FOLEY_CLOTHING_LADDER_MOUNT_TOP = 0xFE176015
    PL_FOLEY_CLOTHING_LOCO = 0xB79EA60A
    PL_FOLEY_CLOTHING_MULTITOOL_DRAW = 0x9B2BB175
    PL_FOLEY_CLOTHING_MULTITOOL_HOLSTER = 0xAA65F0D4
    PL_FOLEY_CLOTHING_MULTITOOL_OVERHEAT = 0x1BD229F3
    PL_FOLEY_CLOTHING_MULTITOOL_RELOAD = 0x5C1C938
    PL_FOLEY_CLOTHING_RUN_TO_IDLE = 0x73450387
    PL_FOLEY_CLOTHING_SWIM_STOPALL = 0x7F90AA67
    PL_FOLEY_EMOTE_DANCELOOP = 0xD832CAD2
    PL_FOLEY_EMOTE_HELP = 0x3EAC0F72
    PL_FOLEY_EMOTE_JOY = 0xB65D913
    PL_FOLEY_EMOTE_LAUGH = 0x953BF62E
    PL_FOLEY_EMOTE_NEEDRESOURCE = 0xF62E41F3
    PL_FOLEY_EMOTE_OVERHERE = 0x7B06DE1F
    PL_FOLEY_EMOTE_UNDERWATER_OK = 0xC10135E9
    PL_FOLEY_EMOTE_UNDERWATER_THUMBSDOWN = 0x920C1178
    PL_FOLEY_EMOTE_UNDERWATER_THUMBSUP = 0xC732E21B
    PL_FOLEY_FISHING_CASTOFF = 0x889F330F
    PL_FOLEY_FISHING_FLICK = 0x34157F46
    PL_FOLEY_FISHING_LAND_FISH = 0x21FA9047
    PL_FOLEY_FISHING_LINE_STOP = 0x80D9F8E2
    PL_FOLEY_FISHING_REEL_IN = 0x36BDB29D
    PL_FOLEY_FISHING_STOP = 0x6581AFD5
    PL_FOLEY_SLOPE_SLIDE_START = 0xD922A3D6
    PL_FOLEY_SLOPE_SLIDE_STOP = 0xE2280BD6
    PL_HAZARD_CRITICAL_HIT = 0x95BC4F32
    PL_HAZARD_RECOVERY = 0x9A6776
    PL_HAZARD_WARNING = 0xD0D988E1
    PL_HEALTH = 0xB050FA76
    PL_OUTOFBREATH = 0x2AC9FF29
    PL_PROTECTION_CHARGE = 0xE20B8CE4
    PL_PROTECTION_END = 0x38657B27
    PL_PROTECTION_LP = 0x1D037974
    PL_RUN_FAIL = 0xD51DCF4E
    PL_SHIELD_CHARGE = 0x969598CA
    PL_SHIELD_HIT = 0x17D34A45
    PL_SHIELD_LOWSWEEP = 0xCBBD44C4
    PL_SHIELD_SHIP_HIT_BIG = 0x74EB2D51
    PL_SHIELD_SHIP_HIT_SMALL = 0x768B8A3E
    PL_SHIP_BOOST_FAIL = 0x9A4E27BD
    PL_SHIP_BOOST_POWERUP = 0x62CDCDDB
    PL_SHIP_BOOST_START = 0xCDB230F3
    PL_SHIP_BOOST_STOP = 0x6B0B4731
    PL_SHIP_BURN = 0xB0660BE
    PL_SHIP_BURN_STOP = 0x958071DD
    PL_SHIP_COCKPIT_RAIN = 0x2380A5E5
    PL_SHIP_COCKPIT_RAIN_STOP = 0xBBD86828
    PL_SHIP_ENGINES_START = 0x7FBDB4F7
    PL_SHIP_ENGINES_START_REMOTE = 0x38FAB124
    PL_SHIP_ENGINES_STOP = 0xE8A32D5D
    PL_SHIP_ENGINES_STOP_REMOTE = 0x46E00B8A
    PL_SHIP_ENTER = 0x17D409FD
    PL_SHIP_EXIT = 0x2F3259B1
    PL_SHIP_GROUND_IMPACT = 0x2CE59259
    PL_SHIP_HASLANDED = 0xB585E053
    PL_SHIP_HASLANDED_RACER = 0xEDFA38D
    PL_SHIP_HYPERSPACE_END = 0xC1AE6E4B
    PL_SHIP_HYPERSPACE_START = 0x4AA4CB30
    PL_SHIP_IDLE = 0xFC4A8773
    PL_SHIP_LANDING = 0xB35579F6
    PL_SHIP_MINIWARP_COUNTDOWN = 0x5064D24A
    PL_SHIP_MINIWARP_END = 0x53B4B6F4
    PL_SHIP_MINIWARP_JUMP = 0xA54A1259
    PL_SHIP_RACER_LANDING = 0x23B40F78
    PL_SHIP_RACER_TAKEOFF = 0xB52D6DE5
    PL_SHIP_ROBOT_CARRIAGELOCK_LANDING = 0xECF68579
    PL_SHIP_ROBOT_CARRIAGELOCK_TAKEOFF = 0x19B453B0
    PL_SHIP_ROBOT_CHUNKYLEGS_LANDING = 0xECF46219
    PL_SHIP_ROBOT_CHUNKYLEGS_TAKEOFF = 0x19B23150
    PL_SHIP_ROBOT_FLIPWINGS_LANDING = 0x461EB821
    PL_SHIP_ROBOT_FLIPWINGS_TAKEOFF = 0xEC758F8
    PL_SHIP_ROBOT_HUGGINGWALLWINGS_LANDING = 0x1D6C0DD1
    PL_SHIP_ROBOT_HUGGINGWALLWINGS_TAKEOFF = 0xDE705488
    PL_SHIP_ROBOT_LANDINGGEAR_LANDING = 0x97B8DB7E
    PL_SHIP_ROBOT_LANDINGGEAR_TAKEOFF = 0xB9990F
    PL_SHIP_ROBOT_NEEDLEWINGS_LANDING = 0x30C68E35
    PL_SHIP_ROBOT_NEEDLEWINGS_TAKEOFF = 0x1D1BD23C
    PL_SHIP_ROBOT_SKIRTWINGS_LANDING = 0xBF6FFECD
    PL_SHIP_ROBOT_SKIRTWINGS_TAKEOFF = 0x4F094A34
    PL_SHIP_ROBOT_TOPWINGS_LANDING = 0x3E9FD09D
    PL_SHIP_ROBOT_TOPWINGS_TAKEOFF = 0x491445A4
    PL_SHIP_ROBOT_WALLWINGS_LANDING = 0xC04C033E
    PL_SHIP_ROBOT_WALLWINGS_TAKEOFF = 0x26D258CF
    PL_SHIP_SCANNED = 0xE2A36147
    PL_SHIP_SHIELD_DOWN = 0x7DC5CDE9
    PL_SHIP_SPACESTATION_LAUNCH_END = 0x824C1ACD
    PL_SHIP_SPARKS = 0x3A41BA4B
    PL_SHIP_SPARKS_STOP = 0x5E131FC6
    PL_SHIP_START_ACTIVE = 0x53F54244
    PL_SHIP_TAKEOFF = 0x1EA46787
    PL_SHIP_TAKEOFF_WHENREMAININSHIP = 0x67C6E21D
    PL_SHIP_THRUST_ONESHOTS = 0xDA41B521
    PL_SHIP_THRUST_REVERSE_ONESHOTS = 0xB71468B0
    PL_SHIP_TRANSITION_TO_PLANET_END = 0x102A0FD3
    PL_SHIP_TRANSITION_TO_PLANET_START = 0x6693D868
    PL_SHIP_TRANSITION_TO_SPACE_END = 0xF8BCF39
    PL_SHIP_TRANSITION_TO_SPACE_START = 0xB630765A
    PL_SHIP_VR_EXIT = 0x88814C78
    PL_SHIP_VR_EXIT_STOP = 0xFB5202B7
    PL_SHIP_WARP = 0x8D21AECF
    PL_SUIT_START = 0xA22F68E2
    PL_SUIT_STARTUP = 0x68319AB9
    PL_SUIT_STARTUP_CONFIRM = 0xCB37B9FC
    PL_SUIT_STARTUP_INTERACT_TIMER = 0x3C572AD4
    PL_SUIT_STARTUP_INTERACT_TIMER_STOP = 0xD1B12CD3
    PL_SUIT_STOP = 0xA1E440DA
    PL_SURVEYING = 0x64B2EA2A
    PL_SURVEYING_C = 0xC44E4630
    PL_SURVEYING_DISCOVER = 0x5CFC7900
    PL_SURVEYING_HIGHLIGHT = 0x5D0CC4E3
    PL_SURVEYING_L = 0xC44E463F
    PL_SURVEYING_R = 0xC44E4621
    PL_SURVEYING_SWITCHTO = 0x12FAB8BA
    PL_TELEPORT_WARP_END = 0xCAD30640
    PL_TELEPORT_WARP_START = 0xC5955A1B
    PL_VEHICLE_REMOTE_BOOST = 0xC188029
    PL_VEHICLE_REMOTE_DESTRUCTIBLE = 0xF466485A
    PL_VEHICLE_REMOTE_ENGINE = 0xABFB7216
    PL_VEHICLE_REMOTE_HORN = 0xC8F8145B
    PL_VEHICLE_REMOTE_IDLE = 0x27EBC5B6
    PL_VEHICLE_REMOTE_IMPACTS = 0xF9B16951
    PL_VEHICLE_REMOTE_JUMP = 0x934AB5F4
    PL_VEHICLE_REMOTE_START = 0xE2B75F44
    PL_VEHICLE_REMOTE_STOP = 0xED8F65F8
    PL_VEHICLE_REMOTE_SURFACE = 0x3B76DFB9
    PL_VEHICLE_REMOTE_SUSPENSION = 0x3B127ED3
    PL_WOUND = 0x82AA4045
    PL_WPN_SHIP_MISSILE_SHOOT = 0x404C8523
    PLACEMARKER_FLARE = 0xA539AE71
    PLACEMARKER_IMPACT = 0x5FC8A561
    PLACEMARKER_LP = 0x36097177
    PLACEMARKER_LP_STOP = 0xEDF59752
    PLACEMARKER_WOOSH = 0xCA202279
    PLANT_ATTACK = 0x4D6B4503
    PLANT_CLOSE = 0x7E3854F5
    PLANT_GASGIANT_STEAMER = 0x299D71F5
    PLANT_GATHER_ALOEFLESH = 0x755AFF3C
    PLANT_GATHER_FIREBERRY = 0x8716FE03
    PLANT_GATHER_FROZENTUBERS = 0xCFD83A4
    PLANT_GATHER_GRAHFRUIT = 0x20134DA1
    PLANT_GATHER_HEPTAWHEAT = 0x153FCA3A
    PLANT_GATHER_IMPULSEBEANS = 0x9063D3AF
    PLANT_GATHER_JADEPEAS = 0x4ED86D0A
    PLANT_GATHER_PULPYROOTS = 0xCEF5472C
    PLANT_GATHER_SWEETROOT = 0x682532C3
    PLANT_ILLUMINATED = 0x426CF1E7
    PLANT_ILLUMINATED_STOP = 0x914B3AA2
    PLANT_RADIOACTIVE_STEAMER = 0xB02F895A
    PLANTCAT_ATTACK01 = 0x383D5896
    PLANTCAT_ATTACK02 = 0x383D5895
    PLANTCAT_ATTACK03 = 0x383D5894
    PLANTCAT_DEATH = 0x43C5BD2F
    PLANTCAT_DETBARK01 = 0x663EDCA9
    PLANTCAT_EAT_FR1 = 0xB52848FF
    PLANTCAT_EAT_FR160 = 0xDA4D5A71
    PLANTCAT_HAPPY01_FR1 = 0x188B5BAE
    PLANTCAT_HAPPY01_FR111 = 0xF7356EF0
    PLANTCAT_PAIN = 0x86694E27
    PLANTCAT_PERFORM02 = 0xC37D5314
    PLANTCAT_PERFORM03 = 0xC37D5315
    PLANTCAT_PERFORM04 = 0xC37D5312
    PLANTCAT_PERFORMATK = 0x1F12F18C
    PLANTCAT_POUNCE = 0x6E38D3C5
    PLANTCAT_ROAR = 0x6F09349F
    PLANTCAT_SAD01 = 0xE7CCA134
    PLANTCAT_SLEEPEND = 0x76AF1AEF
    PLANTCAT_SLEEPSTART = 0x91D5C44C
    PLAQUE_END = 0xA28CC67
    PLAQUE_LOOP = 0x841DC68A
    PLAQUE_START = 0x12497354
    PLAY_BASE_POWER_CONNECT = 0x12E999E4
    PLAY_MAP_CENTRECHORD_01_INDEX_01_MAP_CENTRECHORD_01 = 0xD6A75CD2
    PLAY_MAP_CENTRECHORD_02_INDEX_01_MAP_CENTRECHORD_02 = 0x124A4FFA
    PLAY_MAP_DRONENOISE_01_INDEX_01_MAP_SPACE_NOISE_DRONE = 0xF270DBF0
    PLAY_MAP_DRONENOISE_02_INDEX_01_MAP_SPACE_NOISE_DRONE_RR = 0x57C811D0
    PLAY_MAP_DRONETONE_01_INDEX_01_MUS_MAP1_DRONE_E = 0x2E489D33
    PLAY_MAP_PIANO_INDEX_01_MUS_MAP01_PIANO_01 = 0xB99E1F47
    PLAY_MAP_SINGLES_01_INDEX_01_MUS_MAP01_SINGLES1_04 = 0x614FBC55
    PLAY_MAP_SINGLES_02_INDEX_01_MUS_MAP01_SINGLES2_09 = 0x7F6217FC
    PLAY_MAP_ZONE01_INDEX_01_MAP_ZONE01 = 0x5908A1EE
    PLAY_MAP_ZONE02_INDEX_01_MAP_ZONE02 = 0x827E6B9A
    PLAY_MAP_ZONE02_SINGLES_INDEX_01_ZONE02_SINGLES02 = 0x7B91D5E9
    PLAY_PL_BASS_INDEX_01_MONOLITH_BOWEDBASSGTR_GMIN_6 = 0x67E0BFCD
    PLAY_PL_BASS_INDEX_07_MONOLITH_BOWEDBASSGTR_GMIN_1 = 0x7E462BF8
    PLAY_PL_BASS_INDEX_26_MELB_PLANETBASS_8 = 0x5659A098
    PLAY_PL_CELLO_INDEX_07_EOTWS_CELLO_1 = 0xC0A831E6
    PLAY_PL_DRONE_01_INDEX_01_EQUINOXSOFT_EMIN_2 = 0x400244DF
    PLAY_PL_DRONE_01_INDEX_03_SM_VOX_GRANULAR_DMIN_1 = 0xDE1DF727
    PLAY_PL_DRONE_01_INDEX_08_ASCENSION_SPACE_6 = 0x7BD641CF
    PLAY_PL_DRONE_01_INDEX_10_TETSUO_VOXTEXTURE_1 = 0xC156BA58
    PLAY_PL_DRONE_01_INDEX_13_BEYOND_PLANETDRONE_9 = 0x4FF2963A
    PLAY_PL_DRONE_01_INDEX_14_EOTWSALT_STRINGHOLD_7 = 0x69C8FFA1
    PLAY_PL_DRONE_01_INDEX_16_BOREALIS_GTRDELAY_AMIN_7 = 0x133D7B99
    PLAY_PL_DRONE_01_INDEX_18_NMS2017_MIDS_52 = 0x828A5D91
    PLAY_PL_DRONE_01_INDEX_20_TUNG_PLANET_TEXTURE_2 = 0xEC21FBBE
    PLAY_PL_DRONE_01_INDEX_21_OCT_TEXTURE_39 = 0xF466613E
    PLAY_PL_DRONE_01_INDEX_23_ECHO_PLANETLOWEND_15 = 0xC995CA0F
    PLAY_PL_DRONE_01_INDEX_24_DOMO_PLANETIRIS_2 = 0x5652655A
    PLAY_PL_DRONE_01_INDEX_25_SCRAPER_PLANETROOTS_6 = 0x6C589FF4
    PLAY_PL_DRONE_01_INDEX_27_OVERSEER_PLANETACOUSTICBED_5 = 0xDBCF152F
    PLAY_PL_DRONE_01_INDEX_28_SCRAPER_PLANETROOTS_11 = 0x9DE016C7
    PLAY_PL_DRONE_02_INDEX_01_TOMORROW_FM_1 = 0x57C9311D
    PLAY_PL_DRONE_02_INDEX_08_TOMORROW_FM_CHOPPED_1 = 0x1087A406
    PLAY_PL_DRONE_02_INDEX_14_EOTWSALT_STRINGLOOP_3 = 0xED13C371
    PLAY_PL_DRONE_02_INDEX_18_NMS2017_POLYHIGH_1 = 0x4753E199
    PLAY_PL_DRONE_02_INDEX_25_SCRAPER_PLANETWEIRDARP_1 = 0xC2C438B5
    PLAY_PL_DRONE_02_INDEX_28_SCRAPER_PLANETGTRTEXTURE_8 = 0xACFC51A7
    PLAY_PL_FX_01_INDEX_01_BOWEDCYMBAL_CLEAN_6 = 0x588F99C5
    PLAY_PL_FX_01_INDEX_03_SM_ATMOS_DMIN_4 = 0x4635AF44
    PLAY_PL_FX_01_INDEX_06_EV_PLANETNOISE_9 = 0x5C56712E
    PLAY_PL_FX_01_INDEX_14_EOTWSALT_CRACKLE_2 = 0x2519853
    PLAY_PL_FX_01_INDEX_15_HAUNTED_ARCTIC_EMIN_3 = 0x68DFC6E
    PLAY_PL_FX_01_INDEX_17_APORIA_PLANET_ROBOT_14 = 0xE0D1741E
    PLAY_PL_FX_01_INDEX_18_NMS2017_IMPACTS_3 = 0x9BF2BB69
    PLAY_PL_FX_01_INDEX_19_TUES_PLANETTREMOR_17 = 0x8D44671A
    PLAY_PL_FX_01_INDEX_25_DASKA_PLANETTHUD = 0xF8EB165F
    PLAY_PL_FX_01_INDEX_27_OVERSEER_PLANETTHUMPS_9 = 0x1311F2DC
    PLAY_PL_FX_02_INDEX_03_BOWEDCYMBAL_CHOPDISTORT_22 = 0x8F5FF60A
    PLAY_PL_FX_03_INDEX_03_SM_HHPATTER_6 = 0x2C589B01
    PLAY_PL_GUITAR_01_INDEX_01_MONOLITH_PLANET_GTRSOUNDSCAPE_5 = 0xCF8CADD5
    PLAY_PL_GUITAR_01_INDEX_02_ASIM_PLANET_PAULGTR_5 = 0x6FBE88C7
    PLAY_PL_GUITAR_01_INDEX_03_SM_PLANET_ATMOSGTR_DMIN_3 = 0x8732317B
    PLAY_PL_GUITAR_01_INDEX_04_BLUEPRINT_BOWEDGTR_EMIN_31 = 0x8831B83
    PLAY_PL_GUITAR_01_INDEX_06_EV_PLANETGTR_5 = 0xF7207851
    PLAY_PL_GUITAR_01_INDEX_12_ATWOOD_GTRVERB_7 = 0xADA95082
    PLAY_PL_GUITAR_01_INDEX_13_LULL_GTR_16 = 0xD0ACF4C1
    PLAY_PL_GUITAR_01_INDEX_15_HAUNTED_GTRSHARK_EMIN_4 = 0x4E2457C5
    PLAY_PL_GUITAR_01_INDEX_16_MONOALT_PLANETMALLETFX_6 = 0x255A1F5C
    PLAY_PL_GUITAR_01_INDEX_19_TUES_PLANETGTR_3 = 0x4D7ACD5F
    PLAY_PL_GUITAR_01_INDEX_22_VOSTOK_BOWEDGTR_1 = 0xE45DFE19
    PLAY_PL_GUITAR_01_INDEX_23_ECHO_PLANETGTRBED_9 = 0xBC265BCF
    PLAY_PL_GUITAR_01_INDEX_25_DASHKA_JOEGTR_5 = 0x9165FEF
    PLAY_PL_GUITAR_01_INDEX_26_MELB_PLANETGTR_3 = 0x7A3F4310
    PLAY_PL_GUITAR_02_INDEX_02_ASIM_PLANET_MALLETGTR_BMIN_4 = 0xA9F582C1
    PLAY_PL_GUITAR_02_INDEX_04_BLUEPRINT_GTRTEXTURE_EMIN_5 = 0xF7BDE53
    PLAY_PL_GUITAR_02_INDEX_22_VOSTOK_BOWEDGTRREV_18 = 0x49DDA12D
    PLAY_PL_GUITAR_03_INDEX_02_ASIM_PLANET_MALLETGTRTWO_BMIN_2 = 0x6C2FABF8
    PLAY_PL_GUITAR_04_INDEX_02_ASIM_PLANET_JOEGTRWASHSOFT_BMIN_4 = 0x6730E015
    PLAY_PL_GUITARDRONE_INDEX_01_DEPARTURE_GTR_EMIN_1 = 0xE4ED3E1B
    PLAY_PL_GUITARDRONE_INDEX_08_DEPARTURE_GTR_EMIN_1 = 0x823E3728
    PLAY_PL_GUITARFAST_INDEX_01_CELESTIAL_GTRLOOP_2 = 0x30097230
    PLAY_PL_GUITARFAST_INDEX_08_CELESTIAL_GTRLOOP_3 = 0x3D1FC51C
    PLAY_PL_HIGHCELLO_INDEX_09_RIPLEY_CELLOHIGHER_1 = 0x851502B6
    PLAY_PL_HIGHSYNTH_INDEX_08_CELESTIAL_HIGH_2 = 0xB4547CC4
    PLAY_PL_HIGHSYNTH_INDEX_19_TUES_PLANETHIGH_2 = 0xF7E7F471
    PLAY_PL_HIGHSYNTH_INDEX_20_TUNG_PLANET_PIANOHIGHINT_21 = 0xEA6A0F56
    PLAY_PL_HIGHSYNTH_INDEX_24_DOMO_PLANETHIGHINTEREST_2 = 0x11BE54A5
    PLAY_PL_HIGHSYNTH_INDEX_25_SCRAPER_PLANETGTRMELS_4 = 0x67648F5
    PLAY_PL_HIGHSYNTH_INDEX_27_OVERSEER_PLANETHIGHINTEREST_5 = 0xEF9D0195
    PLAY_PL_MELODY_HI_INDEX_01_MONLITH_PLANET_PIANOMELVERB_1 = 0xD3074360
    PLAY_PL_MELODY_HI_INDEX_02_ASIM_PLANETJUNO_BMIN_7 = 0xA6CE8694
    PLAY_PL_MELODY_HI_INDEX_03_SM_PIANOHIGH_DMIN_5 = 0xA92BA318
    PLAY_PL_MELODY_HI_INDEX_05_REDPARA_CELESTA_9 = 0x7EC0D2BC
    PLAY_PL_MELODY_HI_INDEX_06_EV_HIGHINTEREST_1 = 0x22EB2562
    PLAY_PL_MELODY_HI_INDEX_10_TETSUO_PLANETHI_1 = 0xB4503E43
    PLAY_PL_MELODY_HI_INDEX_11_AKIRA_PLANETPIANO_1 = 0xCDB93632
    PLAY_PL_MELODY_HI_INDEX_13_LULL_PIANO_8 = 0xF678F5FC
    PLAY_PL_MELODY_HI_INDEX_14_EOTWS_PIANOLOOP_4 = 0xBF265D1A
    PLAY_PL_MELODY_HI_INDEX_15_HAUNTED_SHARKUPCLOSE_EMIN_7 = 0xDAB6CF40
    PLAY_PL_MELODY_HI_INDEX_16_MONOALT_REVPIANO_11 = 0x7E23BA9F
    PLAY_PL_MELODY_HI_INDEX_18_NMS2017_MODMELS_2 = 0xD0BF75D2
    PLAY_PL_MELODY_HI_INDEX_21_OCT_HIGHMEL_11 = 0x7D9658D5
    PLAY_PL_MELODY_HI_INDEX_22_VOSTOK_PLANETHIGH_7 = 0xE059651B
    PLAY_PL_MELODY_HI_INDEX_25_DASKA_PLANETHIGHINTEREST_12 = 0xFC6719FE
    PLAY_PL_MELODY_HI_INDEX_27_OVERSEER_PLANETACOUSTIC_13 = 0x39F704ED
    PLAY_PL_MELODY_HI_INDEX_28_SCRAPER_PLANETGTRMELS_7 = 0x6123AC43
    PLAY_PL_MELODY_INDEX_25_DASHKA_PLANETLOOPS_6 = 0x9161064A
    PLAY_PL_MELODY_INDEX_28_SCRAPER_PLANETWEIRDARP_2 = 0x114B8E0E
    PLAY_PL_MUSICBOX_INDEX_01_MUSICBOXLONG_EMIN = 0x5CCD8909
    PLAY_PL_MUSICBOX_INDEX_08_MUSICBOXLONG_EMIN = 0x9F8539B4
    PLAY_PL_PIANO_INDEX_09_RIPLEY_PIANOHI_1 = 0x57B0FC0A
    PLAY_PL_PIANO_INDEX_11_AKIRA_PLANETPIANOREV_18 = 0xF72C407C
    PLAY_PL_PIANO_INDEX_12_ATWOOD_PIANO_5 = 0x6E236852
    PLAY_PL_PIANO_INDEX_17_APORIA_PLANETSINEKEYS_2 = 0x83E153A2
    PLAY_PL_PIANO_INDEX_20_TUNG_PLANET_PIANO_2 = 0x1E867B77
    PLAY_PL_PIANO_INDEX_22_VOSTOK_PLANETKEYS_19 = 0xF34CEC83
    PLAY_PL_PIANO_INDEX_23_ECHO_PIANOHIGH_2 = 0x280B0EAA
    PLAY_PL_PIANO_INDEX_24_DOMO_PLANETBURN_3 = 0xE874446A
    PLAY_PL_STRINGS_INDEX_09_RIPLEY_CELLO_1 = 0x61AF6512
    PLAY_PL_STRINGS_INDEX_17_APORIA_PLANETSOFTBED_2 = 0x975FE591
    PLAY_PL_SYNTH_INDEX_01_CELESTIAL_MOD_1 = 0xC1740844
    PLAY_PL_SYNTH_INDEX_05_REDPARA_SPACEFROST_AMIN_1 = 0x8B892521
    PLAY_PL_SYNTH_INDEX_08_CELESTIAL_MOD_8 = 0x70304420
    PLAY_PL_SYNTH_INDEX_13_BEYOND_SLOWSYNTH_6 = 0xB7D8EC9E
    PLAY_PL_SYNTH_INDEX_15_HAUNTED_DIGITALSHARK_EMIN_2 = 0x480E9420
    PLAY_PL_SYNTH_INDEX_17_APORIA_PLANETREAMPTEXTURE_22 = 0x85937240
    PLAY_PL_SYNTH_INDEX_21_OCT_SLOWMEL_25 = 0xB30EE13F
    PLAY_PL_SYNTH_INDEX_25_DASHKA_PLANETCOUNTER_314 = 0x5E16C9DD
    PLAY_PL_SYNTH_INDEX_26_MELB_PLANETBURNT_4 = 0x11362C7D
    PLAY_PL_VOCAL_INDEX_10_TETSUO_VOXSOFT_1 = 0x19D7608A
    PLAY_PL_VOX_INDEX_03_SM_VOX_DMIN_3 = 0xD6ACAB19
    PLAY_PL_VOX_INDEX_13_LULL_VOX_16 = 0x8B3A1916
    PLAY_SP_ARP_HI_INDEX_01_MONOLITH_SPACE_ARP_GMIN_11 = 0xC22E661B
    PLAY_SP_ARP_HI_INDEX_02_ASIMOVARP_A1 = 0xF21C52D1
    PLAY_SP_ARP_HI_INDEX_03_SUPERMOON_17 = 0x4EDC8A96
    PLAY_SP_ARP_HI_INDEX_04_BLUEPRINT_ARPEMIN_128BPM_3 = 0x3397A0BD
    PLAY_SP_ARP_HI_INDEX_05_REDPARA_SPACEARP_AMIN_7 = 0x73AC58C
    PLAY_SP_ARP_HI_INDEX_07_ARPEOTWS_A11 = 0x3D5692D2
    PLAY_SP_ARP_HI_INDEX_08_HUSK_7 = 0xA6145F83
    PLAY_SP_ARP_HI_INDEX_09_RIPLEY_12 = 0xAA2EFA26
    PLAY_SP_ARP_HI_INDEX_10_ARPTETSUO_B9 = 0x350D57DC
    PLAY_SP_ARP_HI_INDEX_12_ATWOOD_10 = 0xBF34FC67
    PLAY_SP_ARP_HI_INDEX_13_ARPBEYOND_A9 = 0x3F9FF61
    PLAY_SP_ARP_HI_INDEX_14_EOTWSALT_11 = 0x42BAC2B1
    PLAY_SP_ARP_HI_INDEX_15_MACREADY_4 = 0x165044CF
    PLAY_SP_ARP_HI_INDEX_16_MONOALT_7 = 0x228B67A7
    PLAY_SP_ARP_HI_INDEX_21_OCT_ARPS_10 = 0x13035ED0
    PLAY_SP_ARP_HI_INDEX_25_DASHKA_SPACEGTR_8 = 0x7ED77A28
    PLAY_SP_BASS_INDEX_01_SPARKGROWLER_EMIN_4 = 0xDF4601B1
    PLAY_SP_BASS_INDEX_02_SKANNERLOW_EMIN_4 = 0xD6FCD897
    PLAY_SP_BASS_INDEX_07_EOTWS_REAMP_1 = 0x67A6502B
    PLAY_SP_BASS_INDEX_09_RIPLEY_SPACEBASS_EMIN_1 = 0xCD3A288
    PLAY_SP_BASS_INDEX_17_APORIA_SPACEBASS_6 = 0xB4F25703
    PLAY_SP_BASS_INDEX_18_NMS2017_SPACEBASS_7 = 0x6A2EFC7F
    PLAY_SP_BASS_INDEX_20_TUNG_SPACEBASS2 = 0xEEDCEB62
    PLAY_SP_BASS_INDEX_25_DASHKA_SPACEBASS_3 = 0xD4FA04F5
    PLAY_SP_BASS_INDEX_26_MELB_SPACELOWS_5 = 0x6410B4E6
    PLAY_SP_BASS_INDEX_28_SCRAPER_SPACEROOTS_7 = 0xB966DBA0
    PLAY_SP_CHORDS_INDEX_03_SM_CLUSTERKEYS_DMIN_2 = 0x416181A
    PLAY_SP_CHORDS_INDEX_17_APORIA_SPACECHORDS_16 = 0x22601B2
    PLAY_SP_CHORDS_INDEX_18_NMS2017_SPACECHORDSYNTH_10 = 0xF4FCC08
    PLAY_SP_DRONE_01_INDEX_01_MONOLITH_WANTEDGTRDRONES_GMIN_3 = 0x60EAFF30
    PLAY_SP_DRONE_01_INDEX_02_ASIM_KORGSPACESYNTH_BMIN_9 = 0x37AD4C1C
    PLAY_SP_DRONE_01_INDEX_04_BLUEPRINT_MOPHODRONE_EMIN_4 = 0xE91F0CFF
    PLAY_SP_DRONE_01_INDEX_05_REDPARA_SPACEPULSE_AMIN_7 = 0xA5A09195
    PLAY_SP_DRONE_01_INDEX_06_EV_SPACEDRONEONE_ENEUTRAL_2 = 0xA8735D7
    PLAY_SP_DRONE_01_INDEX_12_ATWOOD_DRONESUB_1 = 0xDCAB9F9
    PLAY_SP_DRONE_01_INDEX_13_BEYOND_SPACEKORG_13 = 0x9C46D223
    PLAY_SP_DRONE_01_INDEX_16_MONOALT_SPACEDRONE_5 = 0xAAA6DF83
    PLAY_SP_DRONE_01_INDEX_20_TUNG_SPACEMODAL_14 = 0x1B3D3175
    PLAY_SP_DRONE_01_INDEX_22_VOSTOK_SPACETEXTURE_33 = 0xB4D09396
    PLAY_SP_DRONE_01_INDEX_24_DOMO_SPACEDRONE_15 = 0xB0ECE2C0
    PLAY_SP_DRONE_01_INDEX_25_DASHKA_SPACEAMBIENCE_7 = 0xC4CE4289
    PLAY_SP_DRONE_02_INDEX_06_EV_SPACEDRONETWO_ENEUTRAL_4 = 0x75705BDA
    PLAY_SP_DRONE_02_INDEX_22_VOSTOK_SPACEGRAIN_6 = 0x27F67AEF
    PLAY_SP_DRONE_03_INDEX_22_VOSTOK_LOW_2 = 0x11579679
    PLAY_SP_FX_01_INDEX_02_BOWEDCYMBAL_CLEAN_22 = 0xBCD640CD
    PLAY_SP_FX_01_INDEX_14_EOTWS2_SPACECHIME_1 = 0xF0244729
    PLAY_SP_FX_01_INDEX_22_VOSTOK_ECHO_6 = 0x2EDF484E
    PLAY_SP_FX_01_INDEX_28_SCRAPER_VERBAMBIENCE_7 = 0x6D70AB77
    PLAY_SP_GUITAR_INDEX_07_EOTWS_GTRCLEANNOTES_16 = 0xAAE231EC
    PLAY_SP_GUITAR_INDEX_09_RIPLEY_SPACEGTRHI_1 = 0xE8C36DF6
    PLAY_SP_GUITAR_INDEX_21_OCT_SPACEGTR_31 = 0x9DA8B57
    PLAY_SP_HARP_INDEX_01_ASCENSION_HARP_3 = 0xA45C3554
    PLAY_SP_HARP_INDEX_08_ASCENSION_HARP_4 = 0xF145DEC0
    PLAY_SP_LOWATMOS_INDEX_01_ASCENSION_LONGRISE_2 = 0xB66CB2AC
    PLAY_SP_LOWATMOS_INDEX_08_ASCENSION_LONGRISE_2 = 0x69291BF7
    PLAY_SP_MELODY_HI_INDEX_02_ASIM_SPACEDUDE_9 = 0x92E2D7C0
    PLAY_SP_MELODY_HI_INDEX_06_EV_SPACEPIANO_3_REV = 0xFCE3BF92
    PLAY_SP_MELODY_HI_INDEX_11_AKIRA_DULCECLUSTER_7 = 0x478AC911
    PLAY_SP_MELODY_HI_INDEX_12_ATWOOD_SPACEHIGHINTEREST_2 = 0xF7DCC916
    PLAY_SP_MELODY_HI_INDEX_13_BEYOND_HIGHMELODY_12 = 0xD9F7F0CD
    PLAY_SP_MELODY_HI_INDEX_16_MONOALT_VIOLIN_2 = 0x42820E95
    PLAY_SP_MELODY_HI_INDEX_19_TUES_SPACEHIGHONESHOTS_11 = 0x69573671
    PLAY_SP_MELODY_HI_INDEX_23_ECHO_SPACEHIGHINTERESTREV_1 = 0x8C39509
    PLAY_SP_MELODY_HI_INDEX_27_OVERSEER_SPACEHIGHINTEREST_10 = 0x9ADFD246
    PLAY_SP_MELODY_INDEX_01_ASCENSION_ELEKTRIK_EMIN_1 = 0x55ADB9E1
    PLAY_SP_MELODY_INDEX_03_SM_JUNOCHORDS_DMIN_18 = 0x2D887AF5
    PLAY_SP_MELODY_INDEX_04_BLUEPRINT_ORGANSCATTER_EMIN_10 = 0x2FC2C04A
    PLAY_SP_MELODY_INDEX_08_ASCENSION_ELEKTRIK_EMIN_1 = 0xC089EA38
    PLAY_SP_MELODY_INDEX_11_AKIRA_SPACEORGAN_15 = 0x956D3D20
    PLAY_SP_MELODY_INDEX_15_MAC_SPACEPADS_4 = 0x44EA076C
    PLAY_SP_MELODY_INDEX_19_TUES_MUSICBOX_12 = 0xDED04AC9
    PLAY_SP_MELODY_INDEX_23_ECHO_SPACETHUD_19 = 0xDA845B1A
    PLAY_SP_MELODY_INDEX_26_MELB_SPACEMELS_3 = 0xC71C04F9
    PLAY_SP_MISC_HI_INDEX_01_MONOLITH_MISC_GMIN_1 = 0x5D2FCB47
    PLAY_SP_MISC_HI_INDEX_20_TUNG_SPACEHIGHINTEREST_13 = 0x93AE2D3
    PLAY_SP_MISC_HI_INDEX_22_VOSTOK_SPACEHIGHINT_60 = 0x814B3BC2
    PLAY_SP_MISC_HI_INDEX_23_ECHO_WANTEDCELESTA_3 = 0xFF89DCAA
    PLAY_SP_MISC_HI_INDEX_24_DOMO_SPACEHIGHINTEREST_9 = 0x29AB4507
    PLAY_SP_SYNTH_INDEX_01_ASCENSION_SYNTHSTAB_6 = 0xE8943E79
    PLAY_SP_SYNTH_INDEX_08_ASCENSION_SYNTHSTAB_9 = 0xD6A9E64B
    PLAY_SP_SYNTH_INDEX_11_AKIRA_SPACESYNTH_9 = 0xD0A18574
    PLAY_SP_SYNTH_INDEX_13_BEYOND_SLOWSYNTH_6 = 0x1D942713
    PLAY_SP_SYNTH_INDEX_14_EOTWS2_SPACESTABS_5 = 0xA781CF68
    PLAY_SP_SYNTH_INDEX_19_TUES_JUNO_6 = 0xFA97E7FE
    PLAY_SP_SYNTH_INDEX_21_OCT_SPACEKEYS_14 = 0xFE626DB9
    PLAY_SP_SYNTH_INDEX_22_VOSTOK_ECHOREV_7 = 0xD4D22C6C
    PLAY_SP_SYNTH_INDEX_23_ECHO_SPACEPOLY_7 = 0xFAB5FB24
    PLAY_SP_SYNTH_INDEX_24_DOMO_SPACEARP_22 = 0xA28F7AB7
    PLAY_SP_SYNTH_INDEX_27_OVERSEER_SPACESYNTH_6 = 0x5B9A5C75
    PLAY_SP_SYNTHHIGH_INDEX_10_TETSUO_MOPHOHIGHINTEREST_1 = 0xADF95C78
    PLAY_SP_SYNTHHIGH_INDEX_13_BEYOND_HIGHMELODY_14 = 0xA8B7067F
    PLAY_SP_SYNTHHIGH_INDEX_17_APORIA_SPACE_HIGHINTEREST_3 = 0x39C50559
    PLAY_SP_SYNTHHIGH_INDEX_26_MELB_SPACEHIGHINTEREST6 = 0x9B772B4C
    PLAY_SP_SYNTHHIGH_INDEX_28_SCRAPER_SPACEARPS_5 = 0x725D9C8
    PLAY_SP_SYNTHINTERFERENCE_INDEX_10_TETSUO_SPACEHIGHINTEREST_1 = 0x70929769
    PLAY_SP_SYNTHPADS_INDEX_10_TETSUO_SPACEPADS_17 = 0x32F3C5E
    PLAY_SP_SYNTHPADS_INDEX_14_EOTWS2_SPACEPADS_3 = 0x64FBB0CF
    PLAY_SP_SYNTHPADS_INDEX_27_OVERSEER_SPACEDRIFTS_10 = 0x415027FE
    PLAY_VO_WARNINGDRONE_ACTIVATED = 0xB16E06F0
    PLAY_VO_WARNINGDRONE_COMBAT = 0xA7DEA5CF
    PLAY_VO_WARNINGDRONE_ENGAGED = 0xCCDF400E
    PLAY_VO_WARNINGSENTINELELITE = 0x302ED34F
    PLAY_VO_WARNINGSENTINELINCOMING = 0x57798EBA
    PLAY_VO_WARNINGWALKER = 0x7334AE90
    PLAY_WT_ARP_INDEX_05_REDPARA_SPACEARP_AMIN_3 = 0xE8ABFEA4
    PLAY_WT_ARP_INDEX_06_EV_WANTEDARPS_4 = 0x29011642
    PLAY_WT_ARP_INDEX_08_MONOLITH_SPACE_ARP_GMIN_4 = 0x79BDCBD2
    PLAY_WT_ARP_INDEX_17_APORIA_WANTEDARPS_1 = 0x816AC8F4
    PLAY_WT_ARP_INDEX_19_TUES_WANTEDARP_2 = 0x309679DF
    PLAY_WT_ARP_INDEX_23_ECHO_WANTEDCELESTA_3 = 0xDA34E957
    PLAY_WT_BASS_INDEX_02_SKANNERLOW_EMIN_1 = 0xCE67C6FA
    PLAY_WT_BASS_INDEX_03_SM_WANTED_BASSSEQ_118BPM_DMIN_2 = 0xF54EDD74
    PLAY_WT_BASS_INDEX_08_MONOLITH_WANTED_SYNTHLOW_1 = 0x16BE8EB1
    PLAY_WT_BASS_INDEX_20_TUNG_PLANET_PIANOLOWINT2 = 0xE893B9AA
    PLAY_WT_BASS_INDEX_22_VOSTOK_WANTEDSTABS_3 = 0x819C2011
    PLAY_WT_BASS_INDEX_25_DASHKA_WANTEDBASSSYNTH_5 = 0x52D2E4AE
    PLAY_WT_BASS_INDEX_26_MELB_PLANETBASS_2 = 0x3D53BDE3
    PLAY_WT_BASS_INDEX_27_OVERSEER_WANTEDBASS_2 = 0x1FEA96F4
    PLAY_WT_DRONE_02_INDEX_08_DEPARTURE_NOISE_EMIN_1 = 0x7D3F9967
    PLAY_WT_DRONE_02_INDEX_09_RIPLEY_GRAIN__1 = 0x2D7961A7
    PLAY_WT_DRONE_INDEX_03_DEPARTURE_GTR_EMIN_9 = 0x6D1E8BF2
    PLAY_WT_DRONE_INDEX_04_DEPARTURE_NOISE_EMIN_5 = 0xD33A4CFA
    PLAY_WT_DRONE_INDEX_07_EOTWS_GRAINSPACE_1 = 0xD8E07776
    PLAY_WT_DRONE_INDEX_08_BOREALIS_GTRFEEDBACK_AMIN_1 = 0x7D546579
    PLAY_WT_DRONE_INDEX_09_SM_ATMOS_DMIN_1 = 0xE9CDD90E
    PLAY_WT_DRONE_INDEX_10_TETSUO_GRAINSPACE_1 = 0xADA17A3A
    PLAY_WT_DRONE_INDEX_11_AKIRA_PLANETGRAIN_17 = 0x6AAB05BA
    PLAY_WT_DRONE_INDEX_12_ATWOOD_DRONEGTR_16 = 0x92198342
    PLAY_WT_DRONE_INDEX_14_DEPARTURE_GTR_EMIN_1 = 0xC2FC8B7E
    PLAY_WT_DRONE_INDEX_15_MAC_MAINPADSFULL_CSHARP_MIN_2 = 0xEC4E0A5
    PLAY_WT_DRONE_INDEX_16_MONOALT_GRAIN_10 = 0x37317CEA
    PLAY_WT_DRONE_INDEX_22_VOSTOK_ECHOREV_7 = 0x65358E7C
    PLAY_WT_DRONE_INDEX_24_DOMO_WANTEDBACKGROUND_2 = 0xEDA0C79F
    PLAY_WT_DRUMS_INDEX_01_MONOLITH_WANTED_DRUMLOOPS_20 = 0x976BCC42
    PLAY_WT_DRUMS_INDEX_02_ASIM_DRUMSDIRTY_128BPM_6 = 0xD1FD662A
    PLAY_WT_DRUMS_INDEX_03_SM_WANTED_DRUMLOOPS_15 = 0xA6B6A988
    PLAY_WT_DRUMS_INDEX_04_BLUEPRINT_DRMSGLITCHYBEATS_128BPM_5 = 0xD5CC957C
    PLAY_WT_DRUMS_INDEX_05_REDPARA_WANTEDDRUMLOOPS_1 = 0x88B928BF
    PLAY_WT_DRUMS_INDEX_06_EV_DRUMLOOPS_138BPM_9 = 0x105917
    PLAY_WT_DRUMS_INDEX_07_EOTWS_WANTEDBEATS_1 = 0xD4BB78E
    PLAY_WT_DRUMS_INDEX_08_HUSKWANTEDBEATS11 = 0xB5A776F9
    PLAY_WT_DRUMS_INDEX_09_RIPLEY_DRUMLOOPS_120BPM_1 = 0xFFA06FAD
    PLAY_WT_DRUMS_INDEX_10_TETSUO_DRUMLOOPS_1 = 0xC919BA1D
    PLAY_WT_DRUMS_INDEX_11_AKIRAWANTEDBEATS3 = 0xB31FEE49
    PLAY_WT_DRUMS_INDEX_12_ATWOOD_WANTEDARPBEATS_24 = 0xB4B96ABC
    PLAY_WT_DRUMS_INDEX_13_BEYONDTOMORROW1 = 0x5188A113
    PLAY_WT_DRUMS_INDEX_14_EOTWS_WANTEDDRUMS_2 = 0x9ACE2CC5
    PLAY_WT_DRUMS_INDEX_15_MAC_DRUMLOOP_5 = 0x63BD3B06
    PLAY_WT_DRUMS_INDEX_16_MONOALT_WANTEDLOOPS_8 = 0xC300036F
    PLAY_WT_DRUMS_INDEX_17_APORIA_WANTEDBEATS_2 = 0x1E5E0C9A
    PLAY_WT_DRUMS_INDEX_18_NMS2017_WANTEDSYNTHBEATS_1 = 0x99B4CD28
    PLAY_WT_DRUMS_INDEX_19_TUES_WANTEDBEATS4 = 0xAC12AE00
    PLAY_WT_DRUMS_INDEX_20_TUNG_WANTEDBEATS_3 = 0xED622083
    PLAY_WT_DRUMS_INDEX_21_OCT_WANTEDBEATS_1 = 0x738B234E
    PLAY_WT_DRUMS_INDEX_22_VOSTOK_WANTEDDRUMS_2 = 0x67E42272
    PLAY_WT_DRUMS_INDEX_23_ECHO_WANTEDLOOPS_2 = 0x6F73905E
    PLAY_WT_DRUMS_INDEX_24_DOMO_WANTEDDRUMS_3 = 0xC03ABC3C
    PLAY_WT_DRUMS_INDEX_25_DASHKA_WANTEDBEATS_3 = 0x310645C0
    PLAY_WT_DRUMS_INDEX_26_MELB_WANTEDBEATS_6 = 0x90D1B150
    PLAY_WT_DRUMS_INDEX_27_OVERSEER_WANTEDDRUMS_6 = 0x13D2BB3C
    PLAY_WT_DRUMS_INDEX_28_SCRAPER_WANTEDBEATS_8 = 0xF5818A
    PLAY_WT_FX_01_INDEX_03_SM_ATMOS_DMIN_5 = 0xB37E574E
    PLAY_WT_FX_01_INDEX_04_BLUEPRINT_MOPHOSTUTTER_EMIN_4 = 0x6B45AE08
    PLAY_WT_FX_01_INDEX_17_APORIA_SPACEBOWS_49 = 0x9461CB1B
    PLAY_WT_FX_01_INDEX_19_TUES_SONIC_2 = 0x958C95B8
    PLAY_WT_FX_01_INDEX_25_DASHKA_WANTEDNOISE_5 = 0x2A8CCF98
    PLAY_WT_GUITAR_INDEX_02_ASIM_JOEGTRLOUD_BMIN_18 = 0x315EC7A
    PLAY_WT_GUITAR_INDEX_04_BLUEPRINT_GTRBUILD_EMIN_9 = 0xFE2DAC64
    PLAY_WT_GUITAR_INDEX_05_REDPARA_GTRTREM_9 = 0xF30ED157
    PLAY_WT_GUITAR_INDEX_10_TETSUO_GTR1 = 0x3E3A0819
    PLAY_WT_GUITAR_INDEX_15_MAC_GTRMEL_2 = 0xBC898CEF
    PLAY_WT_GUITAR_INDEX_17_APORIA_WANTEDSTABS_1 = 0x2D251D20
    PLAY_WT_GUITAR_INDEX_18_NMS2017_EBOWGTR_5 = 0xFB8B7983
    PLAY_WT_GUITAR_INDEX_19_TUES_WANTEDGTR_3 = 0xB56B6CBD
    PLAY_WT_GUITAR_INDEX_20_TUNG_WANTEDGTRS_5 = 0xBA1CBEC9
    PLAY_WT_GUITAR_INDEX_21_OCT_WANTEDGTR_32 = 0x8421736D
    PLAY_WT_GUITAR_INDEX_23_ECHO_WANTEDGTRS_1 = 0x1BB1747F
    PLAY_WT_GUITAR_INDEX_26_MELB_PLANETGTR_2 = 0xAEFE5FBA
    PLAY_WT_GUITAR_INDEX_27_OVERSEER_WANTEDGTR_7 = 0x7730B6E
    PLAY_WT_GUITARS_02_INDEX_04_BLUEPRINT_GTREND_EMIN_6 = 0x387EC3EA
    PLAY_WT_GUITARS_02_INDEX_05_REDPARA_EBOWDRONE_5 = 0x25B9F145
    PLAY_WT_GUITARS_02_INDEX_17_APORIA_WANTEDGTRS_1 = 0xBD78E4D
    PLAY_WT_GUITARS_02_INDEX_20_TUNG_WANTEDBASS_3 = 0x7C61FF9A
    PLAY_WT_GUITARS_02_INDEX_26_MELB_DIST_2 = 0x9C2E6721
    PLAY_WT_MELODY_INDEX_03_SM_JOEGTRBURTS_DMIN_19 = 0x42473AD4
    PLAY_WT_MELODY_INDEX_04_KOAECAX_SLOWSYNTH_2 = 0x5B6A46
    PLAY_WT_MELODY_INDEX_06_EV_PIANOWANTED_AMIN_12 = 0x162A4ED3
    PLAY_WT_MELODY_INDEX_07_EOTWS_PLANETHIINTEREST_1 = 0x35FF80B0
    PLAY_WT_MELODY_INDEX_12_ATWOOD_CRACKLE_5 = 0xCD321398
    PLAY_WT_MELODY_INDEX_18_NMS2017_WANTEDLOOPS_3 = 0x16A15695
    PLAY_WT_MELODY_INDEX_21_OCT_WANTEDMELS_4 = 0xB93D3088
    PLAY_WT_MELODY_INDEX_23_ECHO_SPACEHIGHINTEREST_1 = 0x1C772C4
    PLAY_WT_MELODY_INDEX_24_DOMO_WANTEDMELS_1 = 0xF6EADAF3
    PLAY_WT_MELODY_INDEX_25_DASHKA_SPACEPIANO_6 = 0xB88F3749
    PLAY_WT_MELODY_INDEX_27_OVERSEER_WANTEDMELS_4 = 0x84FB5085
    PLAY_WT_MELODY_INDEX_28_SCRAPER_WANTEDMELS_10 = 0x41FA07E6
    PLAY_WT_NOISE_INDEX_01_MONOLITH_WANTED_NOISEONESHOTS_2 = 0x7EBF2A9
    PLAY_WT_ONESHOTS_INDEX_01_MONOLITH_WANTED_FASTONESHOTS_13 = 0x2634FD60
    PLAY_WT_ONESHOTS_INDEX_03_TOMORROW_FM_CHOPPED_5 = 0x76EACDAC
    PLAY_WT_ONESHOTS_INDEX_04_BLUEPRINT_JOESTUTTER_EMIN_11 = 0xB0C277CA
    PLAY_WT_ONESHOTS_INDEX_05_REDPARA_WANTEDSONGONESHOT_2 = 0x80B04A24
    PLAY_WT_ONESHOTS_INDEX_11_BLUEPRINT_GTREND_EMIN_5 = 0x70AADAA4
    PLAY_WT_ONESHOTS_INDEX_14_EOTWS_WANTEDBURN_4 = 0x733E0945
    PLAY_WT_ONESHOTS_INDEX_17_APORIA_PLANETSTABS_37 = 0x50D748A5
    PLAY_WT_ONESHOTS_INDEX_20_TUNG_SPACEHIGHINTEREST_16 = 0xF42D762D
    PLAY_WT_ORGAN_INDEX_06_EV_ORGANWANTED_AMIN_4 = 0xD8EA60FF
    PLAY_WT_PADS_INDEX_04_BLUEPRINT_INTROPADS_EMIN_48 = 0x9011770E
    PLAY_WT_PADS_INDEX_13_BEYOND_WANTEDPADS_6 = 0xC4907E3D
    PLAY_WT_SYNTH_INDEX_17_APORIA_SPACECHORDS_1 = 0x79F49AA7
    PLAY_WT_SYNTH_INDEX_20_TUNG_SPACEMODAL_2 = 0xF17FFB5A
    PLAY_WT_SYNTH_INDEX_26_MELB_WANTEDKEYS_5 = 0x85C4424B
    PLAYER_DIE = 0x5BEE16D1
    PLAYER_DIE_SURFACE = 0x3E80F715
    PLAYER_ORB = 0x44F92B10
    PLAYER_SHIP_TRANSITION = 0x4C30CFEB
    PLAYER_WATER_TRANSITION_INTO_ATMOS = 0xD2A5E6C2
    PLAYER_WATER_TRANSITION_INTO_WATER = 0x10DA6251
    PLOUGH = 0x73DFF4A4
    POD_BEAT = 0x5BD80B25
    POD_BURST = 0x9731DC65
    POD_SHAKE = 0xD1F704ED
    POI_ASTEROID_BEACON = 0x5E085E18
    POI_ATLAS_BEACON_01 = 0x20E5FCAC
    POI_ATLAS_BEACON_02 = 0x20E5FCAF
    POI_BONES = 0xD43CA593
    POI_CRYSTALS = 0x333E286B
    POI_CUBE_STATION = 0xC09FF838
    POI_DERELICT_01 = 0x25A14BD2
    POI_DERELICT_02 = 0x25A14BD1
    POI_DERELICT_03 = 0x25A14BD0
    POI_EYE = 0xC5038395
    POI_EYE_BEAM_END = 0x8593A2D7
    POI_EYE_BEAM_LP = 0x52AF1964
    POI_GAS_BRAIN = 0xA158AFF4
    POI_GEKHEAD = 0xBCAA303B
    POI_GYRO_BALL = 0x8FAB3C89
    POI_HORROR = 0xF3D9CFF2
    POI_JELLYFISH = 0x74BD0818
    POI_JELLYFISH_SPACE_SWIM = 0xABDB3F66
    POI_LINE_GEO = 0x1F696682
    POI_MEMORYLIFEBOAT_FLARE = 0x6C22D0CE
    POI_MEMORYLIFEBOAT_IDLE = 0x55D58134
    POI_NEURON = 0x3B4DCF27
    POI_RADIO_PILLAR = 0x64CC1342
    POI_RELAYBEACON = 0x1B7DE839
    POI_RELICGATE = 0x63E4FEA6
    POI_SPACE_EGG = 0x983E577A
    POI_SPACECLOCK = 0x38EF2B82
    POI_SPINNER = 0xF1CA2105
    POI_WEIRD_METAL = 0xFF2F4C51
    POLICE_CHATTER_START = 0x22042BF0
    POLICE_CHATTER_STOP = 0x86855F5C
    POLICE_INCOMING = 0xE2FDAA5A
    PORTAL_ACTIVATE_NORMAL = 0xC84F6011
    PORTAL_CAMERA_TOTERMINAL = 0x4CF219CD
    PORTAL_CORRUPTED_AMBIENT_LP = 0xCE45018E
    PORTAL_CORRUPTED_AWAKEN = 0xEB4E8710
    PORTAL_CORRUPTED_RUMBLE_BUILD = 0xB732E347
    PORTAL_CORRUPTED_RUMBLE_LP = 0xA30105C9
    PORTAL_CORRUPTED_STOP = 0x52B28E11
    PORTAL_DIAL_SPIN_START = 0x9AA1C4A6
    PORTAL_DIAL_SPIN_STOP = 0xF831E3E6
    PORTAL_EXPLOSION = 0xB8CAC8DB
    PORTAL_JUMP_NORMAL_END = 0x20AA1BB2
    PORTAL_JUMP_NORMAL_END_AMBIENCES = 0x6713C8E4
    PORTAL_JUMP_NORMAL_START = 0xE3B61E91
    PORTAL_JUMP_STORY_END = 0x1F67ACB6
    PORTAL_JUMP_STORY_START = 0xA0AB3F9D
    PORTAL_PILLARSATTACH = 0x77EE9DE6
    PORTAL_PILLARSDETACH = 0x2BF21928
    PORTAL_PILLARSLOCK = 0x4B8CCC60
    PORTAL_PILLARSUNLOCK = 0x8060BB55
    PORTAL_RUNE_SELECT = 0x42F26699
    PORTAL_RUNE_UNAVAILABLE = 0x3E81D195
    PORTAL_RUNES_APPEAR = 0x2926B953
    PORTAL_STOP_ALL = 0x4CAFE42A
    PORTAL_TERMINAL_CLOSE = 0xACE8E6E3
    PORTAL_TERMINAL_OPEN = 0x7606BD5
    PORTAL_WEIRD_BUILDUP = 0xD11EC5BF
    POWER_SWITCH_AUTOSWITCH_OFF = 0x31E73B95
    POWER_SWITCH_AUTOSWITCH_ON = 0x7A01D829
    POWER_SWITCH_BUTTON_OFF = 0xE959674
    POWER_SWITCH_BUTTON_ON = 0xBD66A4EE
    POWER_SWITCH_FLOOR_OFF = 0x882DA65A
    POWER_SWITCH_FLOOR_ON = 0x4C5B965C
    POWER_SWITCH_PROXIMITY_OFF = 0xA51D0817
    POWER_SWITCH_PROXIMITY_ON = 0x38AE2063
    POWERMODULE_NOTE_A = 0x662C5967
    POWERMODULE_NOTE_A_STOP = 0x664B9122
    POWERMODULE_NOTE_B = 0x662C5964
    POWERMODULE_NOTE_B_STOP = 0x1A3E6F83
    POWERMODULE_NOTE_C = 0x662C5965
    POWERMODULE_NOTE_C_STOP = 0x3BEAA2A8
    POWERMODULE_NOTE_D = 0x662C5962
    POWERMODULE_NOTE_D_STOP = 0x39B74521
    POWERMODULE_NOTE_E = 0x662C5963
    POWERMODULE_NOTE_E_STOP = 0x5DCA590E
    POWERMODULE_NOTE_F = 0x662C5960
    POWERMODULE_NOTE_F_STOP = 0xD89D1D4F
    POWERMODULE_NOTE_G = 0x662C5961
    POWERMODULE_NOTE_G_STOP = 0xD42B64
    PROTOROLLER = 0x98F8B9B1
    PROTOROLLER_STOP = 0xC4BC74D4
    PS5_VIBRATION_TONE = 0xCF5E1783
    PS5_VIBRATION_TONE_STOP = 0x93D00DEE
    PULSE_EMPHASISER = 0x22CEF034
    QUAD_ATTACK = 0x8DCE66F7
    QUAD_CROUCHTOSTAND = 0x9F9B4E96
    QUAD_DIE = 0x9DA4A083
    QUAD_EMOTE_LP = 0x62200770
    QUAD_EMOTE_LP_STOP = 0xF9C8B07F
    QUAD_EVADE = 0xF7EBDFCA
    QUAD_GUN = 0xB9A70BFF
    QUAD_HOP = 0xBF9A4960
    QUAD_IDLE = 0xAF14F599
    QUAD_LASER = 0xC667CC3C
    QUAD_LASER_STOP = 0x48BCC9CB
    QUAD_POUNCE = 0x4D21BF6D
    QUAD_POUNCE_BACK = 0xCB08B251
    QUAD_POUNCE_FORWARD = 0x75A11A07
    QUAD_SCAN = 0xC82A6860
    QUAD_SCAN_STOP = 0xBC4B8A4F
    QUAD_STEP = 0xAC0E650D
    QUAD_TONE = 0x9FFA9753
    RACING_DOME_NOTIFIER = 0x72791D60
    RADIO_CHATTER = 0x7E66279C
    RADIO_CHATTER_STOP = 0x66DF5E6B
    RECIPE_RECEIVE = 0xDBD7DDFD
    RESOURCE_GATHER = 0x86333C19
    RIVER = 0xD6EBF401
    ROBOT_GUNMELEE_IMPACTS = 0x4436A6B4
    ROBOT_LASER_IMPACTS = 0x49D29DA7
    ROBOT_METAL_IMPACTS = 0xD7582BF
    ROBOT_NARRATION_SINGALONG = 0x8BBB94A9
    ROBOT_NARRATION_SINGALONG_STOP = 0xCE99149C
    ROBOT_SHIP_TALK = 0x8B4C5A89
    ROBOT_SHIP_TALK_STOP = 0x702B2D3C
    ROCKCREATURE_TRANSFORM = 0x4E24239C
    RODENTATTACK1 = 0xD181620
    RODENTATTACK2 = 0xD181623
    RODENTATTACK3 = 0xD181622
    RODENTPOUNCE = 0xED010011
    RODENTPOUNCE2 = 0x29931AF1
    RODENTROAR = 0xFDD30E03
    ROLLER = 0xF1A7A7AD
    ROUNDTABLE_CLOSE = 0xB601B704
    ROUNDTABLE_OPEN = 0xD3D76000
    ROVER_BOOST_START = 0xD22AAF8A
    ROVER_BOOST_STOP = 0x696003E2
    ROVER_HORN_START = 0x4D72C430
    ROVER_HORN_STOP = 0x80EDB9C
    ROVER_IDLE_EXTERIOR = 0xCD1A7599
    ROVER_IMPACTS = 0xFA34F30F
    ROVER_JUMP = 0x892690CA
    ROVER_START = 0xEC117B92
    ROVER_STOP = 0xBFA7324A
    ROVER_SUSPENSION = 0x73640735
    RUININTERACTION_ACTIVE = 0x8A6EEEE6
    RUININTERACTION_END = 0x629E486F
    RUININTERACTION_IDLE = 0x86C1F9AE
    SANDWORM_INTOGROUND = 0x86327B5A
    SANDWORM_LP = 0x6E353C11
    SANDWORM_LP_STOP = 0xAAC8AD74
    SANDWORM_OUTOFGROUND = 0xE4FE7575
    SANDWORM_UNDERGROUND_WAIL_LP = 0xB2928D5F
    SC_TR_HARV = 0x3234D002
    SCAN_OFF = 0x70FDCEA8
    SCAN_ON = 0x8022EEB2
    SCRAP_DESTROY = 0x8ED2EF33
    SEAHORSE_SWIM = 0x22E468
    SEAURCHINCLOSE = 0x39AEF411
    SEAURCHINEXTEND = 0x7A044893
    SENTINEL_CRYSTAL = 0xD277358A
    SENTINEL_CRYSTAL_SMALL = 0xEF1AD0C6
    SENTINEL_HIVE_LP = 0xAA570111
    SENTINEL_HIVE_NODE = 0x118A84ED
    SENTINEL_HIVE_TERMINAL = 0x1352B0A9
    SENTINEL_MECH_JUMP = 0xD469C69E
    SENTINEL_MECH_LAND = 0x60F02DC9
    SENTINEL_MECH_WPN_FIRE = 0x2345B1E2
    SENTINEL_MECH_WPN_FIRE_STOP = 0x7112EA1
    SENTINEL_MECH_WPN_GRENADE = 0xECF59048
    SENTINEL_MECH_WPN_GUN = 0xF7A08AA0
    SENTINELS_INCOMING1 = 0x5862BAD0
    SENTINELS_INCOMING2 = 0x5862BAD3
    SENTINELS_INCOMING3 = 0x5862BAD2
    SENTINELS_INCOMING4 = 0x5862BAD5
    SENTINELS_INCOMING5 = 0x5862BAD4
    SENTINENCEECHO_REVEAL = 0xAC879F8
    SETTLEMENT_ALARM = 0x39A0EC12
    SETTLEMENT_ALARM_SHIP = 0x9DE3B01B
    SETTLEMENT_ANTENNA = 0x74E20ADC
    SETTLEMENT_ANTENNA0 = 0xDBD71864
    SETTLEMENT_ANTENNA1 = 0xDBD71865
    SETTLEMENT_ANTENNA2 = 0xDBD71866
    SETTLEMENT_ANTENNA3_LOOP = 0x7EE99A9C
    SETTLEMENT_ANTENNA3_SPIN = 0x1D5ED15A
    SETTLEMENT_CONSTRUCTION_TERMINAL = 0x48A1CD9B
    SETTLEMENT_FURNACE = 0x22B71075
    SETTLEMENT_GENERATOR = 0x7D11D44A
    SETTLEMENT_GLOWGLOBE = 0xF2985AF
    SETTLEMENT_LIGHTOUTDOOR = 0x8C6C2D83
    SETTLEMENT_MEDIBAY_LP = 0xEFC5D07B
    SETTLEMENT_PUMP = 0xC2F73565
    SETTLEMENT_ROBOTARM = 0xC5CE471
    SETTLEMENT_TERMINAL = 0xBD68511F
    SETTLEMENT_WATERTOWER = 0x13117793
    SFX_FADEDOWN = 0xED6AB3EB
    SFX_FADEUP = 0x71E96FAC
    SHARK_LP = 0x28B07C37
    SHIP_ALIEN_LANDING = 0x4EF74A6B
    SHIP_ALIEN_NOSTRILFLARE = 0x6300644D
    SHIP_ALIEN_TAKEOFF = 0xD387BE6
    SHIP_NORMANDY_ENGINES = 0x627E5670
    SHIP_NORMANDY_REVEAL = 0x83EEF348
    SHIP_PIRATE_LANDING_WINGS = 0x4DE7AD60
    SHIP_PIRATE_SAILS_ROUNDSAILS_FOLD = 0xBC9C3093
    SHIP_PIRATE_SAILS_ROUNDSAILS_UNFOLD = 0x2F203F2A
    SHIP_PIRATE_SAILS_SQUARE_FOLD = 0x8ADE0CE2
    SHIP_PIRATE_SAILS_SQUARE_UNFOLD = 0x8EF70A7
    SHIP_PIRATE_SAILS_TRIANGLE_FOLD = 0x96B28FFD
    SHIP_PIRATE_SAILS_TRIANGLE_UNFOLD = 0x1A6698D8
    SHIP_PIRATE_TAKEOFF_WINGS = 0x82FAE5D5
    SHIP_ROYAL_ENGINEC_LANDING = 0xA3AC816B
    SHIP_ROYAL_ENGINEC_TAKEOFF = 0x61EDB2E6
    SHIP_ROYAL_LANDINGGEAR_LANDING = 0x5E8606D2
    SHIP_ROYAL_LANDINGGEAR_TAKEOFF = 0x41A85C03
    SHIP_ROYAL_WINGSA_LANDING = 0x50E01CA7
    SHIP_ROYAL_WINGSA_TAKEOFF = 0xBC7EFDA2
    SHIP_ROYAL_WINGSB_LANDING = 0x4FF8C854
    SHIP_ROYAL_WINGSB_TAKEOFF = 0xC9965D21
    SHIP_ROYAL_WINGSC_LANDING = 0x9ACB3D2D
    SHIP_ROYAL_WINGSC_TAKEOFF = 0xBC3F8694
    SHIP_SQUID_LANDINGGEAR_LANDING = 0xA7B106E1
    SHIP_SQUID_LANDINGGEAR_TAKEOFF = 0xE4DA94B8
    SHIP_SQUID_NOSE_LANDING = 0xCC0E542
    SHIP_SQUID_NOSE_TAKEOFF = 0xE2EA8853
    SHIP_TOUCHDOWN_IMPACT = 0xF0555EF0
    SHIPREPAIR_IDLE = 0x2CD1DD7D
    SHORELINE = 0x1A1A962
    SHUTTLE_CLOSE = 0xA8262171
    SHUTTLE_MAINTHRUSTER = 0x8BB99737
    SHUTTLE_OPEN = 0xD82737F3
    SHUTTLE_THRUSTERS_STOP = 0x6211B2EE
    SHUTTLE_TOPTHRUSTER = 0x5FE94583
    SIGNALSCANNER = 0x300E2B2D
    SILO_LOOSECLOTH = 0x47EB586F
    SIXLEGCATPERFORM01 = 0xD1CA7463
    SIXLEGGEDCOWPERFORM01 = 0xFA1323E2
    SLIMEDOOR_BREAKA = 0x2AE26AA0
    SLIMEDOOR_BREAKB = 0x2AE26AA3
    SLIMEDOOR_BREAKC = 0x2AE26AA2
    SLIMEDOOR_BREAKD = 0x2AE26AA5
    SMALLPROPC = 0x90279B9C
    SPACE_STATION_EXTERIOR = 0x11D75F19
    SPACE_STATION_INTERIOR_01 = 0xD20E04AB
    SPACE_STATION_INTERIOR_01_STOP = 0xE63C38E6
    SPACESTATION_ATLAS_DOOR_CLOSE = 0xF3BCBD6B
    SPACESTATION_ATLAS_DOOR_OPEN = 0x115E98AD
    SPACESTATION_ENGINES_INTERIOR = 0x7039CB96
    SPACESTATION_PLANET_HOLOGRAM = 0x68D3A8E6
    SPARKS = 0x9160603F
    SPGEK_CHATTER = 0xA9537B9
    SPGEK_CHATTER_STOP = 0x6E4D844C
    SPIDERATTACK = 0x4090D662
    SPIDERATTACK2 = 0x6017C74
    SPIDERATTACK3 = 0x6017C75
    SPIDERFLOATSAD = 0xF0824E34
    SPIDERPERFORM01 = 0xB731D638
    SPIDERPOUNCE = 0x5D37D550
    SPIDERROAR = 0x711887FE
    SPKORVAX_CHATTER = 0x27F01D43
    SPKORVAX_CHATTER_STOP = 0xC02D15AE
    SPOOKHEATER_IDLE = 0xB909848F
    SPOOKHEATER_LP = 0x2EE47329
    SPOOKHEATER_START = 0x64601067
    SPOOKYTENTACLES = 0x6B387ED7
    SPOOKYTENTACLES_STOP = 0xF16E3972
    SPORE = 0x11268644
    SPOREBAG_IDLE = 0xF7CA9B97
    SPOREBAG_WOBBLE = 0x5AA09996
    SPOREBAGEXPLODE = 0x631A514D
    SPOREVENT_IDLE = 0x598D4C12
    SPOREVENT_INFLATE = 0x92414141
    SPVYKEEN_CHATTER = 0x1B77C414
    SPVYKEEN_CHATTER_STOP = 0x26C45A13
    STARSHIP_OUTFITTING_LP = 0xF353E7CE
    STARSHIP_VIEW_SWITCH_EXTERIOR = 0xF31B791
    STARSHIP_VIEW_SWITCH_INTERIOR = 0x52B4A22F
    STATION_CONSOLE_SWITCH = 0x9CD9E964
    STATIONB_CRANELOADCARGO_FR1 = 0xF54FF1EB
    STATIONB_CRANELOADCARGO_FR446 = 0xE2F1938C
    STATIONB_ORB_IDLE = 0x1E239542
    STATIONB_ORB_LOOM = 0xDE339A2B
    STATIONB_ORB_RETRACT = 0xA1A8F223
    STATIONB_ORB_ZOOM = 0x9BE92935
    STING_LOGO = 0xEE2BDB9E
    STONE_DOOR1_SETTLEMENT_CLOSE = 0xBA754903
    STONE_DOOR1_SETTLEMENT_OPEN = 0x2623C975
    STONEFLOATER_CORE_EXPLODE = 0x61572F39
    STONEFLOATER_LEFT_RIGHT_THROW = 0x5962235B
    STONEFLOATER_MELEE = 0x851C0C16
    STONEFLOATER_SPAWN = 0x8CD5AACB
    STONEFLOATER_SPIN = 0x343E3246
    STONEFLOATER_THROW = 0xC909CC2E
    STOP_MAP_CENTRECHORD_01_INDEX_01_MAP_CENTRECHORD_01 = 0x244CA730
    STOP_MAP_CENTRECHORD_02_INDEX_01_MAP_CENTRECHORD_02 = 0xA78A1418
    STOP_MAP_DRONENOISE_01_INDEX_01_MAP_SPACE_NOISE_DRONE = 0x542550E2
    STOP_MAP_DRONENOISE_02_INDEX_01_MAP_SPACE_NOISE_DRONE_RR = 0x983118E
    STOP_MAP_DRONETONE_01_INDEX_01_MUS_MAP1_DRONE_E = 0x38932291
    STOP_MAP_PIANO_INDEX_01_MUS_MAP01_PIANO_01 = 0x6EC06ADD
    STOP_MAP_SINGLES_01_INDEX_01_MUS_MAP01_SINGLES1_04 = 0xD6E366A7
    STOP_MAP_SINGLES_02_INDEX_01_MUS_MAP01_SINGLES2_09 = 0xD92015F6
    STOP_MAP_ZONE01_INDEX_01_MAP_ZONE01 = 0x18F8DB64
    STOP_MAP_ZONE02_INDEX_01_MAP_ZONE02 = 0x54A95BC0
    STOP_SP_ARP_HI_INDEX_02_ASIMOVARP_A1 = 0x657B7953
    STOP_SP_ARP_HI_INDEX_03_SUPERMOON_17 = 0xC0DE7CE0
    STOP_SP_ARP_HI_INDEX_04_BLUEPRINT_ARPEMIN_128BPM_3 = 0xAE4D8FAB
    STOP_SP_ARP_HI_INDEX_05_REDPARA_SPACEARP_AMIN_7 = 0x5F7A92B2
    STOP_SP_ARP_HI_INDEX_07_ARPEOTWS_A11 = 0x37B14CD4
    STOP_SP_ARP_HI_INDEX_08_HUSK_7 = 0x4545DC2D
    STOP_SP_ARP_HI_INDEX_09_RIPLEY_12 = 0xCCAC66C8
    STOP_SP_ARP_HI_INDEX_10_ARPTETSUO_B9 = 0x3B73F3F2
    STOP_SP_ARP_HI_INDEX_12_ATWOOD_10 = 0xC93C9B99
    STOP_SP_ARP_HI_INDEX_13_ARPBEYOND_A9 = 0xD3038103
    STOP_SP_ARP_HI_INDEX_14_EOTWSALT_11 = 0x6B902D07
    STOP_SP_ARP_HI_INDEX_15_MACREADY_4 = 0xA55C6A95
    STOP_SP_ARP_HI_INDEX_16_MONOALT_7 = 0x4892E98D
    STOP_WT_DRUMS_INDEX_01_MONOLITH_WANTED_DRUMLOOPS_20 = 0x9DAB5CC
    STOP_WT_DRUMS_INDEX_02_ASIM_DRUMSDIRTY_128BPM_6 = 0x8DEF0354
    STOP_WT_DRUMS_INDEX_03_SM_WANTED_DRUMLOOPS_15 = 0xBD85203A
    STOP_WT_DRUMS_INDEX_04_BLUEPRINT_DRMSGLITCHYBEATS_128BPM_5 = 0xD5DE6FAE
    STOP_WT_DRUMS_INDEX_05_REDPARA_WANTEDDRUMLOOPS_1 = 0xC295CDD1
    STOP_WT_DRUMS_INDEX_06_EV_DRUMLOOPS_138BPM_9 = 0xB42E15D
    STOP_WT_DRUMS_INDEX_07_EOTWS_WANTEDBEATS_1 = 0x19E54EC8
    STOP_WT_DRUMS_INDEX_08_HUSKWANTEDBEATS11 = 0xEA903FC3
    STOP_WT_DRUMS_INDEX_09_RIPLEY_DRUMLOOPS_120BPM_1 = 0x10F5BF
    STOP_WT_DRUMS_INDEX_10_TETSUO_DRUMLOOPS_1 = 0x28264EB3
    STOP_WT_DRUMS_INDEX_11_AKIRAWANTEDBEATS3 = 0x34EAABBF
    STOP_WT_DRUMS_INDEX_12_ATWOOD_WANTEDARPBEATS_24 = 0xCA2352DA
    STOP_WT_DRUMS_INDEX_13_BEYONDTOMORROW1 = 0x89E4122D
    STOP_WT_DRUMS_INDEX_14_EOTWS_WANTEDDRUMS_2 = 0x2F23E907
    STOP_WT_DRUMS_INDEX_15_MAC_DRUMLOOP_5 = 0xAD5677B4
    STOP_WT_DRUMS_INDEX_16_MONOALT_WANTEDLOOPS_8 = 0x86A0D375
    STOP_WT_DRUMS_INDEX_17_APORIA_WANTEDBEATS_2 = 0xDC40C4C8
    STOP_WT_DRUMS_INDEX_18_NMS2017_WANTEDSYNTHBEATS_1 = 0xC65EED56
    STOP_WT_DRUMS_INDEX_19_TUES_WANTEDBEATS4 = 0x650EEF52
    STOP_WT_DRUMS_INDEX_20_TUNG_WANTEDBEATS_3 = 0xB1534DD1
    STOP_WT_DRUMS_INDEX_21_OCT_WANTEDBEATS_1 = 0x772C6BC
    STOP_WT_DRUMS_INDEX_22_VOSTOK_WANTEDDRUMS_2 = 0xD1F2B5C0
    STOP_WT_DRUMS_INDEX_23_ECHO_WANTEDLOOPS_2 = 0xFD2B3514
    STOP_WT_DRUMS_INDEX_24_DOMO_WANTEDDRUMS_3 = 0xC9F1D682
    STOP_WT_DRUMS_INDEX_25_DASHKA_WANTEDBEATS_3 = 0x2090B95E
    STOP_WT_DRUMS_INDEX_26_MELB_WANTEDBEATS_6 = 0xFA930376
    STOP_WT_DRUMS_INDEX_27_OVERSEER_WANTEDDRUMS_6 = 0xD262EB32
    STOP_WT_DRUMS_INDEX_28_SCRAPER_WANTEDBEATS_8 = 0xBB18CA00
    STORMCRYSTAL = 0xB8B92596
    STRIDERATTACK = 0x70596ECC
    STRIDERATTACK2 = 0xA8C96B16
    STRIDERATTACK3 = 0xA8C96B17
    STRIDERROAR = 0x6C9FC7B4
    SUBMARINE_BOOST_START = 0x3227AA1A
    SUBMARINE_BOOST_STOP = 0x865165B2
    SUBMARINE_HORN_START = 0x35490700
    SUBMARINE_HORN_STOP = 0x31E249AC
    SUBMARINE_IDLE_EXTERIOR = 0x68EC56E9
    SUBMARINE_IMPACTS = 0x83505C1F
    SUBMARINE_JUMP = 0x2ACCB55A
    SUBMARINE_START = 0x8B430A02
    SUBMARINE_STOP = 0xFC46C37A
    SUBMARINE_SUBMERGE = 0x74187E58
    SUBMARINE_SURFACE = 0xD10F00A7
    SUBMARINE_SUSPENSION = 0xC8164665
    SUIT_INIT_END = 0x9A042E1
    SUIT_INIT_JETPACK = 0xC3E71CD0
    SUIT_INIT_LIFESUPPORT = 0x307E8019
    SUIT_INIT_SCANNER = 0xE637BC54
    SUIT_INIT_STARTUP = 0x7BE29729
    SUIT_UPGRADE_TERMINAL_INTERACT = 0xF69FA17
    SUIT_UPGRADE_TERMINAL_LP = 0xE5E4EDD9
    SUITBOOT_FINISHED = 0x2FA0AF23
    SUITBOOT_FREIGHTERINTRO_01 = 0x7F32ABF3
    SUITBOOT_FREIGHTERINTRO_02 = 0x7F32ABF0
    SUITBOOT_FREIGHTERINTRO_03 = 0x7F32ABF1
    SUITBOOT_FREIGHTERINTRO_04 = 0x7F32ABF6
    SUITBOOT_FREIGHTERINTRO_05 = 0x7F32ABF7
    SUITBOOT_FREIGHTERINTRO_06 = 0x7F32ABF4
    SUITBOOT_FREIGHTERINTRO_07 = 0x7F32ABF5
    SUITBOOT_INIT = 0x53D1EA23
    SUITBOOT_JETPACK = 0xD03EEDFD
    SUITBOOT_LIFESUPPORT = 0x871648A8
    SUITBOOT_SCANNER = 0xB6C45955
    SUITBOOT_SHIELD = 0x76ED680A
    SUITBOOT_WEAPON = 0x19BC0505
    SUMMONSHIPBEACON_CLOSE = 0x8A5AA3F3
    SUMMONSHIPBEACON_OPEN = 0x96E60D05
    TELEPORT = 0x1F992208
    TELEPORT_ACTIVATED_LOOP = 0xB794E78D
    TELEPORT_END = 0xDDE9F36E
    TELEPORT_LOOP_STOP = 0xDCD2E4FC
    TELEPORT_START = 0x26CB3885
    TENTACLE_IN = 0xD373FFC3
    TENTACLE_LP = 0xCE73F7BE
    TENTACLE_OUT = 0xBB8CBCBE
    TENTPLANT_CLOSE = 0x4248A730
    TENTPLANT_OPEN = 0xEDC2EF44
    TERMINAL_ABANDONED_GROWTH = 0xF753A4AA
    TERMINAL_ABANDONED_GROWTH_CLOSE = 0x403391D3
    TERMINAL_ABANDONED_GROWTH_OPEN = 0x9845265
    TERMINAL_ABANDONED_OPEN = 0x294C2E5B
    TERMINAL_BOOTUP = 0x183AB7F3
    TERMINAL_INDOORS = 0x6138EE88
    TERMINAL_INTERACT = 0x4387FCEE
    TERMINAL_OUTDOORS = 0xC48D4C4B
    TERRAIN_CREATE = 0xA095FDCF
    TERRAIN_DESTROY = 0xD6350E47
    TERRAIN_UNDO = 0x1EEA9A75
    TIMBER_DOOR1_SETTLEMENT_CLOSE = 0x43A6512B
    TIMBER_DOOR1_SETTLEMENT_OPEN = 0x18A8586D
    TIMBER_DOOR2_SETTLEMENT_CLOSE = 0xCD38E81A
    TIMBER_DOOR2_SETTLEMENT_OPEN = 0x66990C1E
    TORCH_OFF = 0x74CB5DB
    TORCH_ON = 0xABE43D67
    TORNADO = 0x9A2BAEE8
    TORNADO_STOP = 0xBAAC64C7
    TREXATTACK = 0x4BDEEBF0
    TREXATTACK2 = 0x5FED6AE2
    TREXATTACK3 = 0x5FED6AE3
    TREXHAPPY = 0x88CF37AE
    TREXPERFORM03 = 0xC8FBA2B8
    TREXROAR = 0xABA96530
    TRIATTACK = 0x5C7D1FC4
    TRIATTACK2 = 0x5CF901BE
    TRIATTACK3 = 0x5CF901BF
    TRIPERFORM01 = 0xF294FEC6
    TRIROAR = 0xD1FE084C
    TURRET_DEPLOY = 0x4DD50ACB
    TURRET_INACTIVE_IDLE = 0x19F5429E
    TURRET_LASER = 0xD1A672EB
    TURRET_LASER_STOP = 0x3EF4C726
    TURRET_RETRACT = 0x823861B5
    TURRET_SHOOT = 0xAC2966DB
    TUT_ELEMENT_TRANSFER_SUCCESS = 0xEEF3B67D
    TXT_RADIONOISE = 0x911C13D3
    TXT_SPECIAL_CHIME = 0x6A37C076
    TXT_STATICNOISE_END = 0xC44B58B8
    TXT_STATICNOISE_START = 0x55C1C063
    UI_ACTION_CONFIRMED = 0x18AECCF6
    UI_ALERT_DAMAGE_WARNING_CRITICAL_LP = 0x9BC95F06
    UI_ALERT_DAMAGE_WARNING_CRITICAL_LP_STOP = 0xE832F3D5
    UI_ALERT_POLICE = 0x8A53362D
    UI_ALIEN_RESPONSE = 0x938DD3E3
    UI_BADGE = 0xD22C90A7
    UI_BARTER_SUCCESS = 0xC3A759FE
    UI_BASEBUILD_CALLFREIGHTER = 0x7E2FF586
    UI_BASEBUILD_CHANGECATEGORY = 0x7F2F183A
    UI_BASEBUILD_CHANGESELECTION = 0xC950BE50
    UI_BASEBUILD_DELETE = 0xB00017EF
    UI_BASEBUILD_INVALIDPOSITION = 0xF1FDD4EA
    UI_BASEBUILD_MENU_CLOSE = 0x7C7C81DE
    UI_BASEBUILD_MENU_OPEN = 0x412ACD7A
    UI_BASEBUILD_PLACEBUILDING = 0x5EB87AEF
    UI_BASEBUILD_REPAIRTECH = 0xAB2C9A05
    UI_BASEBUILD_REPAIRTECH_ERROR = 0xE1303E62
    UI_BASEBUILD_ROTATE = 0xEF9C456B
    UI_BASEBUILD_ROTATE_LOOP_START = 0xED43B465
    UI_BASEBUILD_ROTATE_LOOP_STOP = 0xED2E9987
    UI_BASEBUILD_SETCOLOUR = 0xA55D8932
    UI_BASEBUILD_SNAP = 0x79A35452
    UI_BEACON_DISCOVER = 0x75B9A824
    UI_BIOSHIP_ADDORGAN = 0xF5166DC5
    UI_BLUEPRINT_KNOWN = 0x6D5C3D63
    UI_BUILD_ERROR = 0x75AC6211
    UI_BUY = 0xC18CADCA
    UI_CHOICETEXT_WOOSH = 0x8D7D9943
    UI_CLICK_GENERIC = 0x114B52C4
    UI_COMBAT_UNIT_DEPLOYED_01 = 0x221ADFB2
    UI_COMBAT_UNIT_DEPLOYED_02 = 0x221ADFB1
    UI_COMBAT_UNIT_DEPLOYED_03 = 0x221ADFB0
    UI_COMMUNICATOR_HAIL_ALARM = 0x820AE7EA
    UI_CREDITS_INCREASE = 0x12183687
    UI_CRITICAL_HIT = 0x8D307B3B
    UI_DECISIONTEXT_MOUSEOVER = 0x2986B81F
    UI_DESTINATION_REACHED = 0x6C649E5D
    UI_DISMANTLE = 0x86CF5DA3
    UI_DUMMY_EVENT = 0xD6C96D03
    UI_EPIC_ITEM = 0xFB7EBFED
    UI_ERROR = 0x3C2700B8
    UI_FRIGATE_LIVING_FEED = 0x5679A6D
    UI_FRONTEND_BACK = 0x9E331224
    UI_FRONTEND_ENTER = 0xAA0B552D
    UI_FRONTEND_EXIT = 0xC9410141
    UI_FRONTEND_PRODUCTSBUILD = 0x1C2B169B
    UI_FRONTEND_SELECTGENERIC = 0xD8AF6F74
    UI_FRONTEND_TECHBUILD = 0xCA798E63
    UI_FRONTEND_TEXTOVERLAY_DISCOVERY = 0x185DAFCB
    UI_FRONTEND_TEXTOVERLAY_EMPTY = 0xBC089316
    UI_FRONTEND_TEXTOVERLAY_SUBSTANCE = 0x1240C80B
    UI_FRONTEND_TEXTOVERLAY_TECH = 0x14743037
    UI_FRONTEND_TRANSFER = 0x44713ED8
    UI_GAMEMODE_ERASE_COMPLETE = 0xEDE52A4
    UI_GAMEMODE_ERASE_ERROR = 0x68702A95
    UI_GAMEMODE_HOVER = 0xEE0CC5FE
    UI_GAMEMODE_SELECT = 0x2E8FBD50
    UI_GAMEMODE_WARNING = 0x2FB112AC
    UI_GLITCHED_MEMORY = 0x608D8720
    UI_HEALTH_INCREASE = 0xD2D6DFE3
    UI_INCOMING_FRIGATE_LIVING_WARNING = 0xF9E01984
    UI_INCOMING_MESSAGE = 0x6A39A46E
    UI_INCOMING_NORMANDY_WARNING = 0x1EE13682
    UI_INCOMING_STARSHIP_WARNING = 0xFB031F6
    UI_INSUFFICIENT_FUEL = 0x302A36D2
    UI_INSUFFICIENT_STANDING = 0xC49AAA32
    UI_INSUFFICIENT_TECH_FRAGMENTS = 0x9A0D4494
    UI_INTERACT_TIMER = 0x62988FE
    UI_INTERACT_TIMER_STOP = 0x587C411D
    UI_INTERACTIVEFLORA_COLLECT = 0xCAC28EDB
    UI_ITEM_TELEPORTTOSHIP = 0x8738FC46
    UI_ITEM_TRANSFERTOSUIT = 0x4FDFB677
    UI_JUICYGRUB = 0x9D5ABD74
    UI_KEYBINDING = 0xA541E36
    UI_KNOWLEDGE_EXPANDED = 0x6F259D9A
    UI_LANDINGPOST_LOCKON = 0x3241196A
    UI_LAUNCH_CONFIRMATION = 0xA217EA09
    UI_LAUNCH_NOTIFICATION = 0x2EDEE04B
    UI_LEVEL_UP_TEXT = 0xA22D01BE
    UI_MANAGE_EXOSUIT_INVENTORY = 0xA8202B36
    UI_MAP_ENTRY = 0xA4B39221
    UI_MAP_EXIT = 0xB2526227
    UI_MAP_FILTER_CHANGE = 0x57BB81D0
    UI_MAP_HIGHLIGHT_HOVER = 0xA9310FCE
    UI_MAP_INFO = 0xFA9400A7
    UI_MAP_INTERACT_TIMER = 0x3A90F61B
    UI_MAP_LINES = 0x41EB3474
    UI_MAP_MENUDOWN = 0xAC6E86A6
    UI_MAP_MENUUP = 0x15E6E0CD
    UI_MAP_NAV_MODE_BACK = 0x6C37A7AE
    UI_MAP_NAV_MODE_NEXT = 0x65D24B80
    UI_MAP_NAV_MODE_SWITCH_FAIL = 0x809B54D6
    UI_MAP_NAV_PATH_BACK = 0xA8B966DE
    UI_MAP_NAV_PATH_NEXT = 0x82556BF0
    UI_MAP_PLANET_HOVER = 0x5E11CDF2
    UI_MAP_PLANET_SELECT = 0xC49E774
    UI_MAP_PLANET_UNSELECT = 0x16C9D0D
    UI_MAP_POINT_SELECT = 0x9BFF4F86
    UI_MAP_SELECT = 0x4FA1AADF
    UI_MAP_TEXT = 0x1ADD72A
    UI_MAP_TEXT_OUT = 0xBC076EE7
    UI_MAP_WAYPOINT_ADDED = 0xE4BFD309
    UI_MAP_WAYPOINT_DELETED = 0x13DF9858
    UI_MAP_WAYPOINT_ERROR = 0xBEEBD855
    UI_MARKER = 0x2B07DD4C
    UI_MENU_BUILD_TAB = 0x79CE128A
    UI_MENU_INCORRECT = 0x1F60B11B
    UI_MENU_OPTION_SWITCH = 0xFF2FBCA4
    UI_MESSAGE_GENERIC = 0x3A148ACD
    UI_MISSION_NEWSECONDARY_COMPLETE = 0xD8AFAE1F
    UI_MISSION_NEWSECONDARY_OBJECTIVE = 0x2BAC95E3
    UI_MISSION_NOTIFYSCAN = 0x73345F47
    UI_MISSION_NOTIFYSCAN_END = 0xC46B3C49
    UI_MISSIONPRIMARY_UPDATE = 0xF2CE94C6
    UI_NANITES_INSUFFICIENT = 0x9134500C
    UI_NANITES_RECEIVED = 0xEE872C40
    UI_NEW_DISCOVERY = 0x9F19BAC7
    UI_NEW_SUIT_SLOT = 0x1C7D7573
    UI_NEW_TECH = 0xC0882ABB
    UI_NEWTECH_WOOSH = 0xC814BFB5
    UI_NEXT_MESSAGE = 0x30D44C11
    UI_NOWHERETOLAND = 0xC10CD558
    UI_NPC_SHIP_HIT_ALERT = 0xACC079B1
    UI_NPC_SHIP_INTERACTION = 0x3BAC3D09
    UI_OXYGEN_REPLENISHED = 0xBDCC5A4E
    UI_PAGE_CHANGE = 0xCC61961E
    UI_PHOTOMODE_CAMERAPLACE_END = 0x84F4E2DA
    UI_PHOTOMODE_CAMERAPLACE_START = 0x48E446C9
    UI_PHOTOMODE_IN = 0x3C4C263
    UI_PHOTOMODE_OUT = 0x6AAF1EDE
    UI_PHOTOMODE_TAKEPHOTO = 0xBF99F39
    UI_PHOTOMODE_VALUEDOWN = 0x15D19C71
    UI_PHOTOMODE_VALUEUP = 0x8A6C0E96
    UI_PICKUP_LOOT = 0x5CA94A23
    UI_PICKUP_NITROGENPLANT = 0x65062DDA
    UI_PICKUP_PLANT = 0x6470457C
    UI_PICKUP_RESOURCE = 0xA7CBF529
    UI_PIRATES_WARNING = 0xC9AF9145
    UI_PIRATES_WARNING_STOP = 0xB0E8ACC8
    UI_PLACEMARKER = 0xED754EB1
    UI_PRODUCT_CREATED = 0x7094C6BE
    UI_PROTECTION_OFFLINE = 0xE12D76D3
    UI_PULSEDRIVE_OFFLINE = 0x210BD31B
    UI_PURCHASE = 0x5222F6E7
    UI_QUICKMENU_CLOSE = 0x5A2D907B
    UI_QUICKMENU_NOCHARGE = 0xF7957664
    UI_QUICKMENU_OPEN = 0xFDCE559D
    UI_QUICKMENU_TAB = 0x3AC9E576
    UI_QUICKMENU_TECHCHARGE = 0x3F8067B9
    UI_RARE_ITEM = 0xEB5C5104
    UI_RECORD_UPLOADED = 0xD3A1A28C
    UI_REFINERY_DECREASE = 0x8BA635D9
    UI_REFINERY_INCREASE = 0xA2840089
    UI_RETICULE_LOCK = 0xD2C5A1B9
    UI_RETICULE_ONTARGET = 0xA784CC00
    UI_SAVE = 0x10420AD9
    UI_SCAN_PORTAL = 0xF1AA86CE
    UI_SELECT_GENERIC = 0xAEF4BC9C
    UI_SENTINELDETECTOR = 0xF6022E3C
    UI_SENTINELFORCES_ALERTED = 0xDF61DB92
    UI_SENTINELFORCES_DEACTIVATED = 0x56D6F15
    UI_SENTINELINVESTIGATORS_INCOMING = 0x49D6DFF3
    UI_SERVER_FOUND = 0xF00BB46A
    UI_SERVER_SCANDISCOVERIES = 0xECE09C45
    UI_SERVER_SEARCHING_START = 0x502FCE43
    UI_SERVER_SELECT = 0x4FC49B2E
    UI_SERVER_SELECT_POPUP = 0x6D1A2065
    UI_SETTLEMENT_BUILDINGCOMPLETE = 0xB72E6ADF
    UI_SETTLEMENT_DECISION = 0xED34CBC8
    UI_SETTLEMENT_FLOORCOMPLETE = 0xD4E70FC1
    UI_SETTLEMENT_INVEST = 0x1C799E89
    UI_SHIP_CUSTOMISATION_ASSEMBLE = 0x8DA65690
    UI_SHIP_CUSTOMISATION_CHANGE_SHIP = 0xA93A6CB5
    UI_SHIP_CUSTOMISATION_REMOVE = 0xEB26F228
    UI_SHIP_CUSTOMISATION_SELECT = 0x7F015D48
    UI_SHOP_ITEMS_MENU = 0x6192287
    UI_SHOP_SCROLL_DOWN = 0x874F66BD
    UI_SHOP_SCROLL_UP = 0x77487C8A
    UI_SHOP_SWITCH_BUYSELL = 0xEF95C71C
    UI_SHOP_SWITCH_INVENTORY = 0xD1746824
    UI_SLEEP = 0x71F138DB
    UI_SPECIALS_INSUFFICIENT = 0xD05421AC
    UI_SPOOKYMESSAGE = 0x7A28995E
    UI_STANDING_DECREASED = 0xC781ADCF
    UI_STANDING_INCREASED = 0x4D5E4C1F
    UI_STAT_CHANGE = 0xBE30492B
    UI_TARGET_ONSCREEN = 0x9C212C4F
    UI_TECH_BROKEN = 0x7F1E1E22
    UI_TECH_INSTALLED = 0x748BD54D
    UI_TERRAIN_CHANGESIZE = 0xF4C6C733
    UI_TEXT_WOOSH = 0x990CE3CE
    UI_TEXTENTRY = 0xEE38EFB9
    UI_TIP = 0xE15FC005
    UI_TRADING_MESSAGE = 0xB002EB0D
    UI_TRADING_TEXT = 0x7015F9ED
    UI_TRADING_TEXT_ONESHOT = 0xA1F6BCE4
    UI_TRADING_TEXT_STOP = 0xE3C5B820
    UI_TRADING_TEXT_TRANSLATE = 0x4022E06A
    UI_UNITS_RECEIVED = 0x898CD56B
    UI_VEGETABLE_COLLECT = 0xFC94B9A4
    UI_VR_HANDMENU_CLOSE = 0x364CF0A6
    UI_VR_HANDMENU_HIGHLIGHT = 0xE672686E
    UI_VR_HANDMENU_OPEN = 0x112C18F2
    UI_VR_HANDMENU_OPENLP = 0xD0DCFE1E
    UI_VR_WRISTMENU_HIGHLIGHT = 0xB1E07F62
    UI_VR_WRISTMENU_IN = 0xFC42EEA7
    UI_VR_WRISTMENU_OUT = 0xDD62551A
    UI_VR_WRISTMENU_SELECT = 0x52EBA056
    UI_VR_WRISTMENU_TOUCH = 0x9C3C5AF
    UI_WAKEUP = 0x57610D41
    UI_WANTED_INCREASE = 0x80BA51BA
    UI_WANTED_INCREASE_01 = 0x98402038
    UI_WANTED_INCREASE_02 = 0x9840203B
    UI_WANTED_INCREASE_03 = 0x9840203A
    UI_WANTED_INCREASE_04 = 0x9840203D
    UI_WANTED_INCREASE_05 = 0x9840203C
    UI_WEAPON_FOUND = 0x4DBA89E7
    UI_WEIRDBIOME_COUNTDOWN = 0x4A2D6533
    UI_WEIRDBIOME_COUNTDOWN_END = 0x4A1515D5
    UI_WHALESONG = 0xFDC0FA36
    UI_WORD_LEARNT = 0xA3561BAF
    UI_WPN_LOCKON = 0x9F4B5814
    UI_WPN_RETICULE_LOCK = 0x9E114361
    UI_WPN_TARGET_FOCUS = 0xF4A8A5B0
    UNDERWATER_STEAMVENT_RUMBLE = 0xC54EB9A6
    UNDERWATER_STEAMVENT_VENTING = 0xB67C3BF4
    UNDERWATER_STEAMVENT_VENTING_END = 0x6B30806A
    VAULT_CLOSE = 0x8D7D844A
    VAULT_OPEN = 0x5AE8C76E
    VEHICLE_DESTRUCTIBLE = 0x61DED67C
    VEHICLE_MARKER_COLLECT = 0xCC0C57CF
    VEHICLE_MARKER_DELETE = 0xB7B05DC2
    VEHICLE_MARKER_PLACE = 0x46C78620
    VEHICLE_RACE_END = 0x916A2903
    VEHICLE_RACE_START = 0xB3AF6D8
    VEHICLE_SPAWN = 0x5B82CC5F
    VENUSFLYTRAP_CLOSE = 0x722B8CBB
    VENUSFLYTRAP_OPEN = 0xC33559DD
    VIEW_FIRSTPERSON = 0x87AD2FC2
    VIEW_THIRDPERSON = 0x72BDEFFF
    VILESPAWN_EGG_COLLECT = 0xDB837279
    VILESPAWN_LP = 0xAC9C927F
    VILESPAWN_LP_STOP = 0x5DCB9CCA
    VO_ANOMALYDETECTED = 0xFB08E100
    VO_BASECOMPUTER_ONLINE = 0xA8C4CF0F
    VO_INVENTORY_FULL = 0x1B7EE4FB
    VO_PRODUCT_CONSTRUCTED = 0x50544311
    VO_SECURE_TRADEMODULE_LOCATED = 0x97980A7C
    VO_SECURE_TRANSMISSIONMODULE_LOCATED = 0xD9F965C8
    VO_STARSHIP_SIGNAL = 0x41EB6874
    VO_TECH_COMP_REPAIRED = 0xC1C549DE
    VO_TECH_INSTALLED = 0xF1E0AD04
    VO_TECH_OFFLINE = 0x301397AB
    VO_TECH_RECHARGED = 0x20A524C7
    VO_TECH_REPAIRED = 0xD718EFE6
    VO_TUT_COORDSRECEIVED = 0xA023F16A
    VO_TUT_STATIONCOORDSRECEIVED = 0x5B74DAC
    VR_FOLEY_ARM_MOVEMENTS = 0xFAE20B59
    VR_FOLEY_ARM_MOVEMENTS_LEFT = 0xDB88808F
    VR_FOLEY_ARM_MOVEMENTS_RIGHT = 0x84729F52
    VR_FOLEY_ARMS_WOOSH = 0x3FAF1A30
    VR_FOLEY_HAND_CLENCH_CLOSE = 0x1CA287DE
    VR_FOLEY_HAND_CLENCH_OPEN = 0xF9C86F7A
    VR_PULLTOUSE = 0x6A454EC3
    VR_PULLTOUSE_STOP = 0x324C4A2E
    VR_TELEPORTMOVE = 0xAFFEF3EA
    VR_THEREMIN = 0xC7432116
    WALKER_CHARGEUP = 0xB8A1D0D9
    WALKER_DIE = 0xAE8BE068
    WALKER_EMOTE_LP = 0x2AE78935
    WALKER_EMOTE_LP_STOP = 0xE77997D8
    WALKER_ENRAGE = 0xBB04EB24
    WALKER_FALL_IMPACT = 0x2A1F88A2
    WALKER_IDLE = 0xB2C7FAE0
    WALKER_LASER = 0xA8AC2E4F
    WALKER_LASER_STOP = 0xCCF69C7A
    WALKER_LEG_HIT_IDLE = 0x891868C1
    WALKER_LEG_HIT_LEFT_IN_01 = 0xC8452F0
    WALKER_LEG_HIT_LEFT_IN_02 = 0xC8452F3
    WALKER_LEG_HIT_LEFT_OUT_01 = 0x7F48B349
    WALKER_LEG_HIT_LEFT_OUT_02 = 0x7F48B34A
    WALKER_LEG_HIT_RIGHT_IN_01 = 0xDB3B90BF
    WALKER_LEG_HIT_RIGHT_IN_02 = 0xDB3B90BC
    WALKER_LEG_HIT_RIGHT_OUT_01 = 0xB0B8D754
    WALKER_LEG_HIT_RIGHT_OUT_02 = 0xB0B8D757
    WALKER_MOVE = 0x121B6AD1
    WALKER_SIT = 0xAE6B8C16
    WALKER_SQUAWKER = 0xB8DD2DCB
    WALKER_STAND = 0xC4C8E4FE
    WALKER_STEP = 0xB63357EC
    WALKINGBUILDING_AMBIENT_LP = 0x7F4B47C2
    WALKINGBUILDING_ATTACK = 0xE2981965
    WALKINGBUILDING_AWAKEN = 0x839CB70C
    WALKINGBUILDING_EVADE = 0xE7E0FD10
    WALKINGBUILDING_MOVE_SMALL = 0x44453B36
    WALKINGBUILDING_POUNCE = 0x33700AF
    WALKINGBUILDING_POUNCE_BACK = 0x1B4E6F97
    WALKINGBUILDING_STUNNED = 0x22567F4A
    WARN_CIVILIANSHIELDS = 0xBBF796CB
    WARN_DISTRESS_DETECTED = 0x64B78982
    WARN_HOSTILE_APPROACH = 0x41DD6191
    WARN_HOSTILE_DETECTED = 0x4BE3C41F
    WARN_HOSTILE_SCAN = 0x15472E9E
    WARRIORANGRY = 0x8489D2FC
    WARRIORCHATTER = 0xF6BE1370
    WARRIORGREET1 = 0xEDB7C38D
    WARRIORGREET2 = 0xEDB7C38E
    WARRIORGREET3 = 0xEDB7C38F
    WARRIORHAPPY01 = 0x3DEECF18
    WARRIORHAPPY02 = 0x3DEECF1B
    WARRIORHAPPY03 = 0x3DEECF1A
    WARRIORHONOUR = 0xDC70021E
    WATERFALL = 0x7BA60439
    WEAPONTECHSTATION_IN = 0x9D11B593
    WEAPONTECHSTATION_OUT = 0xCED353AE
    WEATHER_OVER = 0xF6B6BE20
    WEATHER_WARN = 0xDBD65A16
    WEIRDBEAMSTONE = 0x2F81A4D0
    WEIRDBEAMSTONE_STOP = 0xFB01B69F
    WEIRDBUBBLE = 0x99F5D6EE
    WEIRDBUBBLE_STOP = 0x40235AED
    WEIRDCONTOUR = 0x21ADDAD6
    WEIRDFLOAT_LP = 0xFAD2C455
    WEIRDFLOAT_STOP = 0xA3CC4851
    WEIRDOFRACTCUBE = 0x79920C4A
    WEIRDROLL_LP = 0x2E855EEC
    WEIRDROLL_STOP = 0x1AD9EA60
    WEIRDSHARDS = 0xF151439F
    WEIRDWIRECELL = 0xC5896FBB
    WINGFLAP = 0x13E172E1
    WOOSH_DROID_SMALL_01_FRONT = 0x11BC8ADA
    WOOSH_DROID_SMALL_01_MID = 0xCF0FF131
    WOOSH_DROID_SMALL_01_REAR = 0xEA2BF77F
    WPN_BROKEN = 0xA5FE3EFA
    WPN_GROUND_SIZZLE = 0x4222F8E2
    WPN_MELEE_IMPACT_CREATURE = 0xA2108648
    WPN_MELEE_IMPACT_GENERIC = 0xCB00CD9E
    WPN_NOAMMO = 0x139F02B6
    WPN_NOTECHTOOL = 0xD9985CA2
    WPN_NOTOOL = 0xBDA317B2
    WPN_PL_CHANGE = 0xB7746754
    WPN_PL_DEPLETED = 0xF90065F9
    WPN_PL_GRENADE = 0xF099543E
    WPN_PL_GRENADE_BOUNCE = 0xCD5D244D
    WPN_PL_GRENADE_EXPLODE = 0x183BF870
    WPN_PL_HANDLASER = 0xBEDA84FC
    WPN_PL_HANDLASER_OVERHEAT = 0xD348E403
    WPN_PL_HANDLASER_STOP = 0x82A0A48B
    WPN_PL_JAVELIN_CHARGE = 0xF04467B0
    WPN_PL_JAVELIN_CHARGE_END = 0xB6B9D056
    WPN_PL_MELEE = 0x8FC09CD8
    WPN_PL_NEUTRON_CANNON_BUILDUP = 0xD02F55E1
    WPN_PL_NEUTRON_CANNON_CHARGE_END = 0x6CF3B5E8
    WPN_PL_NEUTRON_CANNON_FIRE = 0x93C21A7E
    WPN_PL_NEUTRON_CANNON_FIRE_CHARGED = 0x8238361B
    WPN_PL_NEUTRON_CANNON_LP = 0xBEB6F46E
    WPN_PL_OUTOFAMMO_GUN = 0xB3D2327A
    WPN_PL_PISTOL = 0xC3B24F39
    WPN_PL_PISTOL_RELOAD = 0xEA835E0B
    WPN_PL_PUTAWAY = 0x8C2DCD79
    WPN_PL_RAILGUN = 0xEDBB26D2
    WPN_PL_RAILGUN_PATHFINDER = 0x709D11EC
    WPN_PL_RAILGUN_RELOAD = 0xCE68FDE6
    WPN_PL_SCAN = 0x9E35101F
    WPN_PL_SCAN_STOP = 0xE8E06EAA
    WPN_PL_SCATTERBLASTER = 0xC4F25AF5
    WPN_PL_SHOTGUN = 0x128E00C2
    WPN_PL_SHOTGUN_PATHFINDER = 0x381A3A7C
    WPN_PL_SHOTGUN_RELOAD = 0xA0D247B6
    WPN_PL_SMG = 0x3E5AE267
    WPN_PL_TAKEOUT = 0x5CE8E2AB
    WPN_SHIP_CHANGE = 0x5A129B56
    WPN_SHIP_CYCLOTRON_FIRE = 0x7611E876
    WPN_SHIP_CYCLOTRON_OVERHEAT = 0x42DE8842
    WPN_SHIP_GUN = 0x1AAC86AC
    WPN_SHIP_INFRAKNIFE_FIRE = 0xFA63876
    WPN_SHIP_INFRAKNIFE_OVERHEAT = 0xB567D842
    WPN_SHIP_LASER = 0x58B37AEF
    WPN_SHIP_LASER_STOP = 0x40FBA3DA
    WPN_SHIP_MISSILE_OVERHEAT = 0xD49513E9
    WPN_SHIP_OUTOFAMMO = 0xEDB8EC03
    WPN_SHIP_OVERHEAT = 0xBDEC12CA
    WPN_SHIP_POSITRON_FIRE = 0xE9733AD7
    WPN_SHIP_POSITRON_OVERHEAT = 0x8FDEE823
    WPN_SHIP_READY = 0xFE1BE6F7
    WPN_TERRAIN_BUILD = 0xBB4541A9
    WPN_TERRAIN_BUILD_END = 0x2BDF7F4B
    WPN_TERRAIN_DESTROY = 0x8487F81F
    WPN_TERRAIN_DESTROY_END = 0xC4E8D681
    WPN_TERRAIN_END = 0x33B1CD16
    WPN_TERRAIN_UNDO = 0x89B7D91D


class eStormState(IntEnum):
    Inactive = 0x0
    Warning = 0x1
    TransitionIn = 0x2
    Active = 0x3
    TransitionOut = 0x4


class GcBiomeType(IntEnum):
    Lush = 0x0
    Toxic = 0x1
    Scorched = 0x2
    Radioactive = 0x3
    Frozen = 0x4
    Barren = 0x5
    Dead = 0x6
    Weird = 0x7
    Red = 0x8
    Green = 0x9
    Blue = 0xA
    Test = 0xB
    Swamp = 0xC
    Lava = 0xD
    Waterworld = 0xE
    GasGiant = 0xF
    All = 0x10
